import 'package:sixam_mart/data/api/api_checker.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../data/model/response/PrimeMembersModel2.dart';
import '../data/repository/change_client_repo.dart';

class ChangeClientController extends GetxController implements GetxService {
  final ChangeClientRepo repo;
  ChangeClientController({@required this.repo});

  List<Members> _primeMembersList;
  List<Members> _searchItemList = [];
  int _offset = 10;
  bool _isLoading = false;
  bool _isSearchMode = true;
  bool _isSearching = false;

  String _searchText = '';



  List<Members> get searchItemList => _searchItemList;
  List<Members> get primeMembersList => _primeMembersList;
  bool get isSearchMode => _isSearchMode;
  int get offset => _offset;

  bool get isLoading => _isLoading;
  bool get isSearching => _isSearching;
  String get searchText => _searchText;



  void searchData(String query) async {
    if(query.isNotEmpty) {
      _searchText = query;
      _searchItemList = null;
      _isSearching = true;
      update();

      Response response = await repo.getSearchData(query);
      if (response.statusCode == 200) {
        if (query.isEmpty) {
          _searchItemList = [];
        } else {
            _searchItemList = [];
            _searchItemList.addAll(PrimeMembersModel.fromJson(response.body).members);

        }
      } else {
        ApiChecker.checkApi(response);
      }
      update();
    }
  }

  void toggleSearch() {
    _isSearching = !_isSearching;
    _searchItemList = [];

    if(_primeMembersList != null) {
      _searchItemList.addAll(_primeMembersList);
    }

    update();
  }

  void showBottomLoader() {
    _isLoading = true;
    update();
  }
  void setSearchMode(bool isSearchMode) {
    _isSearchMode = isSearchMode;
    if(isSearchMode) {
      _searchText = '';
      _searchItemList = null;
    }
    update();
  }
}
