import 'dart:typed_data';
import 'package:image_picker/image_picker.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/response_model.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../data/api/api_checker.dart';
import '../data/model/response/FamilyMemberListResponseData.dart';
import '../data/model/response/PrimeMembersModel2.dart';
import '../data/model/response/PrimePaymentTrackResppnse.dart';
import '../data/model/response/prime_member_create_update_response.dart';
import '../data/model/response/prime_member_detail_model.dart';
import '../data/model/response/prime_search_response.dart';
import '../data/model/response/share_link_list_response.dart';
import '../data/model/response/state_city_and_relation.dart';
import '../data/model/response/users_prime_members_response.dart';
import '../data/repository/prime_member_repo.dart';
import '../helper/network_info.dart';
import '../helper/route_helper.dart';
import '../util/app_constants.dart';
import '../view/base/custom_snackbar.dart';

class PrimeMemberController extends GetxController implements GetxService {
  final PrimeMemberRepo primeMemberRepo;
  PrimeMemberController({@required this.primeMemberRepo});

  bool _isDigitalSelected = false;
  bool _isListViewSelected = false;
  bool _isGridViewSelected = false;
  bool _isUpiSelected = false;
  bool _isQrSelected = false;
  bool _isWalletSelected = false;
  bool _upiScreenshotSubmitted = false;
  bool _isPersonalDetailsUploading = false;
  bool _isReferenceSubmitted = false;
  bool _isPersonalDetailsSubmitted = false;
  bool _isUsersPrimeMembersLoading = false;
  bool _isLoading = false;
  bool _isAddFamilyLoading = false;
  bool _isSharedLinkDetailsLoading = false;
  bool _isPrimeMembershipOrderIdLoading = false;
  bool _isFormCompleted = false;
  bool _isPrimeMemberDetailLoading = false;
  bool _isUserImageLoading = false;
  bool _isAadharImageLoading = false;
  bool _isAadharBackImageLoading = false;
  bool _isNomineeAadharImageLoading = false;
  bool _isNomineeAadharBackImageLoading = false;
  bool _isPanImageLoading = false;
  bool _isNomineePanImageLoading = false;
  bool _isUpiScreenshotImageLoading = false;
  bool _notification = true;
  bool _isBothAccountNumberMatched = false;
  bool _isPaymentSuccessful = false;
  bool _isPaymentFailed = false;
  bool _acceptTerms = true;
  bool _goingToSearchClicked = false;
  OneStateAllCity _stateDropdownValue ;
  String _relationDropdownValue ;
  City _cityDropdownValue ;
  PrimeMemberDetailData _primeMemberDetailData ;
  PrimeSearchMember _referenceDropdownValue ;
  String _upiOptionDropdownValue ;
  String _upiNumberDropdownValue ;
  int _paymentMethodIndex = 0;
  int _selectedIndexOnMap = 0;
  XFile _pickedUserImageFile;
  Uint8List _rawUserImageFile;
  List<OneStateAllCity> _stateCityList;
  PrimePaymentTrackResponse _primePaymentTrackResponse;
  List<FamilyMemberData> _familyMembersList;
  List<FamilyMemberData> _familyMembersListForMap;
  List<Members> _primeMembersList;
  List<PrimeSearchMember> _searchedPrimeMembersList;
  List<UsersPrimeMember> _usersPrimeMembersList;
  List<SharedLinkDetails> _sharedLinkDetails;
  List<City> _cityList;
  TextEditingController _cityController;
  List<String> _relationList;

  XFile _pickedAadharImageFile;
  XFile _pickedAadharBackImageFile;

  Uint8List _rawAadharImageFile;
  Uint8List _rawAadharBackImageFile;

  XFile _pickedNomineeAadharImageFile;
  Uint8List _rawNomineeAadharImageFile;

  XFile _pickedNomineeAadharBackImageFile;
  Uint8List _rawNomineeAadharBackImageFile;

  XFile _pickedNomineePanImageFile;
  Uint8List _rawNomineePanImageFile;


  XFile _pickedPanImageFile;
  Uint8List _rawPanImageFile;
  String _searchText = '';
  bool _isSearchMode = true;
  bool _isSendButtonActive = false;
  XFile _pickedUpiScreenshotImageFile;
  Uint8List _rawUpiScreenshotImageFile;

  List<XFile> _pickedIdentities = [];

  int get paymentMethodIndex => _paymentMethodIndex;
  int get selectedIndexOnMap => _selectedIndexOnMap;
  //
  String get searchText => _searchText;
  bool get isSearchMode => _isSearchMode;
  bool get isListViewSelected => _isListViewSelected;
  bool get isGridViewSelected => _isGridViewSelected;
  PrimePaymentTrackResponse get primePaymentTrackResponse => _primePaymentTrackResponse;
  TextEditingController get cityController => _cityController;
  List<FamilyMemberData> get familyMembersList => _familyMembersList;
  List<FamilyMemberData> get familyMembersListForMap => _familyMembersListForMap;
  PrimeMemberDetailData get primeMemberDetailData => _primeMemberDetailData;
  List<City> get cityList => _cityList;
  List<String> get relationList => _relationList;
  List<OneStateAllCity> get stateCityList => _stateCityList;
  OneStateAllCity get stateDropdownValue => _stateDropdownValue;
  List<Members> get primeMembersList => _primeMembersList;
  List<PrimeSearchMember> get searchedPrimeMembersList => _searchedPrimeMembersList;
  List<UsersPrimeMember> get usersPrimeMembersList => _usersPrimeMembersList;
  List<SharedLinkDetails> get sharedLinkDetails => _sharedLinkDetails;
  String get relationDropdownValue => _relationDropdownValue;
  PrimeSearchMember get referenceDropdownValue => _referenceDropdownValue;
  String get upiOptionDropdownValue => _upiOptionDropdownValue;
  String get upiNumberDropdownValue => _upiNumberDropdownValue;
  City get cityDropdownValue => _cityDropdownValue;
  bool get isDigitalSelected => _isDigitalSelected;
  bool get isPaymentSuccessful => _isPaymentSuccessful;
  bool get isSendButtonActive => _isSendButtonActive;
  bool get isPaymentFailed => _isPaymentFailed;
  bool get isUpiSelected => _isUpiSelected;
  bool get isQrSelected => _isQrSelected;
  bool get isWalletSelected => _isWalletSelected;
  bool get upiScreenshotSubmitted => _upiScreenshotSubmitted;
  bool get goingToSearchClicked => _goingToSearchClicked;

  bool get isBothAccountNumberMatched => _isBothAccountNumberMatched;
  bool get isPrimeMemberDetailLoading => _isPrimeMemberDetailLoading;
  bool get isFormCompleted => _isFormCompleted;
  bool get isLoading => _isLoading;
  bool get isAddFamilyLoading => _isAddFamilyLoading;
  bool get isUsersPrimeMembersLoading => _isUsersPrimeMembersLoading;
  bool get isSharedLinkDetailsLoading => _isSharedLinkDetailsLoading;
  bool get isPrimeMembershipOrderIdLoading => _isPrimeMembershipOrderIdLoading;
  bool get isReferenceSubmitted => _isReferenceSubmitted;
  bool get isPersonalDetailsSubmitted => _isPersonalDetailsSubmitted;
  bool get isPersonalDetailsUploading => _isPersonalDetailsUploading;
  bool get isUserImageLoading => _isUserImageLoading;
  bool get isAadharImageLoading => _isAadharImageLoading;
  bool get isAadharBackImageLoading => _isAadharBackImageLoading;
  bool get isNomineeAadharImageLoading => _isNomineeAadharImageLoading;
  bool get isNomineeAadharBackImageLoading => _isNomineeAadharBackImageLoading;
  bool get isNomineePanImageLoading => _isNomineePanImageLoading;
  bool get isUpiScreenshotImageLoading => _isUpiScreenshotImageLoading;
  bool get isPanImageLoading => _isPanImageLoading;
  bool get notification => _notification;
  bool get acceptTerms => _acceptTerms;
  XFile get pickedUserImageFile => _pickedUserImageFile;
  Uint8List get rawUserImageFile => _rawUserImageFile;

  XFile get pickedAadharImageFile => _pickedAadharImageFile;
  Uint8List get rawAadharImageFile => _rawAadharImageFile;

  XFile get pickedAadharBackImageFile => _pickedAadharBackImageFile;
  Uint8List get rawAadharBackImageFile => _rawAadharBackImageFile;

  XFile get pickedPanImageFile => _pickedPanImageFile;
  Uint8List get rawPanImageFile => _rawPanImageFile;

  XFile get pickedUpiScreenshotImageFile => _pickedUpiScreenshotImageFile;
  Uint8List get rawUpiScreenshotImageFile => _rawUpiScreenshotImageFile;


  XFile get pickedNomineeAadharImageFile => _pickedNomineeAadharImageFile;
  Uint8List get rawNomineeAadharImageFile => _rawNomineeAadharImageFile;

  XFile get pickedNomineeAadharBackImageFile => _pickedNomineeAadharBackImageFile;
  Uint8List get rawNomineeAadharBackImageFile => _rawNomineeAadharBackImageFile;


  XFile get pickedNomineePanImageFile => _pickedNomineePanImageFile;
  Uint8List get rawNomineePanImageFile => _rawNomineePanImageFile;


  List<XFile> get pickedIdentities => _pickedIdentities;


  void setSearchText(String text) {
    _isSearchMode = true;
    _searchText = text;
    update();
  }
  void toggleSendButtonActivity() {
    _isSendButtonActive = !_isSendButtonActive;
    update();
  }
  void setListView() {
    _isGridViewSelected = false;
    _isListViewSelected = true;
    update();
  }
  void setGridView() {
    _isGridViewSelected = true;
    _isListViewSelected = false;
    update();
  }
  void setGoingToSearch(bool value) {
    _goingToSearchClicked = value;
    update();
  }
  Future<void> getOrderIdForPrimeMembership(String mode,String userId, Function(bool isSuccess, String message, String orderID) callback) async {

    // callback(true, "", userId);
    _isPrimeMembershipOrderIdLoading = true;
    update();

    Response response = await primeMemberRepo.getOrderIdForPrimeMembership(userId);
    _isPrimeMembershipOrderIdLoading = false;
    if (response.statusCode == 200) {

      String orderID = response.body['order_id'].toString();
      if(mode=='wallet'){

        Get.toNamed(RouteHelper.getPrimePaymentFromWalletRoute(orderID));
      }else  if(mode=='upi' || mode=='qrCode'){

        Get.toNamed(RouteHelper.getPrimePaymentManuallyRoute(orderID,mode,"membership"));
      }else{
        callback(true, "", orderID);
      }


      print('--------Prime Membership Order id return successfully $orderID ----------');
    } else {
      callback(false, response.statusText, '-1');
    }

    update();
  }

  Future<void> trackPrimeOrder( String orderID ) async {

    _primePaymentTrackResponse=null;
    _isLoading = true;
    update();

    Response response = await primeMemberRepo.trackPrimeOrder(orderID);
    _isLoading = false;
    if (response.statusCode == 200) {
      _primePaymentTrackResponse = PrimePaymentTrackResponse.fromJson(response.body);
    }
    update();
  }

  void getUsersPrimeMembersList() async {
    _usersPrimeMembersList = null;
    _isUsersPrimeMembersLoading =true;
    Response response = await primeMemberRepo.getUsersPrimaryMembersList(0,10);
    if (response.statusCode == 200) {

      if(UsersPrimeMembersResponse.fromJson(response.body).members.isNotEmpty){
        _usersPrimeMembersList = [];

        _usersPrimeMembersList.addAll(UsersPrimeMembersResponse.fromJson(response.body).members);
      }

    } else {
      ApiChecker.checkApi(response);
    }
    _isUsersPrimeMembersLoading = false;
    update();
  }
  void getPrimeMembersList(bool forDropdown) async {
    _primeMembersList = null;
    _isLoading =true;
    update();
    Response response = await primeMemberRepo.getPrimaryMembersList(0,10);
    if (response.statusCode == 200) {


      if(PrimeMembersModel.fromJson(response.body).members.isNotEmpty){
        _primeMembersList = [];
        if(forDropdown){
          _primeMembersList.insert(0, Members(
            id: -1,
            fName: "Select Reference",
            lName: "",
            image: "",
            phone: "",
          ));
        }

        _primeMembersList.addAll(PrimeMembersModel.fromJson(response.body).members);
      }


    } else {
      ApiChecker.checkApi(response);
    }
    _isLoading = false;
    update();
  }
  void setSearchMode() {
    _isSearchMode = false;
    _searchText = '';
    _searchedPrimeMembersList = null;
    update();
  }
  void setSelectedIndexOnMap(int index) {
    _selectedIndexOnMap=index;
    update();
  }
  void getSearchData(String queryText) async {
    setSearchText(queryText);
    _searchedPrimeMembersList = null;
    _isLoading =true;
    update();
    Response response = await primeMemberRepo.getSearchData(queryText);
    if (response.statusCode == 200) {

      if(PrimeSearchResponse.fromJson(response.body).members.isNotEmpty){
        _searchedPrimeMembersList = [];
        _searchedPrimeMembersList.addAll(PrimeSearchResponse.fromJson(response.body).members);

        //_searchedPrimeMembersList.reversed;
      }else{
        showCustomSnackBar('not_found'.tr);

      }


    } else {
      ApiChecker.checkApi(response);
    }
    _isLoading = false;
    update();
  }


  void getSharedLinkList() async {
    _sharedLinkDetails = null;
    _isSharedLinkDetailsLoading =true;
    Response response = await primeMemberRepo.getSharedLinkList();
    if (response.statusCode == 200) {


      if(ShareLinkListResponse.fromJson(response.body).sharedLinkDetails.isNotEmpty){
        _sharedLinkDetails = [];
        _sharedLinkDetails.addAll(ShareLinkListResponse.fromJson(response.body).sharedLinkDetails);
      }


    } else {
      ApiChecker.checkApi(response);
    }
    _isSharedLinkDetailsLoading = false;
    update();
  }

  Future<ResponseModel> familyMemberDelete(String memberId ,int index) async {
    _isLoading = true;
    update();
    Response response;
    response = await primeMemberRepo.familyMemberDelete("${AppConstants.PRIME_FAMILY_MEMBER_URI}$memberId/delete");


    ResponseModel responseModel;

    if (response.statusCode == 200) {

      responseModel = ResponseModel(true, '${response.body['message']}');
      showCustomSnackBar(response.body['message'],isError: false);
      getFamilyMembersListData();
    } else {
      responseModel = ResponseModel(false, response.statusText);
    }
    _isLoading = false;
    update();
    return responseModel;
  }
  Future<ResponseModel> familyMemberCreateUpdate(String aadharCard,String mobile, String name,String relationship,String memberId) async {
    _isAddFamilyLoading = true;
    update();
    Response response;
    if(memberId==null){
      response = await primeMemberRepo.familyMemberCreateUpdate(
          aadharCard,
          mobile,
          name,
           relationship,
          "${AppConstants.PRIME_FAMILY_MEMBER_URI}store",
          _pickedAadharImageFile
          ,_pickedUserImageFile);

    }else{
      response = await primeMemberRepo.familyMemberCreateUpdate(
          aadharCard,
          mobile,
          name, relationship,"${AppConstants.PRIME_FAMILY_MEMBER_URI}$memberId/update",_pickedAadharImageFile,_pickedUserImageFile);


    }

    ResponseModel responseModel;

    if (response.statusCode == 200) {

      responseModel = ResponseModel(true, '${response.body['message']}');
    } else {
      responseModel = ResponseModel(false, response.statusText);
    }
    _isAddFamilyLoading = false;
    update();
    return responseModel;
  }

  void getFamilyMembersListData() async {

    _isLoading=true;
    _familyMembersList=null;
    _familyMembersListForMap=null;
    _selectedIndexOnMap=-1;

    Response response = await primeMemberRepo.getFamilyMemberList();
    _familyMembersList=[];
    _familyMembersListForMap=[];


    if (response.statusCode == 200) {

      FamilyMemberListResponseData responseData = FamilyMemberListResponseData.fromJson(response.body);

      _familyMembersList.addAll(responseData.data);
      // update();


      if(_familyMembersList!=null && _familyMembersList.isNotEmpty){
        for(int index=0; index<_familyMembersList.length; index++) {
          if(_familyMembersList[index].trackLastLocation!=null) {
            _familyMembersListForMap.add(_familyMembersList[index]);
          }
        }
      }
      // update();
      print("getFamilyMembersListData  ${_familyMembersList.length}");
      print("getFamilyMembersListData 2 ${_familyMembersListForMap.length}");
    }
    _isLoading=false;
    update();

  }


  void getPrimeMemberDetail() async {
    _primeMemberDetailData=null;
    _isPrimeMemberDetailLoading=true;

    Response response = await primeMemberRepo.getPrimeMemberDetail();

    if (response.statusCode == 200) {


      PrimeMemberDetailModel resModel = PrimeMemberDetailModel.fromJson(response.body);

      if(resModel.data.isNotEmpty){
        _primeMemberDetailData = resModel.data[0];

        _isFormCompleted=resModel.is_form_completed;
        if(_primeMemberDetailData.parentId!=null){
          _referenceDropdownValue=PrimeSearchMember(id: _primeMemberDetailData.parentId,name: _primeMemberDetailData.parentName.toString());

          print("_primeMemberDetailData_name ${_primeMemberDetailData.parentName.toString()}");
        }
      }
    }
    _isPrimeMemberDetailLoading=false;
    update();
  }

  void getStateCityAndRelationData(String title) async {
    _relationList=null;

    Response response = await primeMemberRepo.getStateCityAndRelationData();

    if (response.statusCode == 200) {
      _relationList=[];

      StateCityAndRelation resModel = StateCityAndRelation.fromJson(response.body);


      _relationList.insert(0, title==''?"Select Nominee Relation":title);
      _relationList.addAll(resModel.selectRelation);


      update();
      if(_stateCityList==null){
        _stateCityList=[];
        _stateCityList.insert(0, OneStateAllCity(state: "Select State",city: []));
        _stateCityList.addAll(resModel.oneStateAllCity);
        update();
      }

      print("getStateCityAndRelationData  _relationList size =  ${_relationList.length}");

      update();
    }


  }
  void paymentMethodSelected(String type)  {
    _isDigitalSelected=false;
    _isUpiSelected=false;
    _isQrSelected=false;
    _isWalletSelected=false;
    update();

    if(type==AppConstants.payment_method_digital){
      _isDigitalSelected=true;
    } else if(type==AppConstants.payment_method_upi_deposit){
      _isUpiSelected=true;
    }
    else if(type==AppConstants.payment_method_wallet){
      _isWalletSelected=true;
    } else if(type==AppConstants.payment_method_qrCode){
      _isQrSelected=true;
    }


    update();


  }

  void pickUserImage() async {
    _isUserImageLoading=true;
    update();
    _pickedUserImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedUserImageFile != null) {
      _pickedUserImageFile = await NetworkInfo.compressImage(_pickedUserImageFile);
      _rawUserImageFile = await _pickedUserImageFile.readAsBytes();
    }
    _isUserImageLoading=false;
    update();
  }
  void initData() {
    _referenceDropdownValue=null;
    update();
    _cityController = TextEditingController();
    _primeMembersList = null;
    _isFormCompleted = null;
    _isReferenceSubmitted = null;
    _isPersonalDetailsSubmitted = null;
    _isBothAccountNumberMatched = null;
    _stateDropdownValue = null;
    _primeMemberDetailData = null;
    _relationList = null;
    _pickedNomineeAadharImageFile = null;
    _pickedNomineePanImageFile = null;
    _pickedAadharImageFile = null;
    _pickedAadharBackImageFile = null;
    _pickedPanImageFile = null;
    _pickedUpiScreenshotImageFile = null;
    _pickedUserImageFile = null;
    _rawUpiScreenshotImageFile = null;
    _rawAadharImageFile = null;
    _rawNomineeAadharImageFile = null;
    _rawNomineeAadharBackImageFile = null;
    _rawUserImageFile = null;
    _rawPanImageFile = null;
    _rawNomineePanImageFile = null;
    update();
  }
  void pickUpiScreenshotImage() async {
    _isUpiScreenshotImageLoading=true;
    update();
    _pickedUpiScreenshotImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedUpiScreenshotImageFile != null) {
      _pickedUpiScreenshotImageFile = await NetworkInfo.compressImage(_pickedUpiScreenshotImageFile);
      _rawUpiScreenshotImageFile = await _pickedUpiScreenshotImageFile.readAsBytes();
    }
    _isUpiScreenshotImageLoading=false;
    update();
  }
  void togglePayment()  {
    _isPaymentFailed=false;
    _isPaymentSuccessful = !_isPaymentSuccessful;

    update();
  }
  void togglePaymentFailed()  {
    _isPaymentSuccessful=false;
    _isPaymentFailed = !_isPaymentFailed;
    update();
    Get.back();
  }
  void pickNomineePanImage() async {
    _isNomineePanImageLoading=true;
    update();
    _pickedNomineePanImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedNomineePanImageFile != null) {
      _pickedNomineePanImageFile = await NetworkInfo.compressImage(_pickedNomineePanImageFile);
      _rawNomineePanImageFile = await _pickedNomineePanImageFile.readAsBytes();
    }
    _isNomineePanImageLoading=false;
    update();
  }
  void pickNomineeAadharImage() async {
    _isNomineeAadharImageLoading=true;
    update();
    _pickedNomineeAadharImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedNomineeAadharImageFile != null) {
      _pickedNomineeAadharImageFile = await NetworkInfo.compressImage(_pickedNomineeAadharImageFile);
      _rawNomineeAadharImageFile = await _pickedNomineeAadharImageFile.readAsBytes();
    }
    _isNomineeAadharImageLoading=false;
    update();
  }

  void pickNomineeAadharBackImage() async {
    _isNomineeAadharBackImageLoading=true;
    update();
    _pickedNomineeAadharBackImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedNomineeAadharBackImageFile != null) {
      _pickedNomineeAadharBackImageFile = await NetworkInfo.compressImage(_pickedNomineeAadharBackImageFile);
      _rawNomineeAadharBackImageFile = await _pickedNomineeAadharBackImageFile.readAsBytes();
    }
    _isNomineeAadharBackImageLoading=false;
    update();
  }
  void pickPanImage() async {
    _isPanImageLoading=true;
    update();
    _pickedPanImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedPanImageFile != null) {
      _pickedPanImageFile = await NetworkInfo.compressImage(_pickedPanImageFile);
      _rawPanImageFile = await _pickedPanImageFile.readAsBytes();
    }
    _isPanImageLoading=false;
    update();
  }

  void pickAadharImage() async {
    _isAadharImageLoading=true;
    update();
    _pickedAadharImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedAadharImageFile != null) {
      _pickedAadharImageFile = await NetworkInfo.compressImage(_pickedAadharImageFile);
      _rawAadharImageFile = await _pickedAadharImageFile.readAsBytes();
    }
    _isAadharImageLoading=false;
    update();
  }
  void pickAadharBackImage() async {
    _isAadharBackImageLoading=true;
    update();
    _pickedAadharBackImageFile = await ImagePicker().pickImage(source: ImageSource.gallery);
    if(_pickedAadharBackImageFile != null) {
      _pickedAadharBackImageFile = await NetworkInfo.compressImage(_pickedAadharBackImageFile);
      _rawAadharBackImageFile = await _pickedAadharBackImageFile.readAsBytes();
    }
    _isAadharBackImageLoading=false;
    update();
  }
  void updateBothAccountNumberMatched(bool value) {
    _isBothAccountNumberMatched = value;
    update();
  }

  Future<ResponseModel> uploadDocument(
      bool shouldBeUpdate,
      String state,
      String city,
      String pin,
      String bank_account_no,
      String bank_ifc,
      String aadhar_card,
      String pan_card,
      String nominee_name,
      String nominee_mobile,
      String nominee_relation,
      String nominee_adhar_card,
      String nominee_pan_card,
      String parent_id
      ) async {
    _isLoading = true;
    update();
    ResponseModel _responseModel;
    Response response = await primeMemberRepo.uploadDocument(
        shouldBeUpdate,
        state,
         city,
         pin,
         bank_account_no,
         bank_ifc,
         aadhar_card,
         pan_card,
         nominee_name,
         nominee_mobile,
         nominee_relation,
         nominee_adhar_card,
         nominee_pan_card
        ,parent_id
        , _pickedUserImageFile
        , _pickedAadharImageFile
        , _pickedAadharBackImageFile
        , _pickedPanImageFile
        , _pickedNomineeAadharImageFile
        , _pickedNomineeAadharBackImageFile
        , _pickedNomineePanImageFile
    );
    _isFormCompleted = false;
    _isLoading = false;
    if (response.statusCode == 200) {

      _responseModel = ResponseModel(true, response.bodyString);
      PrimeMemberCreateUpdateResponse resModel = PrimeMemberCreateUpdateResponse.fromJson(response.body);
      if(resModel!=null){
        _isFormCompleted = resModel.isFormCompleted??false;


      }

      print(response.bodyString);
    } else {
      _responseModel = ResponseModel(false, response.statusText);
      print(response.statusText);
    }
    update();
    return _responseModel;
  }

  Future<ResponseModel> uploadUpiPaymentScreenshot(String orderId,String remarks,String upiNumber, String type, String transactionID) async {
    _isLoading = true;
    update();
    ResponseModel _responseModel;
    Response response = await primeMemberRepo.uploadUpiPaymentScreenshot(_pickedUpiScreenshotImageFile,_upiOptionDropdownValue,orderId,remarks,upiNumber,type,transactionID);

    _isLoading = false;
    if (response.statusCode == 200) {

      _responseModel = ResponseModel(true, response.bodyString);

      print(response.bodyString);
    } else {
      _responseModel = ResponseModel(false, response.statusText);
      print(response.statusText);
    }
    update();
    return _responseModel;
  }

  void updateRelationDropdown(String value) {
    _relationDropdownValue=value;
    update();
  }
  void setUpiScreenshotSubmitted(bool value) {
    _upiScreenshotSubmitted=value;
    update();
  }
  void updateStateDropdown(OneStateAllCity value) {
    _stateDropdownValue=value;
    _cityDropdownValue=null;
    _cityList=null;
    update();
  }

  void updateCityDropdown(City value) {
    _cityController.text=value.city.toString();
    _cityDropdownValue=value;
    update();
  }

  void updatePersonalDetailsSubmitted() {
    _isPersonalDetailsSubmitted=true;
    update();
  }

  void updateReferenceDropdown(PrimeSearchMember value) {

    _referenceDropdownValue=value;
    update();
  }
  void updateUpiOptionDropdown(String value) {

    _upiOptionDropdownValue=value;
    update();
  } void updateUpiNumberDropdown(String value) {

    _upiNumberDropdownValue=value;
    update();
  }
  void reset() {
    if(Get.find<SplashController>().configModel.upiPaymentNumber.isNotEmpty){
      _upiNumberDropdownValue=Get.find<SplashController>().configModel.upiPaymentNumber[0];
    }else{
      _upiNumberDropdownValue=null;
    }
    _isPaymentFailed=false;
    _isPaymentSuccessful=false;
    _upiOptionDropdownValue=null;

    _rawUpiScreenshotImageFile=null;
    update();
  }

  void updateIsFormCompleted(bool value) {
    _isFormCompleted=value;
    update();
  }

  void cityListUpdate(int index, OneStateAllCity selectedItem) {
    if(_stateCityList!=null && _stateCityList.isNotEmpty){
      print("cityListUpdate run index = $index");
      print("cityListUpdate run A = ${_cityList?.length}");
      if(index==-1 && selectedItem!=null){
        index= _stateCityList.indexOf(selectedItem);
      }

      _cityList=null;
      _cityList=[];
      _cityList.addAll(_stateCityList[index].city);

      try{
        if(_cityList!=null && _cityList.isNotEmpty){

          updateCityDropdown(_cityList[0]);

        }
      }catch(e){}

      update();
      print("cityListUpdate run B = ${_cityDropdownValue.city.toString()}");
    }


  }
  void setPaymentMethod(int index, {bool isUpdate = true}) {
    _paymentMethodIndex = index;
    if(isUpdate){
      update();
    }
  }
}
