import 'package:sixam_mart/controller/auth_controller.dart';
import 'package:sixam_mart/controller/wishlist_controller.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/view/base/custom_snackbar.dart';
import 'package:get/get.dart';
import 'package:flutter/foundation.dart' as Foundation;

import '../model/response/error_response.dart';
class ApiChecker {
  static void checkApi(Response response) {

    if(response!=null){
      if(response.statusCode == 401) {
        Get.find<AuthController>().clearSharedData();
        Get.find<WishListController>().removeWishes();
        Get.offAllNamed(RouteHelper.getSignInRoute(RouteHelper.splash));
      }else if(response.statusCode == 429) {
        if(Foundation.kDebugMode) {
          print('====> 429_Too_Many_Request');
        }
      }
      else {

        if(response!=null && response.body!=null){
          ErrorResponse _errorResponse = ErrorResponse.fromJson(response.body);
          showCustomSnackBar(_errorResponse.errors[0].message, isError: true);

          if(Foundation.kDebugMode) {
            print('====> 430 ${response.statusText}');
          }
        }

      //  showCustomSnackBar(response.statusText);
      }
    }else {
      if(Foundation.kDebugMode) {
        showCustomSnackBar("response return null");
      }else{
        showCustomSnackBar("Something went wrong.");
      }

    }


  }

  static void checkResponseParseError(Error error , String uri) {
    if(Foundation.kDebugMode) {
      print('====> ApiChecker: Parse error uri is : $uri: error is : ${error.toString()}');
    }
  }
}
