/// data : [{"id":17,"user_id":41,"income_type":"transfer","credit":"2023-11-21T14:59:56.000000Z","debit":"5.00","balance":"47.13","deleted_at":"2023-11-21T14:59:56.000000Z","created_at":"2023-11-21T14:59:56.000000Z","updated_at":"2023-11-21T14:59:56.000000Z"}]
/// message : "user found."

class WallerTransferHistoryResponseModel {
  WallerTransferHistoryResponseModel({
      List<WallerTransferHistoryResponseData> data,
      String message,}){
    _data = data;
    _message = message;
}

  WallerTransferHistoryResponseModel.fromJson(dynamic json) {
    if (json['data'] != null) {
      _data = [];
      json['data'].forEach((v) {
        _data.add(WallerTransferHistoryResponseData.fromJson(v));
      });
    }
    _message = json['message'];
  }
  List<WallerTransferHistoryResponseData> _data;
  String _message;
WallerTransferHistoryResponseModel copyWith({  List<WallerTransferHistoryResponseData> data,
  String message,
}) => WallerTransferHistoryResponseModel(  data: data ?? _data,
  message: message ?? _message,
);
  List<WallerTransferHistoryResponseData> get data => _data;
  String get message => _message;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    if (_data != null) {
      map['data'] = _data.map((v) => v.toJson()).toList();
    }
    map['message'] = _message;
    return map;
  }

}

/// id : 17
/// user_id : 41
/// income_type : "transfer"
/// credit : "2023-11-21T14:59:56.000000Z"
/// debit : "5.00"
/// balance : "47.13"
/// deleted_at : "2023-11-21T14:59:56.000000Z"
/// created_at : "2023-11-21T14:59:56.000000Z"
/// updated_at : "2023-11-21T14:59:56.000000Z"

class WallerTransferHistoryResponseData {
  WallerTransferHistoryResponseData({
      num id, 
      num userId, 
      String incomeType, 
      String credit, 
      String debit, 
      String balance, 
      String party,
      String deletedAt,
      String createdAt, 
      String updatedAt,}){
    _id = id;
    _userId = userId;
    _incomeType = incomeType;
    _credit = credit;
    _debit = debit;
    _balance = balance;
    _party = party;
    _deletedAt = deletedAt;
    _createdAt = createdAt;
    _updatedAt = updatedAt;
}

  WallerTransferHistoryResponseData.fromJson(dynamic json) {
    _id = json['id'];
    _userId = json['user_id'];
    _incomeType = json['income_type'];
    _credit = json['credit'];
    _debit = json['debit'];
    _balance = json['balance'];
    _party = json['party'];
    _deletedAt = json['deleted_at'];
    _createdAt = json['created_at'];
    _updatedAt = json['updated_at'];
  }
  num _id;
  num _userId;
  String _incomeType;
  String _credit;
  String _debit;
  String _balance;
  String _party;
  String _deletedAt;
  String _createdAt;
  String _updatedAt;
WallerTransferHistoryResponseData copyWith({  num id,
  num userId,
  String incomeType,
  String credit,
  String debit,
  String balance,
  String party,
  String deletedAt,
  String createdAt,
  String updatedAt,
}) => WallerTransferHistoryResponseData(  id: id ?? _id,
  userId: userId ?? _userId,
  incomeType: incomeType ?? _incomeType,
  credit: credit ?? _credit,
  debit: debit ?? _debit,
  balance: balance ?? _balance,
  party: party ?? _party,
  deletedAt: deletedAt ?? _deletedAt,
  createdAt: createdAt ?? _createdAt,
  updatedAt: updatedAt ?? _updatedAt,
);
  num get id => _id;
  num get userId => _userId;
  String get incomeType => _incomeType;
  String get credit => _credit;
  String get debit => _debit;
  String get balance => _balance;
  String get party => _party;
  String get deletedAt => _deletedAt;
  String get createdAt => _createdAt;
  String get updatedAt => _updatedAt;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = _id;
    map['user_id'] = _userId;
    map['income_type'] = _incomeType;
    map['credit'] = _credit;
    map['debit'] = _debit;
    map['balance'] = _balance;
    map['party'] = _party;
    map['deleted_at'] = _deletedAt;
    map['created_at'] = _createdAt;
    map['updated_at'] = _updatedAt;
    return map;
  }

}