import 'package:sixam_mart/data/model/response/basic_campaign_model.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';

class BannerModel {
  List<BasicCampaignModel> campaigns;
  List<Bannr> banners;

  BannerModel({this.campaigns, this.banners});

  BannerModel.fromJson(Map<String, dynamic> json) {
    if (json['campaigns'] != null) {
      campaigns = [];
      json['campaigns'].forEach((v) {
        campaigns.add(BasicCampaignModel.fromJson(v));
      });
    }

    if (json['banners'] != null) {
      banners = [];
      json['banners'].forEach((v) {
        banners.add(Bannr.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.campaigns != null) {
      data['campaigns'] = this.campaigns.map((v) => v.toJson()).toList();
    }
    if (this.banners != null) {
      data['banners'] = this.banners.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Bannr {
  int id;
  String title;
  String type;
  String image;
  String link;
  Store store;
  Item item;

  Bannr({this.id, this.title, this.type, this.image,this.link, this.store, this.item});

  Bannr.fromJson(Map<String, dynamic> json) {
    id = json['id'] != null ? json['id'] : null;
    title = json['title'] != null ? json['title'] : null;
    type = json['banner_type'];
    image = json['cover_image'];
    link = json['link'] != null ? json['link'] : null;
    store = json['store'] != null ? Store.fromJson(json['store']) : null;
    item = json['item'] != null ? Item.fromJson(json['item']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['title'] = this.title;
    data['type'] = this.type;
    data['cover_image'] = this.image;
    data['link'] = this.link;
    if (this.store != null) {
      data['store'] = this.store.toJson();
    }
    if (this.item != null) {
      data['item'] = this.item.toJson();
    }
    return data;
  }
}
