import 'package:sixam_mart/data/model/response/item_model.dart';

class CartModel {
  double _price;
  double _discountedPrice;
  double _discountedPriceMask;
  double _discountMask;
  double _discount;
  List<Variation> _variation;
  double _discountAmount;
  int _quantity;
  List<AddOn> _addOnIds;
  List<AddOns> _addOns;
  bool _isCampaign;
  int _stock;
  Item _item;

  CartModel(
        double price,
        double discountedPrice,
        double discountedPriceMask,
        double discountMask,
        List<Variation> variation,
        double discountAmount,
        int quantity,
        List<AddOn> addOnIds,
        List<AddOns> addOns,
        bool isCampaign,
        int stock,
        Item item) {
    this._price = price;
    this._discountedPrice = discountedPrice;
    this._discountedPriceMask = discountedPriceMask;
    this._discountMask = discountMask;
    this._variation = variation;
    this._discountAmount = discountAmount;
    this._quantity = quantity;
    this._addOnIds = addOnIds;
    this._addOns = addOns;
    this._isCampaign = isCampaign;
    this._stock = stock;
    this._item = item;
  }

  double get price => _price;
  double get discount => _discount;
  double get discountedPrice => _discountedPrice;
  double get discountMask => _discountMask;
  double get discountedPriceMask => _discountedPriceMask;
  List<Variation> get variation => _variation;
  double get discountAmount => _discountAmount;
  // ignore: unnecessary_getters_setters
  int get quantity => _quantity;
  // ignore: unnecessary_getters_setters
  set quantity(int qty) => _quantity = qty;
  List<AddOn> get addOnIds => _addOnIds;
  List<AddOns> get addOns => _addOns;
  bool get isCampaign => _isCampaign;
  int get stock => _stock;
  Item get item => _item;

  CartModel.fromJson(Map<String, dynamic> json) {
    _price = json['price'].toDouble();
    _discountedPrice = json['discounted_price'].toDouble();
    _discountedPriceMask = json['discounted_price_mask'].toDouble();
    _discountMask = json['discounted_mask'].toDouble();
    if (json['variation'] != null) {
      _variation = [];
      json['variation'].forEach((v) {
        _variation.add(new Variation.fromJson(v));
      });
    }
    _discountAmount = json['discount_amount'].toDouble();
    _quantity = json['quantity'];
    _stock = json['stock'];
    if (json['add_on_ids'] != null) {
      _addOnIds = [];
      json['add_on_ids'].forEach((v) {
        _addOnIds.add(new AddOn.fromJson(v));
      });
    }
    if (json['add_ons'] != null) {
      _addOns = [];
      json['add_ons'].forEach((v) {
        _addOns.add(new AddOns.fromJson(v));
      });
    }
    _isCampaign = json['is_campaign'];
    if (json['item'] != null) {
      _item = Item.fromJson(json['item']);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['price'] = this._price;
    data['discounted_price'] = this._discountedPrice;
    data['discounted_price_mask'] = this._discountedPriceMask;
    data['discounted_mask'] = this._discountMask;
    if (this._variation != null) {
      data['variation'] = this._variation.map((v) => v.toJson()).toList();
    }
    data['discount_amount'] = this._discountAmount;
    data['quantity'] = this._quantity;
    if (this._addOnIds != null) {
      data['add_on_ids'] = this._addOnIds.map((v) => v.toJson()).toList();
    }
    if (this._addOns != null) {
      data['add_ons'] = this._addOns.map((v) => v.toJson()).toList();
    }
    data['is_campaign'] = this._isCampaign;
    data['stock'] = this._stock;
    data['item'] = this._item.toJson();
    return data;
  }
}

class AddOn {
  int id;
  int quantity;

  AddOn({this.id, this.quantity});

  AddOn.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    quantity = json['quantity'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['quantity'] = this.quantity;
    return data;
  }
}
