class ClientReferralInfo {
  ReferralInfo referralInfo;

  ClientReferralInfo({this.referralInfo});

  ClientReferralInfo.fromJson(Map<String, dynamic> json) {
    referralInfo = json['referral_info'] != null
        ? new ReferralInfo.fromJson(json['referral_info'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.referralInfo != null) {
      data['referral_info'] = this.referralInfo.toJson();
    }
    return data;
  }
}

class ReferralInfo {
  String name;
  String phone;
  String image;
  String primeSince;
  int underTotalPrime;

  ReferralInfo(
      {this.name,
        this.phone,
        this.image,
        this.primeSince,
        this.underTotalPrime});

  ReferralInfo.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    phone = json['phone'];
    image = json['image'];
    primeSince = json['prime_since'];
    underTotalPrime = json['under_total_prime'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['phone'] = this.phone;
    data['image'] = this.image;
    data['prime_since'] = this.primeSince;
    data['under_total_prime'] = this.underTotalPrime;
    return data;
  }
}
