/// total_size : 3
/// limit : "10"
/// offset : "0"
/// data : [{"id":20,"startdate":"2024-02-01","endate":"2024-02-10","perpair":"250.00","tds":"0.00","datecreation":"2024-02-10","payment":"30500.00"},{"id":19,"startdate":"2024-01-22","endate":"2024-01-31","perpair":"250.00","tds":"0.00","datecreation":"2024-02-04","payment":"18250.00"},{"id":18,"startdate":"2024-01-01","endate":"2024-01-21","perpair":"250.00","tds":"0.00","datecreation":"2024-02-04","payment":"29375.16"}]

class ClosingResponse {
  ClosingResponse({
      num totalSize, 
      String limit, 
      String offset, 
      List<ClosingResponseData> data,}){
    _totalSize = totalSize;
    _limit = limit;
    _offset = offset;
    _data = data;
}

  ClosingResponse.fromJson(dynamic json) {
    _totalSize = json['total_size'];
    _limit = json['limit'];
    _offset = json['offset'];
    if (json['data'] != null) {
      _data = [];
      json['data'].forEach((v) {
        _data.add(ClosingResponseData.fromJson(v));
      });
    }
  }
  num _totalSize;
  String _limit;
  String _offset;
  List<ClosingResponseData> _data;
ClosingResponse copyWith({  num totalSize,
  String limit,
  String offset,
  List<ClosingResponseData> data,
}) => ClosingResponse(  totalSize: totalSize ?? _totalSize,
  limit: limit ?? _limit,
  offset: offset ?? _offset,
  data: data ?? _data,
);
  num get totalSize => _totalSize;
  String get limit => _limit;
  String get offset => _offset;
  List<ClosingResponseData> get data => _data;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['total_size'] = _totalSize;
    map['limit'] = _limit;
    map['offset'] = _offset;
    if (_data != null) {
      map['data'] = _data.map((v) => v.toJson()).toList();
    }
    return map;
  }

}

/// id : 20
/// startdate : "2024-02-01"
/// endate : "2024-02-10"
/// perpair : "250.00"
/// tds : "0.00"
/// datecreation : "2024-02-10"
/// payment : "30500.00"

class ClosingResponseData {
  ClosingResponseData({
      num id, 
      String startdate, 
      String endate, 
      String perpair, 
      String tds, 
      String datecreation, 
      String payment,}){
    _id = id;
    _startdate = startdate;
    _endate = endate;
    _perpair = perpair;
    _tds = tds;
    _datecreation = datecreation;
    _payment = payment;
}

  ClosingResponseData.fromJson(dynamic json) {
    _id = json['id'];
    _startdate = json['startdate'];
    _endate = json['endate'];
    _perpair = json['perpair'];
    _tds = json['tds'];
    _datecreation = json['datecreation'];
    _payment = json['payment'];
  }
  num _id;
  String _startdate;
  String _endate;
  String _perpair;
  String _tds;
  String _datecreation;
  String _payment;
ClosingResponseData copyWith({  num id,
  String startdate,
  String endate,
  String perpair,
  String tds,
  String datecreation,
  String payment,
}) => ClosingResponseData(  id: id ?? _id,
  startdate: startdate ?? _startdate,
  endate: endate ?? _endate,
  perpair: perpair ?? _perpair,
  tds: tds ?? _tds,
  datecreation: datecreation ?? _datecreation,
  payment: payment ?? _payment,
);
  num get id => _id;
  String get startdate => _startdate;
  String get endate => _endate;
  String get perpair => _perpair;
  String get tds => _tds;
  String get datecreation => _datecreation;
  String get payment => _payment;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = _id;
    map['startdate'] = _startdate;
    map['endate'] = _endate;
    map['perpair'] = _perpair;
    map['tds'] = _tds;
    map['datecreation'] = _datecreation;
    map['payment'] = _payment;
    return map;
  }

}