
/// data : [{"id":1,"state":"Delhi","city":"Central Delhi","pin":"201102","image":"16978870212310218089.png","bank_account_no":"1234","bank_ifc":"Yesb000","aadhar_card":"1637282","aadhar_card_image":"16978870212310214692.png","pan_card":"82838","pan_card_image":"16978870212310216341.png","nominee_name":"Vaishali","nominee_mobile":"8800754419","nominee_relation":"Wife","nominee_adhar_card":"6w7272","nominee_adhar_card_image":"16978870212310216738.png","nominee_pan_card":"72uwue","nominee_pan_card_image":"16978870212310213201.png","user_id":22,"parent_id":1,"created_at":"2023-10-21T11:17:01.000000Z","updated_at":"2023-10-21T11:17:01.000000Z"}]
/// message : "Prime member Details of User"

class PrimeMemberDetailModel {
  PrimeMemberDetailModel({
      List<PrimeMemberDetailData> data,
      String message,
      bool is_form_completed,
  }){
    _data = data;
    _message = message;
    _is_form_completed = is_form_completed;
}

  PrimeMemberDetailModel.fromJson(dynamic json) {
    if (json['data'] != null) {
      _data = [];
      json['data'].forEach((v) {
        _data.add(PrimeMemberDetailData.fromJson(v));
      });
    }
    _message = json['message'];
    _is_form_completed = json['is_form_completed'];
  }
  List<PrimeMemberDetailData> _data;
  String _message;
  bool _is_form_completed;
PrimeMemberDetailModel copyWith({  List<PrimeMemberDetailData> data,
  String message,
}) => PrimeMemberDetailModel(
  data: data ?? _data,
  message: message ?? _message,
  is_form_completed: is_form_completed ?? _is_form_completed,
);
  List<PrimeMemberDetailData> get data => _data;
  String get message => _message;
  bool get is_form_completed => _is_form_completed;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    if (_data != null) {
      map['data'] = _data.map((v) => v.toJson()).toList();
    }
    map['message'] = _message;
    map['is_form_completed'] = _is_form_completed;
    return map;
  }

}

/// id : 1
/// state : "Delhi"
/// city : "Central Delhi"
/// pin : "201102"
/// image : "16978870212310218089.png"
/// bank_account_no : "1234"
/// bank_ifc : "Yesb000"
/// aadhar_card : "1637282"
/// aadhar_card_image : "16978870212310214692.png"
/// pan_card : "82838"
/// pan_card_image : "16978870212310216341.png"
/// nominee_name : "Vaishali"
/// nominee_mobile : "8800754419"
/// nominee_relation : "Wife"
/// nominee_adhar_card : "6w7272"
/// nominee_adhar_card_image : "16978870212310216738.png"
/// nominee_pan_card : "72uwue"
/// nominee_pan_card_image : "16978870212310213201.png"
/// user_id : 22
/// parent_id : 1
/// created_at : "2023-10-21T11:17:01.000000Z"
/// updated_at : "2023-10-21T11:17:01.000000Z"

class PrimeMemberDetailData {
  PrimeMemberDetailData({
      num id, 
      String state, 
      String city, 
      String pin, 
      String image, 
      String bankAccountNo, 
      String bankIfc, 
      String aadharCard, 
      String aadharCardImage, 
      String aadharCardImageBack,
      String panCard,
      String panCardImage, 
      String nomineeName, 
      String nomineeMobile, 
      String nomineeRelation, 
      String nomineeAdharCard, 
      String nomineeAdharCardImage, 
      String nomineeAdharCardImageBack,
      String nomineePanCard,
      String nomineePanCardImage, 
      num userId, 
      num parentId, 
      String parentName,
      String createdAt,
      String updatedAt,}){
    _id = id;
    _state = state;
    _city = city;
    _pin = pin;
    _image = image;
    _bankAccountNo = bankAccountNo;
    _bankIfc = bankIfc;
    _aadharCard = aadharCard;
    _aadharCardImage = aadharCardImage;
    _aadharCardImageBack = aadharCardImageBack;
    _panCard = panCard;
    _panCardImage = panCardImage;
    _nomineeName = nomineeName;
    _nomineeMobile = nomineeMobile;
    _nomineeRelation = nomineeRelation;
    _nomineeAdharCard = nomineeAdharCard;
    _nomineeAdharCardImage = nomineeAdharCardImage;
    _nomineeAdharCardImageBack = nomineeAdharCardImageBack;
    _nomineePanCard = nomineePanCard;
    _nomineePanCardImage = nomineePanCardImage;
    _userId = userId;
    _parentId = parentId;
    _parentName = parentName;
    _createdAt = createdAt;
    _updatedAt = updatedAt;
}

  PrimeMemberDetailData.fromJson(dynamic json) {
    _id = json['id'];
    _state = json['state'];
    _city = json['city'];
    _pin = json['pin'];
    _image = json['image'];
    _bankAccountNo = json['bank_account_no'];
    _bankIfc = json['bank_ifc'];
    _aadharCard = json['aadhar_card'];
    _aadharCardImage = json['aadhar_card_image'];
    _aadharCardImageBack = json['aadhar_card_image_back'];
    _panCard = json['pan_card'];
    _panCardImage = json['pan_card_image'];
    _nomineeName = json['nominee_name'];
    _nomineeMobile = json['nominee_mobile'];
    _nomineeRelation = json['nominee_relation'];
    _nomineeAdharCard = json['nominee_adhar_card'];
    _nomineeAdharCardImage = json['nominee_adhar_card_image'];
    _nomineeAdharCardImageBack = json['nominee_adhar_card_image_back'];
    _nomineePanCard = json['nominee_pan_card'];
    _nomineePanCardImage = json['nominee_pan_card_image'];
    _userId = json['user_id'];
    _parentId = json['parent_id'];
    _parentName = json['parent_name'];
    _createdAt = json['created_at'];
    _updatedAt = json['updated_at'];
  }
  num _id;
  String _state;
  String _city;
  String _pin;
  String _image;
  String _bankAccountNo;
  String _bankIfc;
  String _aadharCard;
  String _aadharCardImage;
  String _aadharCardImageBack;
  String _panCard;
  String _panCardImage;
  String _nomineeName;
  String _nomineeMobile;
  String _nomineeRelation;
  String _nomineeAdharCard;
  String _nomineeAdharCardImage;
  String _nomineeAdharCardImageBack;
  String _nomineePanCard;
  String _nomineePanCardImage;
  num _userId;
  num _parentId;
  String _parentName;
  String _createdAt;
  String _updatedAt;
PrimeMemberDetailData copyWith({  num id,
  String state,
  String city,
  String pin,
  String image,
  String bankAccountNo,
  String bankIfc,
  String aadharCard,
  String aadharCardImage,
  String aadharCardImageBack,
  String panCard,
  String panCardImage,
  String nomineeName,
  String nomineeMobile,
  String nomineeRelation,
  String nomineeAdharCard,
  String nomineeAdharCardImage,
  String nomineeAdharCardImageBack,
  String nomineePanCard,
  String nomineePanCardImage,
  num userId,
  num parentId,
  String createdAt,
  String parentName,
  String updatedAt,
}) => PrimeMemberDetailData(  id: id ?? _id,
  state: state ?? _state,
  city: city ?? _city,
  pin: pin ?? _pin,
  image: image ?? _image,
  bankAccountNo: bankAccountNo ?? _bankAccountNo,
  bankIfc: bankIfc ?? _bankIfc,
  aadharCard: aadharCard ?? _aadharCard,
  aadharCardImage: aadharCardImage ?? _aadharCardImage,
  aadharCardImageBack: aadharCardImageBack ?? _aadharCardImageBack,
  panCard: panCard ?? _panCard,
  panCardImage: panCardImage ?? _panCardImage,
  nomineeName: nomineeName ?? _nomineeName,
  nomineeMobile: nomineeMobile ?? _nomineeMobile,
  nomineeRelation: nomineeRelation ?? _nomineeRelation,
  nomineeAdharCard: nomineeAdharCard ?? _nomineeAdharCard,
  nomineeAdharCardImage: nomineeAdharCardImage ?? _nomineeAdharCardImage,
  nomineeAdharCardImageBack: nomineeAdharCardImageBack ?? _nomineeAdharCardImageBack,
  nomineePanCard: nomineePanCard ?? _nomineePanCard,
  nomineePanCardImage: nomineePanCardImage ?? _nomineePanCardImage,
  userId: userId ?? _userId,
  parentId: parentId ?? _parentId,
  parentName: parentName ?? _parentName,
  createdAt: createdAt ?? _createdAt,
  updatedAt: updatedAt ?? _updatedAt,
);
  num get id => _id;
  String get state => _state;
  String get city => _city;
  String get pin => _pin;
  String get image => _image;
  String get bankAccountNo => _bankAccountNo;
  String get bankIfc => _bankIfc;
  String get aadharCard => _aadharCard;
  String get aadharCardImage => _aadharCardImage;
  String get aadharCardImageBack => _aadharCardImageBack;
  String get panCard => _panCard;
  String get panCardImage => _panCardImage;
  String get nomineeName => _nomineeName;
  String get nomineeMobile => _nomineeMobile;
  String get nomineeRelation => _nomineeRelation;
  String get nomineeAdharCard => _nomineeAdharCard;
  String get nomineeAdharCardImage => _nomineeAdharCardImage;
  String get nomineeAdharCardImageBack => _nomineeAdharCardImageBack;
  String get nomineePanCard => _nomineePanCard;
  String get nomineePanCardImage => _nomineePanCardImage;
  num get userId => _userId;
  num get parentId => _parentId;
  String get createdAt => _createdAt;
  String get parentName => _parentName;
  String get updatedAt => _updatedAt;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = _id;
    map['state'] = _state;
    map['city'] = _city;
    map['pin'] = _pin;
    map['image'] = _image;
    map['bank_account_no'] = _bankAccountNo;
    map['bank_ifc'] = _bankIfc;
    map['aadhar_card'] = _aadharCard;
    map['aadhar_card_image'] = _aadharCardImage;
    map['aadhar_card_image_back'] = _aadharCardImageBack;
    map['pan_card'] = _panCard;
    map['pan_card_image'] = _panCardImage;
    map['nominee_name'] = _nomineeName;
    map['nominee_mobile'] = _nomineeMobile;
    map['nominee_relation'] = _nomineeRelation;
    map['nominee_adhar_card'] = _nomineeAdharCard;
    map['nominee_adhar_card_image'] = _nomineeAdharCardImage;
    map['nominee_adhar_card_image_back'] = _nomineeAdharCardImageBack;
    map['nominee_pan_card'] = _nomineePanCard;
    map['nominee_pan_card_image'] = _nomineePanCardImage;
    map['user_id'] = _userId;
    map['parent_id'] = _parentId;
    map['parent_name'] = _parentName;
    map['created_at'] = _createdAt;
    map['updated_at'] = _updatedAt;
    return map;
  }

}