/// status : true
/// data : [{"upgraded_at":"2023-12-13 12:01:27","user_id":78,"user_prime_account":"000000000001","user_name":"Arpna Kumari Kumari","sponsor_id":42,"sponsor_name":"Bhavya Retail","sponsor_prime_account":"Bhavya000000","membership_fee":2999},{"upgraded_at":"2023-12-13 16:25:14","user_id":80,"user_prime_account":"231213042514","user_name":"Kamakshi Kumari","sponsor_id":78,"sponsor_name":"Arpna Kumari Kumari","sponsor_prime_account":"000000000001","membership_fee":2999}]

class RevenueStatementResponse {
  RevenueStatementResponse({
      bool status, 
      List<RevenueStatementData> data,}){
    _status = status;
    _data = data;
}

  RevenueStatementResponse.fromJson(dynamic json) {
    _status = json['status'];
    if (json['data'] != null) {
      _data = [];
      json['data'].forEach((v) {
        _data.add(RevenueStatementData.fromJson(v));
      });
    }
  }
  bool _status;
  List<RevenueStatementData> _data;
RevenueStatementResponse copyWith({  bool status,
  List<RevenueStatementData> data,
}) => RevenueStatementResponse(  status: status ?? _status,
  data: data ?? _data,
);
  bool get status => _status;
  List<RevenueStatementData> get data => _data;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['status'] = _status;
    if (_data != null) {
      map['data'] = _data.map((v) => v.toJson()).toList();
    }
    return map;
  }

}

/// upgraded_at : "2023-12-13 12:01:27"
/// user_id : 78
/// user_prime_account : "000000000001"
/// user_name : "Arpna Kumari Kumari"
/// sponsor_id : 42
/// sponsor_name : "Bhavya Retail"
/// sponsor_prime_account : "Bhavya000000"
/// membership_fee : 2999

class RevenueStatementData {
  RevenueStatementData({
      String upgradedAt, 
      num userId,
      String userPrimeAccount, 
      String userName, 
      num sponsorId, 
      String sponsorName, 
      String sponsorPrimeAccount, 
      String paymentMode,
      double membershipFee,
      double balance,
  }){
    _upgradedAt = upgradedAt;
    _userId = userId;
    _userPrimeAccount = userPrimeAccount;
    _userName = userName;
    _sponsorId = sponsorId;
    _sponsorName = sponsorName;
    _paymentMode = paymentMode;
    _sponsorPrimeAccount = sponsorPrimeAccount;
    _membershipFee = membershipFee;
    _balance = balance;
}

  RevenueStatementData.fromJson(dynamic json) {
    _upgradedAt = json['upgraded_at'];
    _userId = json['user_id'];
    _userPrimeAccount = json['user_prime_account'];
    _userName = json['user_name'];
    _sponsorId = json['sponsor_id'];
    _sponsorName = json['sponsor_name'];
    _paymentMode = json['payment_mode'];
    _sponsorPrimeAccount = json['sponsor_prime_account'];
    _membershipFee = json['membership_fee'].toDouble();
    _balance = json['balance'].toDouble();
  }
  String _upgradedAt;
  num _userId;
  String _userPrimeAccount;
  String _userName;
  num _sponsorId;
  String _sponsorName;
  String _paymentMode;
  String _sponsorPrimeAccount;
  double _membershipFee;
  double _balance;
RevenueStatementData copyWith({  String upgradedAt,
  num userId,
  String userPrimeAccount,
  String userName,
  num sponsorId,
  String sponsorName,
  String paymentMode,
  String sponsorPrimeAccount,
  double membershipFee,
  double balance,
}) => RevenueStatementData(  upgradedAt: upgradedAt ?? _upgradedAt,
  userId: userId ?? _userId,
  userPrimeAccount: userPrimeAccount ?? _userPrimeAccount,
  userName: userName ?? _userName,
  sponsorId: sponsorId ?? _sponsorId,
  sponsorName: sponsorName ?? _sponsorName,
  paymentMode: paymentMode ?? _paymentMode,
  sponsorPrimeAccount: sponsorPrimeAccount ?? _sponsorPrimeAccount,
  membershipFee: membershipFee ?? _membershipFee,
  balance: balance ?? _balance,
);
  String get upgradedAt => _upgradedAt;
  num get userId => _userId;
  String get userPrimeAccount => _userPrimeAccount;
  String get userName => _userName;
  num get sponsorId => _sponsorId;
  String get sponsorName => _sponsorName;
  String get paymentMode => _paymentMode;
  String get sponsorPrimeAccount => _sponsorPrimeAccount;
  double get membershipFee => _membershipFee;
  double get balance => _balance;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['upgraded_at'] = _upgradedAt;
    map['user_id'] = _userId;
    map['user_prime_account'] = _userPrimeAccount;
    map['user_name'] = _userName;
    map['sponsor_id'] = _sponsorId;
    map['sponsor_name'] = _sponsorName;
    map['payment_mode'] = _paymentMode;
    map['sponsor_prime_account'] = _sponsorPrimeAccount;
    map['membership_fee'] = _membershipFee;
    map['balance'] = _balance;
    return map;
  }

}