import 'package:sixam_mart/data/model/response/conversation_model.dart';

class UserInfoModel {
  int id;
  String fName;
  String mlmMyTeamUrl;
  String lName;
  String email;
  String image;
  String phone;
  String password;
  int orderCount;
  int memberSinceDays;
  double walletBalance;
  int refRemaining;
  double refIncome;
  double sponsorIncome;
  int totalSharedLinks;
  int loyaltyPoint;
  String refCode;
  String clientSideRefCode;
  int primeMember;
  int familyMembersCount;
  int primeMembersCount;
  String avlBP;
  String usedBP;
  int primeRemainingDays;
  double transfer;
  double revenue;
  int primeCount;
  int customerCount;
  String isCompany;
  double withdrawal;
  String upiPaymentStatus;
  String upiPaymentStatusDesc;
  int isTeamLeader;
  String isFormCompleted;
  String upiScreenShot;
  String primePan;
  String primeAadhar;
  String primeValidFrom;
  String primeValidTo;
  String primeMemberAccount;
  String appSharable;
  User userInfo;
  CompanyWalletSummery companyWalletSummery;

  UserInfoModel(
      {this.id,
        this.fName,
        this.mlmMyTeamUrl,
        this.lName,
        this.email,
        this.image,
        this.phone,
        this.password,
        this.orderCount,
        this.memberSinceDays,
        this.walletBalance,
        this.loyaltyPoint,
        this.refCode,
        this.clientSideRefCode,
        this.primeMember,
        this.upiPaymentStatus,
        this.upiPaymentStatusDesc,
        this.isTeamLeader,
        this.isFormCompleted,
        this.upiScreenShot,
        this.familyMembersCount,
        this.primeMembersCount,
        this.avlBP,
        this.usedBP,
        this.primePan,
        this.primeAadhar,
        this.primeValidFrom,
        this.primeValidTo,
        this.primeMemberAccount,
        this.primeRemainingDays,
        this.transfer,
        this.revenue,
        this.isCompany,
        this.primeCount,
        this.customerCount,
        this.appSharable,
        this.refRemaining,
        this.refIncome,
        this.withdrawal,
        this.sponsorIncome,
        this.totalSharedLinks,
        this.userInfo,
        this.companyWalletSummery,
      });

  UserInfoModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    fName = json['f_name'];
    mlmMyTeamUrl = json['mlm_my_team_url'];
    lName = json['l_name'];
    email = json['email'];
    image = json['image'];
    phone = json['phone'];
    password = json['password'];
    orderCount = json['order_count'];
    memberSinceDays = json['member_since_days'];
    walletBalance = json['wallet_balance'].toDouble();
    revenue = json['revenue'].toDouble();
    withdrawal = json['withdrawal']!=null ? json['withdrawal'].toDouble() : 0.0;
    refRemaining = json['ref_remaining'];
    totalSharedLinks = json['total_shared_links'];
    primeRemainingDays = json['prime_remaining_days'];
    transfer = json['transfer'].toDouble();
    primeCount = json['prime_count'];
    customerCount = json['customer_count'];
    isCompany = json['is_company'];
    sponsorIncome = json['sponsor_income'].toDouble();
    refIncome = json['referal_income'].toDouble();
    loyaltyPoint = json['loyalty_point'];
    refCode = json['ref_code'];
    clientSideRefCode = json['client_side_ref_code'];
    primeMember = json['prime_member'];
    familyMembersCount = json['family_members_count'];
    primeMembersCount = json['prime_members_count'];
    usedBP = json['Bhavya_used_coins'];
    avlBP = json['Bhavya_available_coins'];

    upiPaymentStatus = json['upi_payment_status'];
    upiPaymentStatusDesc = json['upi_payment_status_description'];
    isTeamLeader = json['is_team_leader'];
    isFormCompleted = json['is_form_completed'];
    upiScreenShot = json['upi_screen_shot'];
    primePan = json['prime_pan'];
    primeAadhar = json['prime_aadhar'];
    primeValidFrom = json['prime_valid_from'];
    primeValidTo = json['prime_valid_to'];
    primeMemberAccount = json['prime_member_account'];
    appSharable = json['app_sharable'];
    userInfo = json['userinfo'] != null ? new User.fromJson(json['userinfo']) : null;
    companyWalletSummery = json['company_wallet_summery'] != null ? new CompanyWalletSummery.fromJson(json['company_wallet_summery']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['f_name'] = this.fName;
    data['mlm_my_team_url'] = this.mlmMyTeamUrl;
    data['l_name'] = this.lName;
    data['email'] = this.email;
    data['image'] = this.image;
    data['phone'] = this.phone;
    data['password'] = this.password;
    data['order_count'] = this.orderCount;
    data['member_since_days'] = this.memberSinceDays;
    data['wallet_balance'] = this.walletBalance;
    data['ref_remaining'] = this.refRemaining;
    data['total_shared_links'] = this.totalSharedLinks;
    data['transfer'] = this.transfer;
    data['is_company'] = this.isCompany;
    data['prime_count'] = this.primeCount;
    data['revenue'] = this.revenue;
    data['customer_count'] = this.customerCount;
    data['prime_remaining_days'] = this.primeRemainingDays;
    data['sponsor_income'] = this.sponsorIncome;
    data['family_members_count'] = this.familyMembersCount;
    data['prime_members_count'] = this.primeMembersCount;
    data['Bhavya_available_coins'] = this.avlBP;
    data['Bhavya_used_coins'] = this.usedBP;
    data['referal_income'] = this.refIncome;
    data['loyalty_point'] = this.loyaltyPoint;
    data['ref_code'] = this.refCode;
    data['client_side_ref_code'] = this.clientSideRefCode;
    data['prime_member'] = this.primeMember;
    data['upi_payment_status'] = this.upiPaymentStatus;
    data['upi_payment_status_description'] = this.upiPaymentStatusDesc;
    data['is_team_leader'] = this.isTeamLeader;
    data['is_form_completed'] = this.isFormCompleted;
    data['upi_screen_shot'] = this.upiScreenShot;
    data['withdrawal'] = this.withdrawal;
    data['prime_pan'] = this.primePan;
    data['prime_aadhar'] = this.primeAadhar;
    data['prime_valid_from'] = this.primeValidFrom;
    data['prime_valid_to'] = this.primeValidTo;
    data['prime_member_account'] = this.primeMemberAccount;
    data['app_sharable'] = this.appSharable;
    if (this.userInfo != null) {
      data['user`info'] = this.userInfo.toJson();
    }
    if (this.companyWalletSummery != null) {
      data['user`company_wallet_summery'] = this.companyWalletSummery.toJson();
    }
    return data;
  }
}
