/// data : [{"id":3217,"user_id":42,"party_id":514,"income_type":"transfer","particulars":"₹3000 credited in wallet PARAS NATH Mobile+918271279204.","credit":null,"debit":"3000.00","balance":"981279.20","transfer_to_name":"","transfer_to_email":"","transfer_to_phone":"","transfer_to_prime_account_no":"","party":"PARAS NATH","transfer_type":"receipt","remarks":null,"closing_id":null,"deleted_at":null,"created_at":"2024-02-11T09:31:06.000000Z","updated_at":"2024-02-11T09:31:06.000000Z","transaction_date":"2024-02-11 15:01:06","prime_name":"Bhavya Retail","prime_phone":"+919334332876","prime_email":"systemamc@gmail.com","prime_account_no":"Bhavya000000","sponsor_name":null,"sponsor_prime_account_no":null}]
/// types : [{"value":"transfer","name":"Transfer"},{"value":"app_share","name":"App Share"},{"value":"withdrawal","name":"Withdrawal"},{"value":"sponsor","name":"Sponsor"},{"value":"recharge","name":"Recharge"},{"value":"prime_sbscription_fee","name":"Subscription Fee"},{"value":"online_shopping","name":"Online Shopping"},{"value":"tds","name":"TDS"},{"value":"company_recharge","name":"Company Recharge"},{"value":"pair_income","name":"Team Income"}]
/// total_reocrd : 153
/// total_amount : 145597738.7700001895427703857421875

class WalletStatementResponse {
  WalletStatementResponse({
      List<WalletStatementData> data,
      List<Types> types, 
      num totalReocrd, 
      num totalAmount,}){
    _data = data;
    _types = types;
    _totalReocrd = totalReocrd;
    _totalAmount = totalAmount;
}

  WalletStatementResponse.fromJson(dynamic json) {
    if (json['data'] != null) {
      _data = [];
      json['data'].forEach((v) {
        _data.add(WalletStatementData.fromJson(v));
      });
    }
    if (json['types'] != null) {
      _types = [];
      json['types'].forEach((v) {
        _types.add(Types.fromJson(v));
      });
    }
    _totalReocrd = json['total_reocrd'];
    _totalAmount = json['total_amount'];
  }
  List<WalletStatementData> _data;
  List<Types> _types;
  num _totalReocrd;
  num _totalAmount;
WalletStatementResponse copyWith({  List<WalletStatementData> data,
  List<Types> types,
  num totalReocrd,
  num totalAmount,
}) => WalletStatementResponse(  data: data ?? _data,
  types: types ?? _types,
  totalReocrd: totalReocrd ?? _totalReocrd,
  totalAmount: totalAmount ?? _totalAmount,
);
  List<WalletStatementData> get data => _data;
  List<Types> get types => _types;
  num get totalReocrd => _totalReocrd;
  num get totalAmount => _totalAmount;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    if (_data != null) {
      map['data'] = _data.map((v) => v.toJson()).toList();
    }
    if (_types != null) {
      map['types'] = _types.map((v) => v.toJson()).toList();
    }
    map['total_reocrd'] = _totalReocrd;
    map['total_amount'] = _totalAmount;
    return map;
  }

}

/// value : "transfer"
/// name : "Transfer"

class Types {
  Types({
      String value, 
      String name,}){
    _value = value;
    _name = name;
}

  Types.fromJson(dynamic json) {
    _value = json['value'];
    _name = json['name'];
  }
  String _value;
  String _name;
Types copyWith({  String value,
  String name,
}) => Types(  value: value ?? _value,
  name: name ?? _name,
);
  String get value => _value;
  String get name => _name;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['value'] = _value;
    map['name'] = _name;
    return map;
  }

}

/// id : 3217
/// user_id : 42
/// party_id : 514
/// income_type : "transfer"
/// particulars : "₹3000 credited in wallet PARAS NATH Mobile+918271279204."
/// credit : null
/// debit : "3000.00"
/// balance : "981279.20"
/// transfer_to_name : ""
/// transfer_to_email : ""
/// transfer_to_phone : ""
/// transfer_to_prime_account_no : ""
/// party : "PARAS NATH"
/// transfer_type : "receipt"
/// remarks : null
/// closing_id : null
/// deleted_at : null
/// created_at : "2024-02-11T09:31:06.000000Z"
/// updated_at : "2024-02-11T09:31:06.000000Z"
/// transaction_date : "2024-02-11 15:01:06"
/// prime_name : "Bhavya Retail"
/// prime_phone : "+919334332876"
/// prime_email : "systemamc@gmail.com"
/// prime_account_no : "Bhavya000000"
/// sponsor_name : null
/// sponsor_prime_account_no : null

class WalletStatementData {
  WalletStatementData({
      num id, 
      num userId, 
      num partyId, 
      String incomeType, 
      String particulars, 
      dynamic credit, 
      String debit, 
      String balance, 
      String transferToName, 
      String transferToEmail, 
      String transferToPhone, 
      String transferToPrimeAccountNo, 
      String party, 
      String transferType, 
      dynamic remarks, 
      dynamic closingId, 
      dynamic deletedAt, 
      String loanDeductionPercentage,
      String createdAt,
      String updatedAt,
      String transactionDate, 
      String primeName, 
      String primePhone, 
      String primeEmail, 
      String primeAccountNo, 
      dynamic sponsorName,
      dynamic sponsorPrimeAccountNo,
      num loanReceived,
  }){
    _id = id;
    _userId = userId;
    _partyId = partyId;
    _incomeType = incomeType;
    _particulars = particulars;
    _credit = credit;
    _debit = debit;
    _balance = balance;
    _transferToName = transferToName;
    _transferToEmail = transferToEmail;
    _transferToPhone = transferToPhone;
    _transferToPrimeAccountNo = transferToPrimeAccountNo;
    _party = party;
    _transferType = transferType;
    _remarks = remarks;
    _loanDeductionPercentage = loanDeductionPercentage;
    _closingId = closingId;
    _deletedAt = deletedAt;
    _createdAt = createdAt;
    _updatedAt = updatedAt;
    _transactionDate = transactionDate;
    _primeName = primeName;
    _primePhone = primePhone;
    _primeEmail = primeEmail;
    _primeAccountNo = primeAccountNo;
    _sponsorName = sponsorName;
    _sponsorPrimeAccountNo = sponsorPrimeAccountNo;
    _loanReceived = loanReceived;
}

  WalletStatementData.fromJson(dynamic json) {
    _id = json['id'];
    _userId = json['user_id'];
    _partyId = json['party_id'];
    _incomeType = json['income_type'];
    _particulars = json['particulars'];
    _credit = json['credit'];
    _debit = json['debit'];
    _balance = json['balance'];
    _transferToName = json['transfer_to_name'];
    _transferToEmail = json['transfer_to_email'];
    _transferToPhone = json['transfer_to_phone'];
    _transferToPrimeAccountNo = json['transfer_to_prime_account_no'];
    _party = json['party'];
    _transferType = json['transfer_type'];
    _remarks = json['remarks'];
    _loanDeductionPercentage = json['loan_deduction_percentage'];
    _closingId = json['closing_id'];
    _deletedAt = json['deleted_at'];
    _createdAt = json['created_at'];
    _updatedAt = json['updated_at'];
    _transactionDate = json['transaction_date'];
    _primeName = json['prime_name'];
    _primePhone = json['prime_phone'];
    _primeEmail = json['prime_email'];
    _primeAccountNo = json['prime_account_no'];
    _sponsorName = json['sponsor_name'];
    _sponsorPrimeAccountNo = json['sponsor_prime_account_no'];
    _loanReceived = json['loan_received']==null? 0.0 : json['loan_received'];
  }
  num _id;
  num _userId;
  num _partyId;
  String _incomeType;
  String _particulars;
  dynamic _credit;
  String _debit;
  String _balance;
  String _transferToName;
  String _transferToEmail;
  String _transferToPhone;
  String _transferToPrimeAccountNo;
  String _party;
  String _transferType;
  dynamic _remarks;
  String _loanDeductionPercentage;
  dynamic _closingId;
  dynamic _deletedAt;
  String _createdAt;
  String _updatedAt;
  String _transactionDate;
  String _primeName;
  String _primePhone;
  String _primeEmail;
  String _primeAccountNo;
  dynamic _sponsorName;
  dynamic _sponsorPrimeAccountNo;
  num _loanReceived;
WalletStatementData copyWith({  num id,
  num userId,
  num partyId,
  String incomeType,
  String particulars,
  dynamic credit,
  String debit,
  String balance,
  String transferToName,
  String transferToEmail,
  String transferToPhone,
  String transferToPrimeAccountNo,
  String party,
  String transferType,
  String loanDeductionPercentage,
  dynamic remarks,
  dynamic closingId,
  dynamic deletedAt,
  String createdAt,
  String updatedAt,
  String transactionDate,
  String primeName,
  String primePhone,
  String primeEmail,
  String primeAccountNo,
  dynamic sponsorName,
  dynamic sponsorPrimeAccountNo,
  num loanReceived,
}) => WalletStatementData(  id: id ?? _id,
  userId: userId ?? _userId,
  partyId: partyId ?? _partyId,
  incomeType: incomeType ?? _incomeType,
  particulars: particulars ?? _particulars,
  credit: credit ?? _credit,
  debit: debit ?? _debit,
  balance: balance ?? _balance,
  transferToName: transferToName ?? _transferToName,
  transferToEmail: transferToEmail ?? _transferToEmail,
  transferToPhone: transferToPhone ?? _transferToPhone,
  transferToPrimeAccountNo: transferToPrimeAccountNo ?? _transferToPrimeAccountNo,
  party: party ?? _party,
  transferType: transferType ?? _transferType,
  remarks: remarks ?? _remarks,
  loanDeductionPercentage: loanDeductionPercentage ?? _loanDeductionPercentage,
  closingId: closingId ?? _closingId,
  deletedAt: deletedAt ?? _deletedAt,
  createdAt: createdAt ?? _createdAt,
  updatedAt: updatedAt ?? _updatedAt,
  transactionDate: transactionDate ?? _transactionDate,
  primeName: primeName ?? _primeName,
  primePhone: primePhone ?? _primePhone,
  primeEmail: primeEmail ?? _primeEmail,
  primeAccountNo: primeAccountNo ?? _primeAccountNo,
  sponsorName: sponsorName ?? _sponsorName,
  sponsorPrimeAccountNo: sponsorPrimeAccountNo ?? _sponsorPrimeAccountNo,
  loanReceived: loanReceived ?? _loanReceived,
);
  num get id => _id;
  num get userId => _userId;
  num get partyId => _partyId;
  String get incomeType => _incomeType;
  String get particulars => _particulars;
  dynamic get credit => _credit;
  String get debit => _debit;
  String get balance => _balance;
  String get transferToName => _transferToName;
  String get transferToEmail => _transferToEmail;
  String get transferToPhone => _transferToPhone;
  String get transferToPrimeAccountNo => _transferToPrimeAccountNo;
  String get party => _party;
  String get transferType => _transferType;
  dynamic get remarks => _remarks;
  String get loanDeductionPercentage => _loanDeductionPercentage;
  dynamic get closingId => _closingId;
  dynamic get deletedAt => _deletedAt;
  String get createdAt => _createdAt;
  String get updatedAt => _updatedAt;
  String get transactionDate => _transactionDate;
  String get primeName => _primeName;
  String get primePhone => _primePhone;
  String get primeEmail => _primeEmail;
  String get primeAccountNo => _primeAccountNo;
  dynamic get sponsorName => _sponsorName;
  dynamic get sponsorPrimeAccountNo => _sponsorPrimeAccountNo;
  num get loanReceived => _loanReceived;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = _id;
    map['user_id'] = _userId;
    map['party_id'] = _partyId;
    map['income_type'] = _incomeType;
    map['particulars'] = _particulars;
    map['credit'] = _credit;
    map['debit'] = _debit;
    map['balance'] = _balance;
    map['transfer_to_name'] = _transferToName;
    map['transfer_to_email'] = _transferToEmail;
    map['transfer_to_phone'] = _transferToPhone;
    map['transfer_to_prime_account_no'] = _transferToPrimeAccountNo;
    map['party'] = _party;
    map['transfer_type'] = _transferType;
    map['remarks'] = _remarks;
    map['loan_deduction_percentage'] = _loanDeductionPercentage;
    map['closing_id'] = _closingId;
    map['deleted_at'] = _deletedAt;
    map['created_at'] = _createdAt;
    map['updated_at'] = _updatedAt;
    map['transaction_date'] = _transactionDate;
    map['prime_name'] = _primeName;
    map['prime_phone'] = _primePhone;
    map['prime_email'] = _primeEmail;
    map['prime_account_no'] = _primeAccountNo;
    map['sponsor_name'] = _sponsorName;
    map['sponsor_prime_account_no'] = _sponsorPrimeAccountNo;
    map['loan_received'] = _loanReceived;
    return map;
  }

}