import 'package:get/get.dart';
import 'package:sixam_mart/controller/localization_controller.dart';
import 'package:sixam_mart/data/api/api_client.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:flutter/material.dart';

import '../../controller/auth_controller.dart';
import '../../controller/user_controller.dart';
import '../model/response/userinfo_model.dart';

class BrandsRepo {
  final ApiClient apiClient;
  BrandsRepo({@required this.apiClient});

  Future<Response> getBrandsList( int offset, int type) async {


    return await apiClient.getData('${AppConstants.BRAND_URI}?limit=15&offset=$offset&brand_type=$type');
  }
  Future<Response> getBrandItemList(String brandID, int offset) async {
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }
    return await apiClient.getData('${AppConstants.BRANDS_ITEM_URI}$brandID?limit=30&offset=$offset&is_prime=$isPrime');
  }


  Future<Response> saveUserInterests(List<int> interests) async {
    return await apiClient.postData(AppConstants.INTEREST_URI, {"interest": interests});
  }
  Future<Response> getSearchData(String query, String brandID) async {
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }


    return await apiClient.getData(
      '${AppConstants.SEARCH_URI}${'items'}/search?name=$query&brand_id=$brandID&offset=1&limit=50&is_prime=$isPrime',
    );
  }
}