import 'dart:convert';

import 'package:sixam_mart/data/model/response/cart_model.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';

import '../model/response/item_model.dart';

class CartRepo{
  final SharedPreferences sharedPreferences;
  CartRepo({@required this.sharedPreferences});

  List<CartModel> getCartList() {
    List<String> carts = [];
    if(sharedPreferences.containsKey(AppConstants.CART_LIST)) {
      carts = sharedPreferences.getStringList(AppConstants.CART_LIST);
    }
    List<CartModel> cartList = [];
    carts.forEach((cart) => cartList.add(CartModel.fromJson(jsonDecode(cart))) );

    print("cartTest get =  ${carts.toString()}");
    return cartList;
  }

  void addToCartList(List<CartModel> cartProductList) {

    List<String> carts = [];
    cartProductList.forEach((cartModel) => carts.add(jsonEncode(cartModel)) );


    sharedPreferences.setStringList(AppConstants.CART_LIST, carts);
  }

  List<Item> getRecentViewList() {
    List<String> recentViews = [];
    if(sharedPreferences.containsKey(AppConstants.RECENT_VIEW_LIST)) {
      recentViews = sharedPreferences.getStringList(AppConstants.RECENT_VIEW_LIST);
    }
    List<Item> recentViewList = [];
    recentViews.forEach((cart) => recentViewList.add(Item.fromJson(jsonDecode(cart))) );

    return recentViewList;
  }

  void addToRecentViewList(List<Item> cartProductList) {

    List<String> recentViews = [];
    cartProductList.forEach((cartModel) => recentViews.add(jsonEncode(cartModel)) );

    sharedPreferences.setStringList(AppConstants.RECENT_VIEW_LIST, recentViews);
  }

}