import 'package:get/get.dart';
import 'package:sixam_mart/controller/localization_controller.dart';
import 'package:sixam_mart/data/api/api_client.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:flutter/material.dart';

import '../../controller/auth_controller.dart';
import '../../controller/user_controller.dart';
import '../model/response/userinfo_model.dart';

class CategoryRepo {
  final ApiClient apiClient;
  CategoryRepo({@required this.apiClient});

  Future<Response> getCategoryList(int offset, int type) async {
    return await apiClient.getData('${AppConstants.CATEGORY_URI}?limit=10&offset=$offset&cat_type=$type');
    //  return await apiClient.getData(AppConstants.CATEGORY_URI, headers: allCategory ? {
    //       'Content-Type': 'application/json; charset=UTF-8',
    //       AppConstants.LOCALIZATION_KEY: Get.find<LocalizationController>().locale.languageCode
    //           ?? AppConstants.languages[0].languageCode
    //     } : null);
  }

  Future<Response> getSubCategoryList(String parentID) async {
    return await apiClient.getData('${AppConstants.SUB_CATEGORY_URI}$parentID');
  }

  Future<Response> getCategoryItemList(String categoryID, int offset, String parentChild) async {
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }

    return await apiClient.getData('${AppConstants.CATEGORY_ITEM_URI}$categoryID?limit=10&offset=$offset&parent_child=$parentChild&is_prime=$isPrime');

  }

  Future<Response> getCategoryStoreList(String categoryID, int offset, String type) async {
    return await apiClient.getData('${AppConstants.CATEGORY_STORE_URI}$categoryID?limit=10&offset=$offset&type=$type');
  }

  Future<Response> getSearchData(String query, String categoryID, bool isStore, String parentChild) async {

    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }
    return await apiClient.getData(
      '${AppConstants.SEARCH_URI}${isStore ? 'stores' : 'items'}/search?name=$query&category_id=$categoryID&parent_child=$parentChild&offset=1&limit=50&is_prime=$isPrime',
    );
  }

  Future<Response> saveUserInterests(List<int> interests) async {
    return await apiClient.postData(AppConstants.INTEREST_URI, {"interest": interests});
  }

}