import 'package:get/get.dart';
import 'package:sixam_mart/data/api/api_client.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:flutter/material.dart';
import 'package:get/get_connect/http/src/response/response.dart';
import 'package:shared_preferences/shared_preferences.dart';

import '../../controller/auth_controller.dart';
import '../../controller/user_controller.dart';
import '../model/response/userinfo_model.dart';

class SearchRepo {
  final ApiClient apiClient;
  final SharedPreferences sharedPreferences;
  SearchRepo({@required this.apiClient, @required this.sharedPreferences});

  Future<Response> getSearchData(String query, bool isStore) async {

    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }
    return await apiClient.getData('${AppConstants.SEARCH_URI}${isStore ? 'stores' : 'items'}/search?name=$query&offset=1&limit=50&is_prime=$isPrime');
  }

  Future<Response> getSuggestedItems() async {
    return await apiClient.getData(AppConstants.SUGGESTED_ITEM_URI);
  }

  Future<bool> saveSearchHistory(List<String> searchHistories) async {
    return await sharedPreferences.setStringList(AppConstants.SEARCH_HISTORY, searchHistories);
  }

  List<String> getSearchAddress() {
    return sharedPreferences.getStringList(AppConstants.SEARCH_HISTORY) ?? [];
  }

  Future<bool> clearSearchHistory() async {
    return sharedPreferences.setStringList(AppConstants.SEARCH_HISTORY, []);
  }
}
