import 'package:get/get.dart';
import 'package:sixam_mart/data/api/api_client.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:flutter/material.dart';
import 'package:get/get_connect/http/src/response/response.dart';

import '../../controller/auth_controller.dart';
import '../../controller/user_controller.dart';
import '../model/response/userinfo_model.dart';

class StoreRepo {
  final ApiClient apiClient;
  StoreRepo({@required this.apiClient});

  Future<Response> getStoreList(int offset, String filterBy) async {
    return await apiClient.getData('${AppConstants.STORE_URI}/$filterBy?offset=$offset&limit=10');
  }

  Future<Response> getFeaturedStoreList() async {
    return await apiClient.getData('${AppConstants.STORE_URI}/all?featured=1&offset=1&limit=50');
  }

  Future<Response> getPopularStoreList(String type) async {
    return await apiClient.getData('${AppConstants.POPULAR_STORE_URI}?type=$type');
  }

  Future<Response> getLatestStoreList(String type) async {
    return await apiClient.getData('${AppConstants.LATEST_STORE_URI}?type=$type');
  }



  Future<Response> getStoreDetails(String storeID) async {
    return await apiClient.getData('${AppConstants.STORE_DETAILS_URI}$storeID');
  }

  Future<Response> getStoreItemList(int offset) async {
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }
    return await apiClient.getData(
      '${AppConstants.LATEST_ITEM_URI}?offset=$offset&limit=12&is_prime=$isPrime',
    );

    //  return await apiClient.getData(
    //       '${AppConstants.STORE_ITEM_URI}?store_id=$storeID&category_id=$categoryID&offset=$offset&limit=10&type=$type',
    //     );
  }

  Future<Response> getStoreSearchItemList(String searchText, String storeID, int offset, String type) async {

    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    bool _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    var isPrime="0";
    if(_isLoggedIn && _user!=null
        && _user.primeMember!=null
        && _user.primeMember==1
    ){
      isPrime="1";
    }

    return await apiClient.getData(
      '${AppConstants.SEARCH_URI}items/search?store_id=$storeID&name=$searchText&offset=$offset&limit=10&type=$type&is_prime=$isPrime',
    );
  }

  Future<Response> getStoreReviewList(String storeID) async {
    return await apiClient.getData('${AppConstants.STORE_REVIEW_URI}?store_id=$storeID');
  }

}