import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:get/get_connect/http/src/response/response.dart';
import 'package:sixam_mart/data/api/api_client.dart';
import 'package:sixam_mart/util/app_constants.dart';

import '../../controller/user_controller.dart';

class WalletRepo {
  final ApiClient apiClient;
  WalletRepo({@required this.apiClient});

  Future<Response> getWalletTransactionList(String offset) async {
    return await apiClient.getData('${AppConstants.WALLET_TRANSACTION_URL}?offset=$offset&limit=10');
  }

  Future<Response> getData(String url) async {

  return await apiClient.getData('$url');

  }
  Future<Response> updateUpiPaymentStatus({String id, String remarks, String action}) async {
    return await apiClient.postData(AppConstants.UPI_PAYMENT_APPROVE_URI, {"id": id, "remarks": remarks, "status": action});
  }
  Future<Response> trackWalletOrder(String orderId) async {
    return await apiClient.getData(
      '${AppConstants.WALLET_RECHARGE_ORDER_STATUS_URI}${'?order_id=$orderId'}',
    );
  }
  Future<Response> getLoyaltyTransactionList(String offset) async {
    return await apiClient.getData('${AppConstants.LOYALTY_TRANSACTION_URL}?offset=$offset&limit=10');
  }

  Future<Response> customerIdentity(String mobile) async {
    return await apiClient.getData('${AppConstants.CUSTOMER_IDENTITY_URI}?mobile_no=$mobile');

  }
  Future<Response> primePaymentFromWalletUri(String orderId) async {
    return await apiClient.getData('${AppConstants.PRIME_PAYMENT_FROM_WALLET_URI}?order_id=$orderId&customer_id=${Get.find<UserController>().userInfoModel.id.toString()}');

  }
  Future<Response> getOrderIdForWalletRecharge(String amt) async {
    return await apiClient.getData('${AppConstants.WALLET_RECHARGE_ORDER_ID_URL}?user_id=${Get.find<UserController>().userInfoModel.id.toString()}&recharge_amount=$amt');
  }

  Future<Response> pointToWallet({int point}) async {
    return await apiClient.postData(AppConstants.LOYALTY_POINT_TRANSFER_URL, {"point": point});
  }
  Future<Response> walletAmtTransfer({String loanDeductionPercent,String amount,String recipientId,String transferType,String remark}) async {
    return await apiClient.postData(AppConstants.WALLET_AMOUNT_TRANSFER_URL, {"amount": amount,"recipient_id": recipientId,"transfer_type": transferType,"loan_deduction_percentage": loanDeductionPercent,"remarks": remark});
  }Future<Response> requestToWithdrawal({String amount}) async {
    return await apiClient.postData(AppConstants.WALLET_AMOUNT_WITHDRAWAL_URL, {"withdrawal_amount": amount});
  }
  Future<Response> walletAmtTransferHistory(String url) async {
    return await apiClient.getData(url);
  }  Future<Response> getReferralHistory(String url) async {
    return await apiClient.getData(url);
  }
}