import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:get/get.dart';

class PriceConverter {
  static String convertPrice(double price, {double discount, String discountType}) {
    if(discount != null && discountType != null){
      if(discountType == 'amount') {
        price = price - discount;
      } else if(discountType == 'percentage' || discountType == 'percent') {


        if (discount <= 100) {
          discount = 1+ discount*.01;
        } else if(discount >100 && discount <=200) {
          discount = 2+ (discount-100)*.01;
        } else if(discount >200 && discount <=300) {
          discount = 3+ (discount-200)*.01;
        } else if(discount >300 && discount <=400) {
          discount = 4+ (discount-300)*.01;
        } else if(discount >400 && discount <=500) {
          discount = 5+ (discount-400)*.01;
        } else if(discount >500 && discount <=600) {
          discount = 6+ (discount-500)*.01;
        } else if(discount >600 && discount <=700) {
          discount = 7+ (discount-600)*.01;
        } else if(discount >700 && discount <=800) {
          discount = 8+ (discount-700)*.01;
        } else if(discount >800 && discount <=900) {
          discount = 9+ (discount-800)*.01;
        }
      }
      //price = price - ((discount / 100) * price);
      price = price / discount;
    }
    bool _isRightSide = Get.find<SplashController>().configModel.currencySymbolDirection == 'right';

    return '${_isRightSide ? '' : Get.find<SplashController>().configModel.currencySymbol+' '}'
        '${(price).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
        .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'
        '${_isRightSide ? ' '+Get.find<SplashController>().configModel.currencySymbol : ''}';
  }

  static double convertWithDiscountMask(double price, double discount, String discountType) {
    print("convertWithDiscount price $price discount $discount discountType $discountType");
    if(discountType == 'amount') {
      price = price - discount;
    }

    else if(discountType == 'percentage' || discountType == 'percent') {


      price = price - ((discount / 100) * price);
    }

    return price;
  }

  static double convertWithDiscount(double price, double discount, String discountType) {
    print("convertWithDiscount price $price discount $discount discountType $discountType");
    if(discountType == 'amount') {
      price = price - discount;
    }

    else if(discountType == 'percentage' || discountType == 'percent') {


      if (discount <= 100) {
        discount = 1+ discount*.01;
      } else if(discount >100 && discount <=200) {
        discount = 2+ (discount-100)*.01;
      } else if(discount >200 && discount <=300) {
        discount = 3+ (discount-200)*.01;
      } else if(discount >300 && discount <=400) {
        discount = 4+ (discount-300)*.01;
      } else if(discount >400 && discount <=500) {
        discount = 5+ (discount-400)*.01;
      } else if(discount >500 && discount <=600) {
        discount = 6+ (discount-500)*.01;
      } else if(discount >600 && discount <=700) {
        discount = 7+ (discount-600)*.01;
      } else if(discount >700 && discount <=800) {
        discount = 8+ (discount-700)*.01;
      } else if(discount >800 && discount <=900) {
        discount = 9+ (discount-800)*.01;
      }
    }
    price = price / discount;
    //price = price - ((discount / 100) * price);
    return price;
  }
  // static double convertWithMembershipDiscount(double price, double discount, String discountType) {
  //   print("convertWithDiscount price $price discount $discount discountType $discountType");
  //   if(discountType == 'amount') {
  //     price = price - discount;
  //   }else if(discountType == 'percentage' || discountType == 'percent') {
  //
  //
  //     price = price - ((discount / 100) * price);
  //   }
  //
  //   return price;
  // }

  static double calculation(double amount, double discount, String type, int quantity) {
    double calculatedAmount = 0;
    if(type == 'amount') {
      calculatedAmount = discount * quantity;
    }else if(type == 'percentage') {
      calculatedAmount = (discount / 100) * (amount * quantity);
    }
    return calculatedAmount;
  }
  static double discount(double originalPrice, double discountedPrice) {
    double discount = 0.0;

    try{
      discount = (100 *(originalPrice -discountedPrice))/10;
    }catch(e){
      discount = 0.0;
      e.printError(e.toString());
    }


    return discount;
  }
  static String percentageCalculation(double price, double priceAfterDiscount) {

    var percentageOfDiscountPerItem =0.0;
    try{
      percentageOfDiscountPerItem =( (price-priceAfterDiscount)/price) *100;
    }catch(e){
      percentageOfDiscountPerItem =0.0;
    }
    return num.parse(percentageOfDiscountPerItem.toStringAsFixed(2)).toString();
  }

  static String primeDiscountToViewOnly({double discount, String discountType}) {

    if(discount != null && discountType!=null){
      bool _isPercent = discountType == 'percentage' || discountType == 'percent';

      return '${_isPercent ? ''
          : Get.find<SplashController>().configModel.currencySymbol+' '}'
          '${(discount).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
          .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'
          '${_isPercent ? ' '+'%'
          : ''}';
    }else{
      bool _isPercent = false;
      discount=0.0;

      return '${_isPercent ? ''
          : Get.find<SplashController>().configModel.currencySymbol+' '}'
          '${(discount).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
          .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'
          '${_isPercent ? ' '+'%'
          : ''}';
    }

  }

}

