import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/data/model/response/choose_us_model.dart';
import 'package:sixam_mart/data/model/response/language_model.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:flutter/foundation.dart' as Foundation;

import '../data/model/response/item_model.dart';
import '../helper/price_converter.dart';
import 'dimensions.dart';

class AppConstants {


  static const String APP_NAME = 'Save and Shop';
  static const String payment_method_digital = 'cash';
  static const String payment_method_upi_deposit = 'upi';
  static const String payment_method_upi = 'upi';
  static const String payment_method_wallet = 'wallet';
  static const String payment_method_qrCode = 'qr';
  static const double APP_VERSION = 1.1;

  //static const String BASE_URL = 'https://webapp.Bhavyagroup.net';
  //https://register.gosoft.work/API/login.php

  static  String baseUrl = appUrl();


  static const String PRIMARY_MEMBERS_URI = '/api/v1/auth/prime-members';
  static const String USERS_PRIMARY_MEMBERS_URI = '/api/v1/auth/users-prime-members-list';
  static const String BRAND_URI = '/api/v1/brands';
  static const String BRANDS_ITEM_URI = '/api/v1/brands/items/';

  static const String BANNER_URI = '/api/v1/banners';

  static const String LATEST_ITEM_URI = '/api/v1/items/latest';
  static const String POPULAR_ITEM_URI = '/api/v1/items/popular';
  static const String REVIEWED_ITEM_URI = '/api/v1/items/most-reviewed';
  static const String SEARCH_ITEM_URI = '/api/v1/items/details/';
  static const String CATEGORY_URI = '/api/v1/categories';
  static const String SUB_CATEGORY_URI = '/api/v1/categories/childes/';
  static const String CATEGORY_ITEM_URI = '/api/v1/categories/items/';
  static const String CATEGORY_STORE_URI = '/api/v1/categories/stores/';
  static const String CONFIG_URI = '/api/v1/config';
  static const String CONFIG_2_URI = '/api/v1/config2';
  static const String PRIME_MEMBER_DETAIL = '/api/v1/auth/display-prime-members-details';
  static const String TRACK_URI = '/api/v1/customer/order/track?order_id=';
  static const String MESSAGE_URI = '/api/v1/customer/message/get';
  static const String FORGET_PASSWORD_URI = '/api/v1/auth/forgot-password';
  static const String VERIFY_TOKEN_URI = '/api/v1/auth/verify-token';
  static const String RESET_PASSWORD_URI = '/api/v1/auth/reset-password';
  static const String VERIFY_PHONE_URI = '/api/v1/auth/verify-phone';
  static const String CHECK_EMAIL_URI = '/api/v1/auth/check-email';
  static const String VERIFY_EMAIL_URI = '/api/v1/auth/verify-email';
  static const String REGISTER_URI = '/api/v1/auth/sign-up';
  static const String REFERRAL_CODE_DETAIL_URI = '/api/v1/auth/referral-info';
  static const String PRIME_MEMBER_URI = '/api/v1/user/prime-member';
  static const String CHECK_USER_CAN_SHARE_APP_URI = '/api/v1/auth/share-link';
  static const String CUSTOMER_IDENTITY_URI = '/api/v1/auth/customer-identity';
  static const String PRIME_FAMILY_MEMBER_URI = '/api/v1/auth/prime-family-members/';
  static const String PRIME_PAYMENT_FROM_WALLET_URI = '/api/v1/auth/prime-membership-payment/';
  static const String LOGIN_URI = '/api/v1/auth/login';
  static const String TOKEN_URI = '/api/v1/customer/cm-firebase-token';
  static const String PLACE_ORDER_URI = '/api/v1/customer/order/place';
  static const String ADDRESS_LIST_URI = '/api/v1/customer/address/list';
  static const String ZONE_URI = '/api/v1/config/get-zone-id';
  static const String REMOVE_ADDRESS_URI = '/api/v1/customer/address/delete?address_id=';
  static const String ADD_ADDRESS_URI = '/api/v1/customer/address/add';
  static const String UPDATE_ADDRESS_URI = '/api/v1/customer/address/update/';
  static const String SET_MENU_URI = '/api/v1/items/set-menu';
  static const String CUSTOMER_INFO_URI = '/api/v1/customer/info';
  static const String COUPON_URI = '/api/v1/coupon/list';
  static const String COUPON_APPLY_URI = '/api/v1/coupon/apply?code=';
  static const String RUNNING_ORDER_LIST_URI = '/api/v1/customer/order/running-orders';

  static const String HISTORY_ORDER_LIST_URI = '/api/v1/customer/order/list';
  static const String ORDER_CANCEL_URI = '/api/v1/customer/order/cancel';
  static const String COD_SWITCH_URL = '/api/v1/customer/order/payment-method';
  static const String ORDER_DETAILS_URI = '/api/v1/customer/order/details?order_id=';
  static const String WISH_LIST_GET_URI = '/api/v1/customer/wish-list';
  static const String ADD_WISH_LIST_URI = '/api/v1/customer/wish-list/add?';
  static const String REMOVE_WISH_LIST_URI = '/api/v1/customer/wish-list/remove?';
  static const String NOTIFICATION_URI = '/api/v1/customer/notifications';
  static const String UPDATE_PROFILE_URI = '/api/v1/customer/update-profile';


  static const String UPDATE_PRIME_DOCUMENTS_URI = '/api/v1/auth/update-prime-members-details';
  static const String UPI_SCREENSHOT_URI = '/api/v1/auth/prime-member/upi-screen-shot-upload';
  static const String UPI_PAYMENT_APPROVE_URI = '/api/v1/auth/prime-member/approve-payment';
  static const String UPI_PAYMENTS_LIST_URI = '/api/v1/auth/prime-member/upi-payments';
  static const String UPI_SCREENSHOT_RECHARGE_URI = '/api/v1/auth/recharge/upi-screen-shot-upload';
  static const String PRIME_DOCUMENTS_URI = '/api/v1/auth/store-prime-members';
  static const String SEARCH_URI = '/api/v1/';
  static const String PRIME_MEMBER_SEARCH_URI = '/api/v1/auth/prime-member-search';
  static const String PRIME_MEMBER_ORDER_ID_URI = '/api/v1/auth/prime-membership-order-id';
  static const String PRIME_MEMBER_ORDER_STATUS_URI = '/api/v1/auth/prime-membership-order-status';
  static const String WALLET_RECHARGE_ORDER_STATUS_URI = '/api/v1/auth/wallet-recharge/order-status';
  static const String REVIEW_URI = '/api/v1/items/reviews/submit';
  static const String ITEM_DETAILS_URI = '/api/v1/items/details/';
  static const String LAST_LOCATION_URI = '/api/v1/delivery-man/last-location?order_id=';
  static const String DELIVER_MAN_REVIEW_URI = '/api/v1/delivery-man/reviews/submit';
  static const String STORE_URI = '/api/v1/stores/get-stores';
  static const String POPULAR_STORE_URI = '/api/v1/stores/popular';
  static const String LATEST_STORE_URI = '/api/v1/stores/latest';
  static const String STORE_DETAILS_URI = '/api/v1/stores/details/';
  static const String BASIC_CAMPAIGN_URI = '/api/v1/campaigns/basic';
  static const String ITEM_CAMPAIGN_URI = '/api/v1/campaigns/item';
  static const String BASIC_CAMPAIGN_DETAILS_URI = '/api/v1/campaigns/basic-campaign-details?basic_campaign_id=';
  static const String INTEREST_URI = '/api/v1/customer/update-interest';
  static const String SUGGESTED_ITEM_URI = '/api/v1/customer/suggested-items';
  static const String STORE_REVIEW_URI = '/api/v1/stores/reviews';
  static const String DISTANCE_MATRIX_URI = '/api/v1/config/distance-api';
  static const String SEARCH_LOCATION_URI = '/api/v1/config/place-api-autocomplete';
  static const String PLACE_DETAILS_URI = '/api/v1/config/place-api-details';
  static const String GEOCODE_URI = '/api/v1/config/geocode-api';
  static const String SOCIAL_LOGIN_URL = '/api/v1/auth/social-login';
  static const String SOCIAL_REGISTER_URL = '/api/v1/auth/social-register';

  static const String UPDATE_ZONE_URL = '/api/v1/customer/update-zone';
  static const String MODULES_URI = '/api/v1/module';
  static const String PRIME_EVENT_BANNER_URI = '/api/v1/prime-event-banner';
  static const String PARCEL_CATEGORY_URI = '/api/v1/parcel-category';
  static const String ABOUT_US_URI = '/api/v1/about-us';
  static const String PRIME_BENEFITS_URI = '/api/v1/prime-member-benefits';
  //static const String PRIVACY_POLICY_URI = '/privacy-policy';
  static const String PRIVACY_POLICY_URI = '/api/v1/privacy-policy';
  static const String TERMS_AND_CONDITIONS_URI = '/api/v1/terms-and-conditions';
  static const String CANCELATION_URI = '/api/v1/cancelation';
  static const String REFUND_URI = '/api/v1/refund';
  static const String SHIPPING_POLICY_URI = '/api/v1/shipping-policy';
  static const String SUBSCRIPTION_URI = '/api/v1/newsletter/subscribe';
  static const String CUSTOMER_REMOVE = '/api/v1/customer/remove-account';
  static const String WALLET_RECHARGE_ORDER_ID_URL = '/api/v1/auth/wallet-recharge/order';
  static const String WALLET_TRANSACTION_URL = '/api/v1/customer/wallet/transactions';
  static const String WALLET_STATEMENT_URL = '/api/v1/auth/wallet-statement';
  static const String WALLET_CLOSING_URL = '/api/v1/auth/wallet/closing';
  static const String REVENUE_STATEMENT_URL = '/api/v1/auth/revenue-collection';
  static const String REGISTERED_USERS_URL = '/api/v1/auth/all-members';
  static const String LOYALTY_TRANSACTION_URL     = '/api/v1/customer/loyalty-point/transactions';
  static const String LOYALTY_POINT_TRANSFER_URL = '/api/v1/customer/loyalty-point/point-transfer';
  static const String WALLET_AMOUNT_TRANSFER_URL = '/api/v1/auth/wallet-transfer';
  static const String WALLET_AMOUNT_WITHDRAWAL_URL = '/api/v1/auth/withdrawal-requests/store';
  static const String CUSTOMER_ALL_TRANSFER_URL = '/api/v1/auth/customer-all-transfer';
  static const String WALLET_WITHDRAWAL_REQUEST_LIST_URL = '/api/v1/auth/withdrawal-requests/list';
  static const String SHARE_LINK_LIST_URL = '/api/v1/auth/share-link/list';
  static const String ZONE_LIST_URI = '/api/v1/zone/list';
  static const String STORE_REGISTER_URI = '/api/v1/auth/vendor/register';
  static const String DM_REGISTER_URI = '/api/v1/auth/delivery-man/store';
  static const String REFUND_REASONS_URI = '/api/v1/customer/order/refund-reasons';
  static const String REFUND_REQUEST_URI = '/api/v1/customer/order/refund-request';

  // KEY FOR API
  static const int ALL = 0;
  static const int FEATURED = 1;
  static const int POPULAR = 2;
  static const String PARENT = 'parent';
  static const String CHILD = 'child';


  //MESSAGING
  static const String CONVERSATION_LIST_URI = '/api/v1/customer/message/list';
  static const String SEARCH_CONVERSATION_LIST_URI = '/api/v1/customer/message/search-list';
  static const String MESSAGE_LIST_URI = '/api/v1/customer/message/details';
  static const String SEND_MESSAGE_URI = '/api/v1/customer/message/send';

  // Shared Key
  static const String THEME = 'Bhavya_theme';
  static const String TOKEN = 'Bhavya_token';
  static const String COUNTRY_CODE = 'Bhavya_country_code';
  static const String LANGUAGE_CODE = 'Bhavya_language_code';
  static const String CART_LIST = 'Bhavya_cart_list';
  static const String RECENT_VIEW_LIST = 'recent_view_list';
  static const String USER_PASSWORD = 'Bhavya_user_password';
  static const String USER_ADDRESS = 'Bhavya_user_address';
  static const String USER_NUMBER = 'Bhavya_user_number';
  static const String USER_PRIME = 'Bhavya_user_prime';
  static const String CLIENT_REFERRAL_CODE = 'client_referral_code';
  static const String USER_COUNTRY_CODE = 'Bhavya_user_country_code';
  static const String NOTIFICATION = 'Bhavya_notification';
  static const String SEARCH_HISTORY = 'Bhavya_search_history';
  static const String INTRO = 'Bhavya_intro';
  static const String NOTIFICATION_COUNT = 'Bhavya_notification_count';

  static const String TOPIC = 'all_zone_customer';
  static const String ZONE_ID = 'zoneId';
  static const String MODULE_ID = 'moduleId';
  static const String LOCALIZATION_KEY = 'X-localization';
  static const String LATITUDE = 'latitude';
  static const String LONGITUDE = 'longitude';
  static const String imgPlacement_top = 'top';
  static const String imgPlacement_bottom = 'bottom';
  static const String imgPlacement_before_header = 'before_header';
  static const String imgPlacement_after_header = 'after_header';
  static const String imgPlacement_before_body_text = 'before_body_text';
  static const String imgPlacement_after_body_text = 'after_body_text';

  //top
  // bottom
  // before_header
  // after_header
  // before_body_text
  // after_body_text
  // Delivery Tips
  static List<int> tips = [0, 5, 10, 15, 20, 30, 50];

  static List<ChooseUsModel> whyChooseUsList = [
    ChooseUsModel(icon: Images.landing_trusted, title: 'trusted_by_customers_and_store_owners'),
    ChooseUsModel(icon: Images.landing_stores, title: 'thousands_of_stores'),
    ChooseUsModel(icon: Images.landing_excellent, title: 'excellent_shopping_experience'),
    ChooseUsModel(icon: Images.landing_checkout, title: 'easy_checkout_and_payment_system'),
  ];

  static InputDecoration dropDownDecoration (){
    return InputDecoration(
      enabledBorder: OutlineInputBorder(
        borderRadius: BorderRadius.circular(10),
        borderSide: const BorderSide(color: Colors.grey,width: 0.5),
      ), focusedBorder: OutlineInputBorder(
      borderRadius: BorderRadius.circular(10),
      borderSide: const BorderSide(color: Colors.grey,width: 0.5),
    ),
    );
  }
  static List<LanguageModel> languages = [
    LanguageModel(imageUrl: Images.english, languageName: 'English', countryCode: 'US', languageCode: 'en'),
   // LanguageModel(imageUrl: Images.arabic, languageName: 'عربى', countryCode: 'SA', languageCode: 'ar'),
    LanguageModel(imageUrl: Images.hindi, languageName: 'हिंदी', countryCode: 'IN', languageCode: 'hi'),
  ];


  static dynamic checkDoubleTypeKey(dynamic key){
    if(key==null){
      return null;
    }else{
      double.parse(key);
    }

  }


  static dynamic checkIntTypeKey(dynamic key){
    if(key==null){
      return null;
    }else{
      int.parse(key);
    }

  }

  static const white= Color(0xFFFFFFFF);
  static const app_grey= Color(0xFF1C1B1F);
  static const black= Color(0xff000000);
  static const card_2= Color(0xff8f1b70);


  static void printLongString(String text) {
    if(Foundation.kDebugMode) {
      final RegExp pattern = RegExp('.{1,800}'); // 800 is the size of each chunk
      pattern.allMatches('printLongString $text').forEach((RegExpMatch match) =>   print(match.group(0)));

    }

  }

  static double saving(Item item) {
   return item.price-PriceConverter.convertWithDiscount(item.price,
       item.discount,
       item.discountType);

  }
  static BoxDecoration customBoxDecoration(BuildContext context) {
   return BoxDecoration(
     color: Theme.of(context).cardColor,
     border: Border.all(color: Colors.grey,width: 0.5),
     borderRadius: BorderRadius.circular(Dimensions.RADIUS_DEFAULT),
     boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
   );

  }

  static String appUrl() {


    if(Foundation.kDebugMode) {
      //https://webapp.malagroup.org/privacy-policy
      return 'https://webapp.malagroup.org';
    } else {
      return 'https://webapp.malagroup.org';
    }
  }
  static String paymentUrl({String userId , String orderId , String type}) {

    return '/process-payment?customer_id=$userId&order_id=$orderId&order_type=$type';
  }
}
