import 'package:get/get.dart';

class Dimensions {
  static double fontSizeExtraSmall = Get.context.width >= 1300 ? 14 : 10;
  static double fontSizeSmall = Get.context.width >= 1300 ? 16 : 12;
  static double fontSizeDefault = Get.context.width >= 1300 ? 18 : 14;
  static double fontSizeLarge = Get.context.width >= 1300 ? 20 : 16;
  static double fontSizeExtraLarge = Get.context.width >= 1300 ? 22 : 18;
  static double fontSizeExtraExtraLarge = Get.context.width >= 1300 ? 28 : 24;
  static double fontSizeExtraExtraLarge2 = Get.context.width >= 1300 ? 32 : 28;
  static double fontSizeOverLarge = Get.context.width >= 1300 ? 28 : 24;

  static const double PADDING_SIZE_EXTRA_SMALL = 5.0;
  static const double PADDING_SIZE_SMALL = 10.0;
  static const double PADDING_SIZE_DEFAULT = 15.0;
  static const double PADDING_SIZE_LARGE = 20.0;
  static const double PADDING_SIZE_EXTRA_LARGE = 25.0;

  static const double RADIUS_SMALL = 5.0;
  static const double BORDER_WIDTH_FOR_CONTAINER = 1.5;
  static const double RADIUS_DEFAULT = 10.0;
  static const double RADIUS_LARGE = 15.0;
  static const double RADIUS_EXTRA_LARGE = 20.0;

  static const double WEB_MAX_WIDTH = 1170;
  static const int MESSAGE_INPUT_LENGTH = 250;


  static const double mainAxisSpacing_mobile = 0.0;
  static const double mainAxisSpacing_Desktop_Tab = 0.0;
  static const double gridPadding = 0.0;
  static const double childAspectRatio_Mobile = (1/0.65);
  static const double childAspectRatio_Desktop = (1/1);
  static const double childAspectRatio_Tab_widthMoreThan950 = (1/1);
  static const double childAspectRatio_Tab_widthLessThan950 = (1/0.8);

  static const int crossAxisCount_Desktop = 4;
  static const int crossAxisCount_Tab_widthMoreThan950 = 3;
  static const int crossAxisCount_Tab_widthLessThan950 = 2;
  static const int crossAxisCount_Mobile = 1;


}
