import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:shimmer_animation/shimmer_animation.dart';

import '../../controller/splash_controller.dart';
import '../../util/dimensions.dart';
import '../../util/images.dart';
class BannerShimmer extends StatelessWidget {
  final bool isEnabled;
  final BuildContext context;
  BannerShimmer({@required this.isEnabled , @required this.context});

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.all(8.0),
      child: Shimmer(
        duration: Duration(seconds: 2),
        enabled: isEnabled,
        child: Container(
          decoration: BoxDecoration(
            color: Theme.of(context).cardColor,
            borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
            boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
          ),
          child: ClipRRect(
            borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
            child: GetBuilder<SplashController>(builder: (splashController) {
              return Image.asset(
                Images.placeholder, width: context.width, height: 120, fit: BoxFit.cover,
              );
            }),
          ),
        ),
      ),
    );
  }

}