import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_image.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:url_launcher/url_launcher_string.dart';
import '../../data/model/response/banner_model.dart';
import '../../data/model/response/brand_model.dart';
import '../../data/model/response/category_model.dart';
import '../../helper/route_helper.dart';
import '../../util/app_constants.dart';
import 'custom_snackbar.dart';


class BannerWidget extends StatelessWidget {
  final Bannr bannerItem;
  final String bannerType;

  BannerWidget({@required this.bannerItem,@required this.bannerType,});

  @override
  Widget build(BuildContext context) {


    String _baseUrl = Get.find<SplashController>().configModel.baseUrls.bannerImageUrl;

    return InkWell(
      onTap: ()  {
        Get.toNamed(RouteHelper.getAllProductsRoute(bannerType=='todays_offers'.tr?'todays_offers'.tr : 'Offers'));
      },
      child: Container(
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(Dimensions.RADIUS_EXTRA_LARGE),
          boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
        ),
        child: ClipRRect(
          borderRadius: BorderRadius.circular(Dimensions.RADIUS_EXTRA_LARGE),
          child: GetBuilder<SplashController>(builder: (splashController) {
            return CustomImage(
              image: '$_baseUrl/${bannerItem.image}',
              fit: BoxFit.fill,
            );
          }),
        ),
      ),
    );
  }
}
