import 'dart:async';

import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_image.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../data/model/response/brand_model.dart';
import '../../data/model/response/category_model.dart';
import '../../helper/responsive_helper.dart';
import '../../util/app_constants.dart';


// class CategoriesWidget extends StatelessWidget {
//   final CategoryModel catItem;
//   final Brands brandItem;
//   final bool isBrand;
//   final int index;
//   final int length;
//
//   CategoriesWidget({@required this.catItem,@required this.brandItem, @required this.isBrand, @required this.index,
//     @required this.length});
//
//
//
//
//
//
//   @override
//   Widget build(BuildContext context) {
//
//
//     String _baseUrl = Get.find<SplashController>().configModel.baseUrls.commonImageUrl;
//
//     return Column(
//       mainAxisAlignment: MainAxisAlignment.start,
//       crossAxisAlignment: CrossAxisAlignment.center,
//       children: [
//
//         Container(width: context.width,
//           height: context.width*0.34,
//           // width: 87,
//           decoration: BoxDecoration(
//             // color: Theme.of(context).cardColor,
//             color: AppConstants.catItemBG.withAlpha(50),
//             borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//             boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], blurRadius: 5, spreadRadius: 1)],
//           ),
//
//           child: Center(
//             child: Padding(
//               padding: const EdgeInsets.all(0.0),
//               child: ClipRRect(
//                 borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//                 child: CustomImage(
//                   height: context.height, width: context.width, fit: BoxFit.fill,
//                   image:
//                   // index==0?
//                   // 'https://cdn01.pharmeasy.in/dam/products_otc/080200/friends-easy-adult-diapers-tape-style-high-absorbency-anti-bacterial-core-10-count-m-waist-2756-4921-inch-3-1669655434.jpg'
//                   //     : index==1? 'https://static.vecteezy.com/system/resources/previews/008/316/318/original/air-freshener-sticks-isolated-on-beige-background-aroma-sticks-and-essential-oil-bottle-for-relaxation-free-photo.jpg'
//                   //     : index==2? 'https://healthyhome.co.in/cdn/shop/products/2_d6e52d09-cb74-4103-8e7c-22f43ad7862f_1024x1024.jpg?v=1623141322'
//                   //     : index==3? 'https://www.aashirvaad.com/img/aashirvad-atta-center-all-packets.jpg'
//                   //     : index==4? 'https://5.imimg.com/data5/UH/RN/OK/SELLER-3121225/fmcg-baby-care-products-under-ayurvedic-medicated-category-500x500.jpg'
//                   //     : index==5? 'https://5.imimg.com/data5/UH/RN/OK/SELLER-3121225/fmcg-baby-care-products-under-ayurvedic-medicated-category-500x500.jpg'
//                   //     : index==6? 'https://post.healthline.com/wp-content/uploads/2022/04/UPDATE_1809308-The-Best-Baby-Food-Jars-Pouches-Organic-and-More-732x549-Feature.jpg'
//                   //     : index==7? 'https://media.allure.com/photos/627415e4c6e37cc6b02dff4a/1:1/w_2000,h_2000,c_limit/5-05%20best%20body%20washes.jpg'
//                   //     :
//                   '$_baseUrl/${isBrand ? brandItem.image : catItem.image}',
//                 ),
//               ),
//             ),
//           ),
//         ),
//
//         SizedBox(height: Dimensions.PADDING_SIZE_DEFAULT),
//
//         Expanded(child: Text(
//           isBrand ? brandItem.name : catItem.name , textAlign: TextAlign.center,
//           style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeDefault),
//           maxLines: 2, overflow: TextOverflow.clip,
//         )),
//       ],
//     );
//   }
// }


class CategoriesWidget extends StatefulWidget {
  final CategoryModel catItem;
  final Brands brandItem;
  final bool isBrand;
  final int index;
  final int length;

  CategoriesWidget({@required this.catItem,@required this.brandItem, @required this.isBrand, @required this.index,
    @required this.length});

  @override
  State<CategoriesWidget> createState() => _CategoriesWidgetState();
}

class _CategoriesWidgetState extends State<CategoriesWidget> {
  var counter = 0;
  List<Color> get getColorsList => [
    // Colors.yellow[300],
    // Colors.yellow[100],
    // Colors.cyan[300],
    // Colors.yellow[400],

    // Colors.grey[100],
    // Colors.grey[200],
    Colors.grey[300],
    Colors.blueGrey[500],

  ]..shuffle();


  /// Generate list of alignment which will be used to
  /// set gradient start and end for random color animation.
  List<Alignment> get getAlignments => [
    Alignment.bottomLeft,
    Alignment.bottomRight,
    Alignment.topRight,
    Alignment.topLeft,
  ];

  _startBgColorAnimationTimer() {
    ///Animating for the first time.
    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      counter++;
      setState(() {});
    });

    const interval = Duration(seconds: 5);
    Timer.periodic(
      interval,
          (Timer timer) {
        counter++;
        setState(() {});
      },
    );
  }

  @override
  void initState() {
    super.initState();
   // _startBgColorAnimationTimer();
  }

  @override
  Widget build(BuildContext context) {
    bool _desktop   =   ResponsiveHelper.isDesktop(context);
    bool _isTab     =   ResponsiveHelper.isTab(context);
    bool _isWeb     =   ResponsiveHelper.isWeb();
    bool _isMobile  =   ResponsiveHelper.isMobile(context);

    double screenWidth = MediaQuery.of(context).size.width;

    //print("testResponsiveHelper CategoriesViewSonu _desktop $_desktop _isTab $_isTab isWeb $_isWeb _isMobile $_isMobile");

    String _baseUrl = Get.find<SplashController>().configModel.baseUrls.commonImageUrl;
    // return ClipRRect(
    //     borderRadius: BorderRadius.circular(Dimensions.RADIUS_EXTRA_LARGE,)
    //     ,child: Container(
    //   color: Colors.black.withOpacity(0.4),
    //   child: Column(
    //
    //     mainAxisAlignment: MainAxisAlignment.start,
    //     crossAxisAlignment: CrossAxisAlignment.center,
    //     children: [
    //
    //       CustomImage(
    //         height: context.width*0.45, width: context.width, fit: BoxFit.fill,
    //         image: '$_baseUrl/${widget.isBrand ? widget.brandItem.image : widget.catItem.image}',
    //       ),
    //
    //       SizedBox(height: Dimensions.PADDING_SIZE_DEFAULT),
    //
    //       Expanded(child: Text(
    //         widget.isBrand ? widget.brandItem.name : widget.catItem.name , textAlign: TextAlign.center,
    //         style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeDefault),
    //         maxLines: 2, overflow: TextOverflow.clip,
    //       )),
    //     ],
    //   ),
    // ));
    return ClipRRect(borderRadius: BorderRadius.circular(Dimensions.RADIUS_EXTRA_LARGE),child:
    Container(
      color: Colors.grey[300],
      child: Column(

        mainAxisAlignment: MainAxisAlignment.start,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [

          CustomImage(
            height : _desktop ? screenWidth*0.15 : _isTab? screenWidth*0.20 :   screenWidth*0.45,
            width:  context.width, fit: BoxFit.fill,
            image: '$_baseUrl/${widget.isBrand ? widget.brandItem.image : widget.catItem.image}',
          ),


          Expanded(child: Center(
            child: Text(
              widget.isBrand ? widget.brandItem.name : widget.catItem.name , textAlign: TextAlign.center,
              style: robotoRegular.copyWith(fontSize: _desktop ? Dimensions.fontSizeExtraLarge : _isTab ? Dimensions.fontSizeLarge : Dimensions.fontSizeDefault),
              maxLines: 2, overflow: TextOverflow.clip,
            ),
          )),
        ],
      ),
    )
    // Stack(
    //   children: [
    //     // AnimatedContainer(
    //     //   width: MediaQuery.of(context).size.width,
    //     //   height: MediaQuery.of(context).size.height,
    //     //   decoration: BoxDecoration(
    //     //     gradient: LinearGradient(
    //     //       begin: getAlignments[counter % getAlignments.length],
    //     //       end: getAlignments[(counter + 2) % getAlignments.length],
    //     //       colors: getColorsList,
    //     //       tileMode: TileMode.clamp,
    //     //     ),
    //     //   ),
    //     //   duration: const Duration(seconds: 4),
    //     // ),
    //     Container(
    //       color: Colors.grey,
    //       child: SizedBox(),
    //     ),
    //   ],
    // )
    );
  }
}

