import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:shimmer_animation/shimmer_animation.dart';
import '../../util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';



class CircularImageListForShimmer extends StatelessWidget {
  final bool isEnabled;
  final String title;
  CircularImageListForShimmer({@required this.isEnabled , @required this.title});

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Padding(
          padding: EdgeInsets.only(left: 10,right: 10),
          child: Text(title, style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge)),
        ),
        SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
        SizedBox(
          height: 100,
          child: ListView.builder(
            controller: ScrollController(),
            physics: BouncingScrollPhysics(),
            scrollDirection: Axis.horizontal,
            itemCount: 8,

            itemBuilder: (context, index) {
              return Shimmer(
                duration: Duration(seconds: 2),
                enabled: isEnabled,
                child: SizedBox(
                  width: 100,
                  child: Column(children: [
                    Container(
                      height: 70,
                      width: 70,

                      margin: EdgeInsets.only(
                        left: index == 0 ? 0 : Dimensions.PADDING_SIZE_EXTRA_SMALL,
                        right: Dimensions.PADDING_SIZE_EXTRA_SMALL,
                      ),
                      child: Stack(children: [
                        Container(
                          width: 70.0,
                          height: 70.0,
                          decoration: BoxDecoration(
                            borderRadius: BorderRadius.all( Radius.circular(50.0)),
                            border: Border.all(
                              color: Theme.of(context).dividerColor,
                              width: 1.0,
                            ),
                          ),
                        ),

                      ]),
                    ),
                  ]),
                ),
              );
            },
          ),
        ),
      ],
    );
  }
}