import 'package:shimmer_animation/shimmer_animation.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../util/styles.dart';

class ItemShimmer extends StatelessWidget {
  final bool isEnabled;
  final bool isStore;

  ItemShimmer({@required this.isEnabled, this.isStore = false});

  @override
  Widget build(BuildContext context) {
    bool _desktop = ResponsiveHelper.isDesktop(context);

    return Container(
      height: 220,
      width: 180,
      decoration: BoxDecoration(
        borderRadius: BorderRadius.circular(Dimensions.RADIUS_DEFAULT),
        color: Theme.of(context).backgroundColor,
        boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 700 : 200], spreadRadius: 1, blurRadius: 5)],
      ),
      child: Shimmer(
        duration: Duration(seconds: 2),
        enabled: isEnabled,
        child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisAlignment: MainAxisAlignment.center, children: [

          Stack(children: [
            Container(

              decoration: BoxDecoration(
                borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                color: Colors.grey[300],
              ),
            ),
            Positioned(
              right: Dimensions.PADDING_SIZE_EXTRA_SMALL,
              child: Padding(
                padding: EdgeInsets.symmetric(vertical: 0),
                child: Icon(
                  Icons.favorite_border,  size:20,
                  color:Theme.of(context).primaryColor.withAlpha(200),
                ),
              ),
            ),
          ]),

          Expanded(
            child: Stack(children: [
              Padding(
                padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
                child: Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.stretch, children: [
                  Container(height: 15, width: 100, color: Colors.grey[300]),
                  SizedBox(height: 2),

                  Container(height: 10, width: 70, color: Colors.grey[300]),
                  SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),

                  Row(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.end, children: [
                    Container(height: 10, width: 40, color: Colors.grey[300]),
                    SizedBox(width: Dimensions.PADDING_SIZE_EXTRA_SMALL),
                    Container(height: 15, width: 40, color: Colors.grey[300]),
                  ]),
                ]),
              ),
              // Positioned(bottom: 0, right: 0, child: Container(
              //   height: 25, width: 25,
              //   decoration: BoxDecoration(
              //       shape: BoxShape.circle,
              //       color: Theme.of(context).primaryColor
              //   ),
              //   child: Icon(Icons.add, size: 20, color: Colors.white),
              // )),
              Positioned(bottom: 0, right: 0, child: Container(

                decoration: BoxDecoration(
                  color: Theme.of(context).primaryColor.withAlpha(30),
                  // backgroundBlendMode: BlendMode.darken,
                  borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                  border: Border.all(
                    color: Theme.of(context).primaryColor,
                    width: 0.8,
                  ),),
                child: Padding(
                  padding: const EdgeInsets.symmetric(vertical: 5,horizontal: 20),
                //  child: Text('ADD',style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraSmall)),
                  child : Text('',style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraSmall)),
                ),
              )),
            ]),
          ),

        ]),
      ),
    );
  }
}
