
import 'package:sixam_mart/controller/auth_controller.dart';
import 'package:sixam_mart/controller/item_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/controller/wishlist_controller.dart';
import 'package:sixam_mart/data/model/body/place_order_body.dart';
import 'package:sixam_mart/data/model/response/config_model.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/data/model/response/module_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';
import 'package:sixam_mart/helper/price_converter.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_image.dart';
import 'package:sixam_mart/view/base/custom_snackbar.dart';
import 'package:sixam_mart/view/base/discount_tag.dart';
import 'package:sixam_mart/view/base/not_available_widget.dart';
import 'package:sixam_mart/view/base/rating_bar.dart';
import 'package:sixam_mart/view/screens/store/store_screen.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../controller/cart_controller.dart';
import '../../controller/theme_controller.dart';
import '../../data/model/response/cart_model.dart';
import '../../util/images.dart';
import 'add_item_button_widget.dart';
import 'cart_snackbar.dart';
import 'mrp_and_save_view.dart';
import 'mrp_selling_diff_view.dart';
// class ItemWidget extends StatelessWidget {
//   final Item item;
//   final Store store;
//
//   final bool isStore;
//   final int index;
//   final int length;
//   final bool inStore;
//   final bool isCampaign;
//   final bool isFeatured;
//   final bool isRecentViewItem;
//   ItemWidget({@required this.item, @required this.isStore, @required this.store, @required this.index,
//    @required this.length, this.inStore = false, this.isCampaign = false, this.isFeatured = false, this.isRecentViewItem = false});
//
//   @override
//   Widget build(BuildContext context) {
//     double getStartingPrice(Item item) {
//       double _startingPrice = 0;
//       if (item.choiceOptions!=null && item.choiceOptions.length != 0) {
//         List<double> _priceList = [];
//         item.variations.forEach((variation) => _priceList.add(variation.price));
//         _priceList.sort((a, b) => a.compareTo(b));
//         _startingPrice = _priceList[0];
//       } else {
//         _startingPrice = item.price;
//       }
//       return _startingPrice;
//     }
//
//     double getDiscount(Item item) => item.discount==null?0 : item.discount;
//
//     String getDiscountType(Item item) => item.storeDiscount == 0 ? item.discountType : 'percentage';
//
//     BaseUrls _baseUrls = Get.find<SplashController>().configModel.baseUrls;
//     bool _desktop = ResponsiveHelper.isDesktop(context);
//     double _discount;
//     String _discountType;
//     bool _isAvailable;
//     if(isStore) {
//       _discount = store.discount != null ? store.discount.discount : 0;
//       _discountType = store.discount != null ? store.discount.discountType : 'percentage';
//       _isAvailable = store.open == 1 && store.active;
//     }
//     else {
//       _discount = (item.storeDiscount == 0 || isCampaign) ? item.discount : item.storeDiscount;
//       _discountType = (item.storeDiscount == 0 || isCampaign) ? item.discountType : 'percentage';
//       _isAvailable = (item.stock>0 && item.isInactive==0);
//     }
//
//   // var saving=  item.price-PriceConverter.convertWithDiscount(item.price, item.discount, item.discountType);
//    var saving=  AppConstants.saving(item);
//     return InkWell(
//       onTap: () {
//         if(isStore) {
//           if(store != null) {
//             if(isFeatured && Get.find<SplashController>().moduleList != null) {
//               for(ModuleModel module in Get.find<SplashController>().moduleList) {
//                 if(module.id == store.moduleId) {
//                   Get.find<SplashController>().setModule(module);
//                   break;
//                 }
//               }
//             }
//             Get.toNamed(
//               RouteHelper.getStoreRoute(store.id, isFeatured ? 'module' : 'item'),
//               arguments: StoreScreen(store: store, fromModule: isFeatured),
//             );
//           }
//         }
//         else {
//           if(!isRecentViewItem){
//             Get.find<CartController>().addToRecentView(item);
//           }
//           Get.find<ItemController>().navigateToItemPage(item, context, inStore: inStore, isCampaign: isCampaign);
//
//         }
//       },
//       child: Container(
//         decoration: isRecentViewItem ? BoxDecoration(
//             color: Theme.of(context).cardColor,
//             borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//             border: Border.all(
//               color: Colors.green,
//               width: 1.0,
//             )
//
//         )
//             : BoxDecoration(
//           color: Theme.of(context).cardColor,
//           borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//           border: Border.all(
//             color: Theme.of(context).dividerColor,
//             width: 1.0,
//           ),),
//
//
//         child: Column(
//             crossAxisAlignment: CrossAxisAlignment.center,
//             mainAxisAlignment: MainAxisAlignment.center,
//             children: [
//
//               Container(
//                 child: Stack( children: [
//                   Center(
//                     child: ClipRRect(
//                       borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
//                       child: CustomImage(
//                         image: '${isCampaign ? _baseUrls.campaignImageUrl : isStore ? _baseUrls.storeImageUrl
//                             : _baseUrls.commonImageUrl}'
//                             '/${isStore ? store.logo : item.image}',
//                         height: 98, width: 95, fit: BoxFit.cover,
//                       ),
//                     ),
//                   ),
//                   Positioned(
//                     right: Dimensions.PADDING_SIZE_EXTRA_SMALL,
//                     child: GetBuilder<WishListController>(builder: (wishController) {
//                       bool _isWished = wishController.wishItemIdList.contains(item.id);
//                       return InkWell(
//                         onTap: () {
//                           if(Get.find<AuthController>().isLoggedIn()) {
//                             _isWished ? wishController.removeFromWishList( item.id, false)
//                                 : wishController.addToWishList(item, null, false);
//                           }else {
//                             showCustomSnackBar('you_are_not_logged_in'.tr);
//                           }
//                         },
//                         child: Padding(
//                           padding: EdgeInsets.symmetric(vertical: _desktop ? Dimensions.PADDING_SIZE_SMALL : 0),
//                           child: Icon(
//                             _isWished ? Icons.favorite : Icons.favorite_border,  size: _desktop ? 30 : _isWished ? 25 :20,
//                             color: _isWished ? Theme.of(context).primaryColor : Theme.of(context).disabledColor,
//                           ),
//                         ),
//                       );
//                     }),
//                   ),
//                   // Positioned(
//                   //   right:  Dimensions.PADDING_SIZE_EXTRA_SMALL,
//                   //   child: GetBuilder<WishListController>(builder: (wishController) {
//                   //     bool _isWished = wishController.wishItemIdList.contains(item.id);
//                   //     return InkWell(
//                   //       onTap: () {
//                   //         if(Get.find<AuthController>().isLoggedIn()) {
//                   //           _isWished ? wishController.removeFromWishList( item.id, false)
//                   //               : wishController.addToWishList(item, null, false);
//                   //         }else {
//                   //           showCustomSnackBar('you_are_not_logged_in'.tr);
//                   //         }
//                   //       },
//                   //       child: Padding(
//                   //         padding:EdgeInsets.symmetric(vertical: _desktop ? Dimensions.PADDING_SIZE_SMALL : 0),
//                   //         child: _isWished ? HeartBeat(
//                   //           child: Icon(
//                   //             Icons.favorite ,  size: _desktop ? 30 : 30,
//                   //             color: Theme.of(context).primaryColor ,
//                   //           ),) :
//                   //
//                   //         Icon(Icons.favorite_border,  size: _desktop ? 30 : 22,
//                   //           color: Theme.of(context).disabledColor,
//                   //         ),
//                   //       ),
//                   //     );
//                   //   }),
//                   // ),
//                   DiscountTag(
//                     discount: _discount, discountType: _discountType,
//                     inLeft: true,
//                   ),
//                   _isAvailable ? SizedBox() : NotAvailableWidget(isStore: false),
//
//                 ]),
//               ),
//
//               Expanded(
//                 child: Stack(children: [
//                   Padding(
//                     padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                     child: Column(mainAxisAlignment: MainAxisAlignment.start, crossAxisAlignment: CrossAxisAlignment.stretch, children: [
//                       SizedBox(height: 5),
//                       Text(
//                         item.name ?? '',
//                         style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge),
//                         maxLines: 2, overflow: TextOverflow.ellipsis,
//                       ),
//
//                       SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//
//                       getDiscount(item) > 0  ?
//
//                       MrpAndSaveView(mrpFontSize: 8, saveFontSize: Dimensions.fontSizeLarge,
//                         saving: saving, startingPrice: getStartingPrice(item),)
//                           : MrpSellingDiffView(mrp: item.mrp,price: item.price,),
//
//                       SizedBox(height:  Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                       Text(
//                         PriceConverter.convertPrice(
//                           getStartingPrice(item), discount: getDiscount(item),
//                           discountType: getDiscountType(item),
//                         ),
//                         style: robotoMedium,
//                       ),
//
//                     ]),
//                   ),
//                   // Positioned(bottom: 0, right: 0, child: Container(
//                   //   height: 20, width: 20,
//                   //   decoration: BoxDecoration(
//                   //       shape: BoxShape.circle,
//                   //       color: Theme.of(context).primaryColor
//                   //   ),
//                   //   child: Icon(Icons.add, size: 20, color: Colors.white),
//                   // )),
//                   AddItemButtonWidget(),
//                 ]),
//               ),
//
//             ]),
//       ),);
//   }
// }



class ItemWidget extends StatelessWidget {
  final Item item;
  final Store store;

  final bool isStore;
  final int index;
  final int length;
  final bool inStore;
  final bool isCampaign;
  final bool isFeatured;
  final bool isRecentViewItem;

  ItemWidget({@required this.item, @required this.isStore, @required this.store, @required this.index,
    @required this.length, this.inStore = false, this.isCampaign = false, this.isFeatured = false,
    this.isRecentViewItem = false}
      );




  @override
  Widget build(BuildContext context) {
    double _discount;
    String _discountType;
    bool _isAvailable;
    CartModel itemFromCartOfCurrentIndex;


    List<DiscountRange> discountRange=[];
    var discountPlusQtyBasedDiscount=0.0;

    discountRange.insert(0, DiscountRange(qty: 0,discount: 'Select Qty'));
    discountRange.addAll(item.discountRange);

    if(item.discount!=null && item.discountRange.isNotEmpty){
      // itemFromCartOfCurrentIndex=item;
      discountPlusQtyBasedDiscount=double.parse(item.discountRange[0].discount);
    }
    item.discount=discountPlusQtyBasedDiscount;

    if(isStore) {
      _discount = store.discount != null ? store.discount.discount : 0;
      _discountType = store.discount != null ? store.discount.discountType : 'percentage';
      _isAvailable = store.open == 1 && store.active;
    }
    else {

      _discount = (item.storeDiscount == 0 || isCampaign) ? discountPlusQtyBasedDiscount : item.storeDiscount;
      _discountType = (item.storeDiscount == 0 || isCampaign) ? item.discountType : 'percentage';
      _isAvailable = (item.stock>0 && item.isInactive==0);
    }

    double getStartingPrice(Item item) {
      double _startingPrice = 0;
      if (item.choiceOptions!=null && item.choiceOptions.length != 0) {
        List<double> _priceList = [];
        item.variations.forEach((variation) => _priceList.add(variation.price));
        _priceList.sort((a, b) => a.compareTo(b));
        _startingPrice = _priceList[0];
      } else {
        _startingPrice = item.price;
      }
      return _startingPrice;
    }

    double getDiscount(Item item) => item.discount==null?0 : item.discount;

    String getDiscountType(Item item) => item.storeDiscount == 0 ? item.discountType : 'percentage';



    CartModel returnCurrentItemFromCart(){

      var list = Get.find<CartController>().cartList;
      if(list!=null && list.length>0){

        for(int index=0; index<list.length; index++) {
          //if(list[index].item.id==item.id && list[index].quantity!=null && list[index].quantity>0) {
          if(list[index].item.id==item.id && list[index].quantity!=null) {
            itemFromCartOfCurrentIndex=list[index];
            break;
          }
        }

      }


      return itemFromCartOfCurrentIndex;

    }

    double screenWidth = MediaQuery.of(context).size.width;

    String getMinimumDiscountedPriceOnSingleQty(){
      double discountedPrice=0.0;

      try{
        if(discountRange!=null && discountRange.length>0){
          var _discount=double.parse(discountRange[1].discount);
          discountedPrice = PriceConverter.convertWithDiscount(item.price, _discount, 'percentage');

        }

      }catch(e){
        discountedPrice=0.0;
      }
      return PriceConverter.convertPrice(discountedPrice);
    }
    String getBestPrice(){
      double bestPrice=0.0;

      try{
        if(discountRange!=null && discountRange.length>0){
          var _discount=double.parse(discountRange.last.discount);
          bestPrice = PriceConverter.convertWithDiscount(item.price, _discount, 'percentage');
        }

      }catch(e){
        bestPrice=0.0;
      }

      return PriceConverter.convertPrice(bestPrice);
    }

    bool isBestPriceApplied(){

      bool isBestPriceApplied=false;

      var bestPrice = getBestPrice();
      var ourPrice = item.discountRange!=null && item.discountRange.isNotEmpty && returnCurrentItemFromCart()==null?getMinimumDiscountedPriceOnSingleQty():PriceConverter.convertPrice(returnCurrentItemFromCart().discountedPrice);
      if(bestPrice.trim()==ourPrice.trim()){
        isBestPriceApplied=true;
      }else{
        isBestPriceApplied=false;
      }

      return isBestPriceApplied;
    }

    String getMinimumProfitOnSingleQty(){

      var _discount=double.parse(discountRange[1].discount);
      double discountedPrice = PriceConverter.convertWithDiscountMask(item.price, _discount, 'percentage');

      return PriceConverter.percentageCalculation(item.price, discountedPrice).toString();
    }
    String getMaxProfitOnSingleQty(){
      var discountedPrice=0.0;
      try{
        var _discount = double.parse(discountRange.last.discount);
        discountedPrice = PriceConverter.convertWithDiscountMask(item.price, _discount, 'percentage');

      }catch(e){
        discountedPrice = 0.0;
      }


      return '${PriceConverter.percentageCalculation(item.price, discountedPrice).toString()}%';
    }
    String getMinimumProfitInPriceOnSingleQty(){

      var _discount=double.parse(discountRange[1].discount);

      var ty ='${(item.price-PriceConverter.convertWithDiscount(item.price, _discount, 'percentage')).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
          .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}';
      return ty;
    }

    String totalSavingOnSelectedQty(){
      var totalSavingOnSelectedQty=0.0;
      try{
        if(returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0'){

          var qty =returnCurrentItemFromCart().quantity;
          var price =returnCurrentItemFromCart().discountAmount.toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
              .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},');
          totalSavingOnSelectedQty = double.parse(price) * qty;


        }
      }catch(e){
        totalSavingOnSelectedQty =  0.0;
      }
      return totalSavingOnSelectedQty.toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
          .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},');
    }

    Widget view(BuildContext context){
      bool _desktop = ResponsiveHelper.isDesktop(context);
      bool _isTab = ResponsiveHelper.isTab(context);
      bool _isWeb = ResponsiveHelper.isWeb();
      bool _isMobile = ResponsiveHelper.isMobile(context);
      double screenWidth = MediaQuery.of(context).size.width;

      //print("screenWidthTest  $screenWidth");
      return Center(
        child: Column(

            mainAxisSize: MainAxisSize.max,
            children: [
              SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

              Row(
                mainAxisAlignment: MainAxisAlignment.start,
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Container(
                    padding: const EdgeInsets.all(3.0),
                    decoration: BoxDecoration(
                      border: Border.all(color: Colors.blueGrey.withOpacity(0.1)),
                      borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                    ),
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.center,
                      mainAxisAlignment: MainAxisAlignment.start,
                      children: [
                        ClipRRect(
                          borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                          child: CustomImage(
                            height: _desktop ? 110 : _isTab ? 90 : 70,
                            width: _desktop ? 130 : _isTab ? 110 : 90,
                            fit: BoxFit.cover,
                            image: '${Get.find<SplashController>().configModel.baseUrls.commonImageUrl}'
                                '/${item.image}',
                          ),
                        ),
                        RatingBar(rating: item.avgRating?? 1.0,
                          size: _desktop ? 15 : _isTab ? 12 : 10,
                          ratingCount:  item.ratingCount??5,
                          color: Colors.green,)

                      ],
                    ),
                  ),


                  SizedBox(width: 7,),

                  Expanded(child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [

                      (_discount > 0 && _discount != item.price) ?  Row(
                        children: [

                          Container(
                            decoration: BoxDecoration(
                              color: Colors.orange[100],
                              // backgroundBlendMode: BlendMode.darken,
                              borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL)
                              ,),
                            child: Padding(
                              padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 4),
                              child: Row(
                                mainAxisAlignment: MainAxisAlignment.start,
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: [
                                  Icon(
                                    (item.discountRange!=null && item.discountRange.length>1)? Icons.percent : Icons.discount,  size: 7,
                                    color: Colors.orange[900],
                                  ),
                                  SizedBox(width: 3,),
                                  Text('OFFER',style: robotoRegular.copyWith(fontSize: 9,color: Colors.orange[900])),
                                ],
                              ),
                            ),
                          ),

                          SizedBox(width: Dimensions.PADDING_SIZE_DEFAULT,),

                          Container(
                            decoration: BoxDecoration(
                              color: Colors.indigo[200],
                              // backgroundBlendMode: BlendMode.darken,
                              borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),),
                            child: Padding(
                              padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 4),
                              child: Row(
                                mainAxisAlignment: MainAxisAlignment.start,
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: [
                                  Icon(
                                    Icons.favorite,  size: 7,
                                    color: Colors.indigo,
                                  ),
                                  SizedBox(width: 3,),
                                  Text('BESTSELLER',style: robotoRegular.copyWith(fontSize: 9,color: Colors.indigo)),
                                ],
                              ),
                            ),
                          ),
                        ],
                      )
                          : SizedBox(),

                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
                      Text(
                        item.name ?? '',
                        style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeDefault,color: Colors.black87),
                        maxLines: 2, overflow: TextOverflow.ellipsis,
                      ),
                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
                      Text(
                        item.brandName ?? item.categoryName??'',
                        style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeSmall,color: Colors.grey),
                        maxLines: 2, overflow: TextOverflow.ellipsis,
                      ),

                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),


                    ],
                  )),
                ],),

              SizedBox(height:  _desktop ? Dimensions.PADDING_SIZE_LARGE : Dimensions.PADDING_SIZE_SMALL ,),

              // (_discount > 0 && _discount != item.price)

              Row(mainAxisAlignment:MainAxisAlignment.spaceBetween,children: [
                Container(

                  // width: screenWidth*0.25,
                  decoration: BoxDecoration(
                    border: Border.all(color: Colors.blueGrey.withOpacity(0.1)),
                    borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                  ),

                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Container(
                        padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
                        // width: screenWidth*0.25,
                        decoration: BoxDecoration(
                          color: Colors.grey[200],),
                        child: Text(' ${'mrp_per_piece'.tr}',style:
                        robotoRegular.copyWith(fontSize: 10)),
                      ),

                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 3,horizontal: 7),
                        child: Text(PriceConverter.convertPrice(getStartingPrice(item)),
                            style: robotoMedium.copyWith(fontSize: 10)),
                      ),

                    ],
                  ),
                ),
                Container(

                  // width: screenWidth*0.25,
                  decoration: BoxDecoration(
                    border: Border.all(color: Colors.blueGrey.withOpacity(0.1)),
                    borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                  ),

                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Container(
                        padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
                        // width: screenWidth*0.25,
                        decoration: BoxDecoration(
                          color: Colors.grey[200],),
                        child: Text(' ${'our_price_per_piece'.tr}',style:
                        robotoMedium.copyWith(fontSize: 10)),
                      ),

                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 7),
                        child: Text(
                          '${item.discountRange!=null && item.discountRange.isNotEmpty && returnCurrentItemFromCart()==null? getMinimumDiscountedPriceOnSingleQty() : PriceConverter.convertPrice(returnCurrentItemFromCart().discountedPrice) }',
                          style: robotoMedium.copyWith(fontSize: 12),
                        ),
                      ),

                    ],
                  ),
                ),
                Container(
                  // width: screenWidth*0.40,
                  decoration: BoxDecoration(
                    border: Border.all(color: Colors.green.withOpacity(0.1)),
                    borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                  ),

                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Container(
                        padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
                        // width: screenWidth*0.40,
                        decoration: BoxDecoration(
                          color: Colors.green[50],),
                        child: Text(' ${'profit_margin_per_piece'.tr}',style:
                        robotoRegular.copyWith(fontSize: 12,color: Colors.green[900])),
                      ),

                      SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 7),
                        child: Row(
                          children: [
                            Text(
                              '${returnCurrentItemFromCart()==null?'${getMinimumProfitOnSingleQty()} ':
                              PriceConverter.percentageCalculation(item.price, returnCurrentItemFromCart().discountedPriceMask)} %',
                              style: robotoMedium.copyWith(fontSize: 13,color: Colors.green[900]),
                            ),

                            // Text(
                            //   _discount > 0 ? '$_discount${_discountType == 'percentage' || _discountType == 'percentage' ? '%'
                            //       : Get.find<SplashController>().configModel.currencySymbol} ${'off'.tr}' : 'free_delivery'.tr,
                            //
                            //   style: robotoMedium.copyWith(
                            //       color: Colors.green[900],
                            //       fontSize: 10
                            //     // fontSize: fontSize != null ? fontSize : ResponsiveHelper.isMobile(context) ? 8 : 12,
                            //   ),
                            //   textAlign: TextAlign.center,
                            // ),
                            Text(
                              ' ( ${Get.find<SplashController>().configModel.currencySymbol}'
                                  ' ${ returnCurrentItemFromCart()==null? '${getMinimumProfitInPriceOnSingleQty()}'

                                  : '${returnCurrentItemFromCart().discountAmount.toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
                                  .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'}  ) '
                              ,
                              style: robotoMedium.copyWith(fontSize: 10,color: Colors.green[900]),
                            ),
                            // Text(
                            //   ' ( ${Get.find<SplashController>().configModel.currencySymbol}'
                            //       ' ${(AppConstants.saving(item)).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
                            //       .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')} ) '
                            //   ,
                            //   style: robotoMedium.copyWith(fontSize: 10,color: Colors.green[900]),
                            // ),
                          ],
                        ),
                      ),

                    ],
                  ),
                )
              ],),

              // Row(
              //
              //   mainAxisSize: MainAxisSize.max,
              //   crossAxisAlignment: CrossAxisAlignment.start,
              //   mainAxisAlignment: MainAxisAlignment.start,
              //   children: [
              //
              //     Container(
              //
              //       width: screenWidth*0.25,
              //       decoration: BoxDecoration(
              //         border: Border.all(color: Colors.blueGrey.withOpacity(0.1)),
              //         borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
              //       ),
              //
              //       child: Column(
              //         crossAxisAlignment: CrossAxisAlignment.start,
              //         children: [
              //           Container(
              //             padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
              //             width: screenWidth*0.25,
              //             decoration: BoxDecoration(
              //               color: Colors.grey[50],),
              //             child: Text(' ${'mrp_per_piece'.tr}',style:
              //             robotoRegular.copyWith(fontSize: 10)),
              //           ),
              //
              //           SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
              //
              //           Padding(
              //             padding: const EdgeInsets.symmetric(vertical: 3,horizontal: 7),
              //             child: Text(PriceConverter.convertPrice(getStartingPrice(item)),
              //                 style: robotoMedium.copyWith(fontSize: 10)),
              //           ),
              //
              //         ],
              //       ),
              //     ),
              //     SizedBox(width: screenWidth*0.03,),
              //
              //     Container(
              //
              //       width: screenWidth*0.25,
              //       decoration: BoxDecoration(
              //         border: Border.all(color: Colors.blueGrey.withOpacity(0.1)),
              //         borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
              //       ),
              //
              //       child: Column(
              //         crossAxisAlignment: CrossAxisAlignment.start,
              //         children: [
              //           Container(
              //             padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
              //             width: screenWidth*0.25,
              //             decoration: BoxDecoration(
              //               color: Colors.grey[50],),
              //             child: Text(' ${'our_price_per_piece'.tr}',style:
              //             robotoRegular.copyWith(fontSize: 10)),
              //           ),
              //
              //           SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
              //
              //           Padding(
              //             padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 7),
              //             child: Text(
              //               '${item.discountRange!=null && item.discountRange.isNotEmpty && returnCurrentItemFromCart()==null? getMinimumDiscountedPriceOnSingleQty() : PriceConverter.convertPrice(returnCurrentItemFromCart().discountedPrice) }',
              //               style: robotoMedium.copyWith(fontSize: 12),
              //             ),
              //           ),
              //
              //         ],
              //       ),
              //     ),
              //
              //
              //     SizedBox(width: screenWidth*0.03,),
              //     Container(
              //
              //       width: screenWidth*0.30,
              //       decoration: BoxDecoration(
              //         border: Border.all(color: Colors.green.withOpacity(0.1)),
              //         borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
              //       ),
              //
              //       child: Column(
              //         crossAxisAlignment: CrossAxisAlignment.start,
              //         children: [
              //           Container(
              //             padding: const EdgeInsets.symmetric(vertical: 4,horizontal: 7),
              //             width: screenWidth*0.30,
              //             decoration: BoxDecoration(
              //               color: Colors.green[50],),
              //             child: Text(' ${'profit_margin_per_piece'.tr}',style:
              //             robotoRegular.copyWith(fontSize: 10)),
              //           ),
              //
              //           SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
              //
              //           Padding(
              //             padding: const EdgeInsets.symmetric(vertical: 2,horizontal: 7),
              //             child: Row(
              //               children: [
              //                 Text(
              //                   '${returnCurrentItemFromCart()==null?'${getMinimumProfitOnSingleQty()} ':
              //                   PriceConverter.percentageCalculation(item.price, returnCurrentItemFromCart().discountedPrice)} %',
              //                   style: robotoMedium.copyWith(fontSize: 12,color: Colors.green[900]),
              //                 ),
              //
              //                 // Text(
              //                 //   _discount > 0 ? '$_discount${_discountType == 'percentage' || _discountType == 'percentage' ? '%'
              //                 //       : Get.find<SplashController>().configModel.currencySymbol} ${'off'.tr}' : 'free_delivery'.tr,
              //                 //
              //                 //   style: robotoMedium.copyWith(
              //                 //       color: Colors.green[900],
              //                 //       fontSize: 10
              //                 //     // fontSize: fontSize != null ? fontSize : ResponsiveHelper.isMobile(context) ? 8 : 12,
              //                 //   ),
              //                 //   textAlign: TextAlign.center,
              //                 // ),
              //                 Text(
              //                   ' ( ${Get.find<SplashController>().configModel.currencySymbol}'
              //                       ' ${ returnCurrentItemFromCart()==null? '${getMinimumProfitInPriceOnSingleQty()}'
              //
              //                       : '${returnCurrentItemFromCart().discountAmount.toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
              //                       .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'}  ) '
              //                   ,
              //                   style: robotoMedium.copyWith(fontSize: 10,color: Colors.green[900]),
              //                 ),
              //                 // Text(
              //                 //   ' ( ${Get.find<SplashController>().configModel.currencySymbol}'
              //                 //       ' ${(AppConstants.saving(item)).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
              //                 //       .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')} ) '
              //                 //   ,
              //                 //   style: robotoMedium.copyWith(fontSize: 10,color: Colors.green[900]),
              //                 // ),
              //               ],
              //             ),
              //           ),
              //
              //         ],
              //       ),
              //     ),
              //     SizedBox(width: screenWidth*0.04,),
              //   ],
              // ),

              SizedBox(height: (_discount > 0 && _discount != item.price) ? 10 : 15,),


              (discountRange.length==1 || !_isAvailable )? Container(
                width: context.width,
                decoration: BoxDecoration(
                  color: Colors.blueGrey[200],
                  // backgroundBlendMode: BlendMode.darken,
                  borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),),
                child: Padding(
                  padding: const EdgeInsets.symmetric(vertical: 10,horizontal: 7),
                  child:  Center(child: Text('out_of_stock'.tr, style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeSmall, color: Colors.blueGrey))),
                ),
              )
                  : Row(mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  ( item.discountRange!=null && item.discountRange.isNotEmpty
                      && item.discountRange.length > 0 ) ? Container(
                    padding: const EdgeInsets.symmetric(vertical: 12,horizontal: 7),
                    // width: _isMobile? context.width*0.50 : _desktop? (context.width*0.50)/4
                    //     : (context.width*0.50)/4,
                    decoration: BoxDecoration(
                      color: Theme.of(context).primaryColor.withOpacity(0.1),
                      border: Border.all(color: Colors.green.withOpacity(0.1)),
                      borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                    ),

                    child: Center(
                      child: _isWeb? Column(mainAxisAlignment: MainAxisAlignment.start,crossAxisAlignment: CrossAxisAlignment.center,children: [
                        Text("${'best_price'.tr}",
                            style: robotoMedium.copyWith(fontSize:
                            Dimensions.fontSizeSmall, color: Theme.of(context).primaryColor)),

                        Text("${getMaxProfitOnSingleQty()} (${getBestPrice() })",
                            style: robotoMedium.copyWith(fontSize:
                            Dimensions.fontSizeSmall, color: Theme.of(context).primaryColor))
                      ],) : Text("${'best_price'.tr}: ${getMaxProfitOnSingleQty()} (${getBestPrice() })",
                          style: robotoMedium.copyWith(fontSize:
                          Dimensions.fontSizeSmall, color: Theme.of(context).primaryColor)),
                    ),
                  )
                      : SizedBox(),

                  Container(
                    // width: _isMobile? context.width*0.30 : _desktop? (context.width*0.30)/3
                    //     : (context.width*0.30)/2,
                    decoration: BoxDecoration(
                      color: ( returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0')? Theme.of(context).primaryColor : Theme.of(context).primaryColor,
                      // backgroundBlendMode: BlendMode.darken,
                      borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),),
                    child: Padding(
                      padding: const EdgeInsets.symmetric(vertical: 12,horizontal: 7),
                      child: Container(
                        padding: EdgeInsets.only(left: 6,right: 6),
                        decoration: BoxDecoration(
                          color: ( returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0')? Theme.of(context).primaryColor : Theme.of(context).primaryColor,

                        ),
                        child: Row(
                          crossAxisAlignment: CrossAxisAlignment.center,
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Text(( returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0') ?'${returnCurrentItemFromCart().quantity.toString()} Added' :
                            'Select Qty', style: robotoRegular.copyWith(fontSize:
                            Dimensions.fontSizeSmall,color: ( returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0')? Colors.white : Colors.white,),),
                            SizedBox(width: 10,),Icon(Icons.keyboard_arrow_down_rounded,size: 15,color: Colors.white,)
                          ],
                        ),
                      ),
                    ),
                  )
                ],),

              (_discount > 0 && _discount != item.price && returnCurrentItemFromCart()!=null && returnCurrentItemFromCart().quantity.toString()!='0' && returnCurrentItemFromCart().quantity>1) ?
              Column(
                children: [
                  SizedBox(height: 10,),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      SizedBox(),
                      Row(children: [
                        Text("You saved ",
                            style: robotoRegular.copyWith(fontSize:
                            Dimensions.fontSizeExtraSmall, color: Colors.black)),

                        Text(" ${Get.find<SplashController>().configModel.currencySymbol} ${totalSavingOnSelectedQty()}",
                            style: robotoRegular.copyWith(fontSize:
                            Dimensions.fontSizeExtraSmall, color: Colors.blue)),

                        SizedBox(width: 2,),
                      ],)

                    ],
                  ),
                ],
              )
                  : SizedBox(),

              SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
              _isAvailable ? SizedBox() : NotAvailableWidget(isStore: false),
            ]),
      );
    }

    return GetBuilder<ItemController>(
      builder: (itemController) {

        int _stock = 0;
        double _priceWithAddons = 0;
        //var item =itemController.item;
        // var item =widget.item;
        //
        // if(item.discount!=null && item.discountRange.isNotEmpty){
        //   discountPlusQtyBasedDiscount = item.discount + double.parse(item.discountRange[0].discount);
        // }
        // item.discount=discountPlusQtyBasedDiscount;

        if(item != null && itemController.variationIndex != null){
          List<String> _variationList = [];

          if(item.choiceOptions!=null){
            for (int index = 0; index < item.choiceOptions.length; index++) {
              _variationList.add(item.choiceOptions[index].options[itemController.variationIndex[index]].replaceAll(' ', ''));
            }
          }

          String variationType = '';
          bool isFirst = true;
          _variationList.forEach((variation) {
            if (isFirst) {
              variationType = '$variationType$variation';
              isFirst = false;
            } else {
              variationType = '$variationType-$variation';
            }
          });

          double price = item.price;
          Variation _variation;
          _stock = item.stock;
          if(item.variations!=null){
            for (Variation variation in item.variations) {
              if (variation.type == variationType) {
                price = variation.price;
                _variation = variation;
                _stock = variation.stock;
                break;
              }
            }
          }

          // double _discount = (item.availableDateStarts != null || item.storeDiscount == 0) ? item.discount : item.storeDiscount;
          //String _discountType = (item.availableDateStarts != null || item.storeDiscount == 0) ? item.discountType : 'percentage';

          double priceWithDiscount = PriceConverter.convertWithDiscount(price, _discount, _discountType);
          double priceWithQuantity = priceWithDiscount * itemController.quantity;

          double addonsCost = 0;
          List<AddOn> _addOnIdList = [];
          List<AddOns> _addOnsList = [];

          if(item.addOns!=null && item.addOns.length>0){
            for (int index = 0; index < item.addOns.length; index++) {
              if (itemController.addOnActiveList[index]) {
                addonsCost = addonsCost + (item.addOns[index].price * itemController.addOnQtyList[index]);
                _addOnIdList.add(AddOn(id: item.addOns[index].id, quantity: itemController.addOnQtyList[index]));
                _addOnsList.add(item.addOns[index]);
              }
            }
          }


          _priceWithAddons = priceWithQuantity + (Get.find<SplashController>().configModel.moduleConfig.module.addOn ? addonsCost : 0);

        }


        // _discount = (item.discountRange!=null && item.discountRange.isNotEmpty && returnCurrentItemFromCart()==null)? getMinimumDiscountOnSingleQty(itemController) : (item.availableDateStarts != null || item.storeDiscount == 0) ? item.discount : item.storeDiscount;
        // _discountType = (item.discountRange!=null && item.discountRange.isNotEmpty)?'percentage' :(item.availableDateStarts != null || item.storeDiscount == 0) ? item.discountType : 'percentage';



        return InkWell(
          onTap: () {

            if(discountRange.length>1){
              if(isStore) {
                if(store != null) {
                  if(isFeatured && Get.find<SplashController>().moduleList != null) {
                    for(ModuleModel module in Get.find<SplashController>().moduleList) {
                      if(module.id == store.moduleId) {
                        Get.find<SplashController>().setModule(module);
                        break;
                      }
                    }
                  }
                  Get.toNamed(

                    RouteHelper.getStoreRoute(store.id, isFeatured ? 'module' : 'item'),
                    arguments: StoreScreen(store: store, fromModule: isFeatured),
                  );
                }
              }
              else {
                if(!isRecentViewItem){
                  Get.find<CartController>().addToRecentView(item);
                }

                Get.find<ItemController>().navigateToItemPage(
                    item, context, inStore: inStore,
                    isCampaign: isCampaign
                );

              }
            }


          },
          child:
          // GetPlatform.isWeb? Container(
          //   padding: EdgeInsets.all(Dimensions.PADDING_SIZE_EXTRA_SMALL),
          //   decoration: BoxDecoration(
          //     color: Theme.of(context).cardColor,
          //     borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
          //     boxShadow: [BoxShadow(
          //       color: Colors.grey[Get.find<ThemeController>().darkTheme ? 700 : 300],
          //       blurRadius: 5, spreadRadius: 1,
          //     )],
          //   ),
          //   child: Row(children: [
          //
          //     Stack(children: [
          //       ClipRRect(
          //         borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
          //         child: CustomImage(
          //           image: '${Get.find<SplashController>().configModel.baseUrls.commonImageUrl}'
          //               '/${item.image}',
          //           height: 90, width: 90, fit: BoxFit.cover,
          //         ),
          //       ),
          //       DiscountTag(
          //         discount: itemController.getDiscount(item),
          //         discountType: itemController.getDiscountType(item),
          //       ),
          //       itemController.isAvailable(item) ? SizedBox() : NotAvailableWidget(),
          //     ]),
          //
          //     Expanded(
          //       child: Padding(
          //         padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
          //         child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisAlignment: MainAxisAlignment.center, children: [
          //           Text(
          //             item.name??"",
          //             style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall),
          //             maxLines: 1, overflow: TextOverflow.ellipsis,
          //           ),
          //           SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),
          //
          //           Text(
          //             item.storeName??"",
          //             style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraSmall, color: Theme.of(context).disabledColor),
          //             maxLines: 1, overflow: TextOverflow.ellipsis,
          //           ),
          //
          //           RatingBar(
          //             rating: item.avgRating, size: 15,
          //             ratingCount: item.ratingCount,
          //           ),
          //
          //           // Row(
          //           //   children: [
          //           //     Text(
          //           //       PriceConverter.convertPrice(
          //           //         item.price, discount: item.discount, discountType: item.discountType,
          //           //       ),
          //           //       style: robotoBold.copyWith(fontSize: Dimensions.fontSizeExtraSmall),
          //           //     ),
          //           //     SizedBox(width: item.discount > 0 ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
          //           //     item.discount > 0 ? Expanded(child: Text(
          //           //       PriceConverter.convertPrice(itemController.getStartingPrice(item)),
          //           //       style: robotoRegular.copyWith(
          //           //         fontSize: Dimensions.fontSizeExtraSmall, color: Theme.of(context).disabledColor,
          //           //         decoration: TextDecoration.lineThrough,
          //           //       ),
          //           //     )) : Expanded(child: SizedBox()),
          //           //     Icon(Icons.add, size: 25),
          //           //   ],
          //           // ),
          //         ]),
          //       ),
          //     ),
          //
          //   ]),
          // ) :


          Container(
            padding: EdgeInsets.only(left: 10.0,right: 10.0),
            decoration: isRecentViewItem ? BoxDecoration(
                color: Theme.of(context).cardColor,
                borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                border: Border.all(
                  color: Colors.green,
                  width: 1.0,
                )
            )
                : BoxDecoration(
              border: Border(
                bottom: BorderSide(width: 1.5, color: Colors.grey[300]),
              ),
            ),


            child: view(context),
          ),);
      },
    );


  }

}


class DiscountTagTest extends StatelessWidget {
  final double discount;
  final String discountType;
  final double fromTop;
  final double fontSize;
  final bool inLeft;
  final bool freeDelivery;
  DiscountTagTest({
    @required this.discount, @required this.discountType, this.fromTop = 10, this.fontSize, this.freeDelivery = false,
    this.inLeft = true,
  });

  @override
  Widget build(BuildContext context) {
    return (discount > 0 || freeDelivery) ? Container(
      padding: EdgeInsets.symmetric(horizontal: 2, vertical: 4),
      decoration: BoxDecoration(
        color: Colors.green,
        borderRadius: BorderRadius.horizontal(
          right: Radius.circular(inLeft ? Dimensions.RADIUS_SMALL : 0),
          left: Radius.circular(inLeft ? 0 : Dimensions.RADIUS_SMALL),
        ),
      ),
      child: Text(
        discount > 0 ? '$discount${discountType == 'percentage' || discountType == 'percentage' ? '%'
            : Get.find<SplashController>().configModel.currencySymbol} ${'off'.tr}' : 'free_delivery'.tr,

        style: robotoMedium.copyWith(
          color: Colors.white,
          fontSize: fontSize != null ? fontSize : ResponsiveHelper.isMobile(context) ? 8 : 12,
        ),
        textAlign: TextAlign.center,
      ),
    ) : SizedBox();
  }
}

class AddItemButtonWidgetTest extends StatelessWidget {


  @override
  Widget build(BuildContext context) {
    return Container(
      decoration: BoxDecoration(
        color: Theme.of(context).primaryColor.withAlpha(30),
        // backgroundBlendMode: BlendMode.darken,
        borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
        border: Border.all(
          color: Theme.of(context).primaryColor,
          width: 0.8,
        ),),
      child: Padding(
        padding: const EdgeInsets.symmetric(vertical: 5,horizontal: 20),
        child: Text('ADD',style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge)),
      ),
    );
  }
}
































// Container(
//         height: 210,
//         width: context.width,
//         padding: EdgeInsets.all(Dimensions.PADDING_SIZE_EXTRA_SMALL),
//         decoration: BoxDecoration(
//           color: Theme.of(context).cardColor,
//           borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//           boxShadow: [BoxShadow(
//             color: Colors.grey[Get.find<ThemeController>().darkTheme ? 800 : 300],
//             blurRadius: 5, spreadRadius: 1,
//           )],
//         ),
//         child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisAlignment: MainAxisAlignment.center, children: [
//
//           Stack(children: [
//             ClipRRect(
//               borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
//               child: CustomImage(
//                 image: '${isCampaign ? _baseUrls.campaignImageUrl : isStore ? _baseUrls.storeImageUrl
//                             : _baseUrls.commonImageUrl}'
//                             '/${isStore ? store.logo : item.image}',
//                 height: 100, width: context.width, fit: BoxFit.cover,
//               ),
//             ),
//             DiscountTag(
//               discount: item.discount, discountType: item.discountType,
//               inLeft: false,
//             ),
//             isAvailable(item) ? SizedBox() : NotAvailableWidget(isStore: true),
//             Positioned(
//               top: Dimensions.PADDING_SIZE_EXTRA_SMALL, left: Dimensions.PADDING_SIZE_EXTRA_SMALL,
//               child: Container(
//                 padding: EdgeInsets.symmetric(vertical: 2, horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                 decoration: BoxDecoration(
//                   color: Theme.of(context).cardColor.withOpacity(0.8),
//                   borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//                 ),
//                 child: Row(children: [
//                   Icon(Icons.star, color: Theme.of(context).primaryColor, size: 15),
//                   SizedBox(width: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                   Text(item.avgRating.toStringAsFixed(1), style: robotoRegular),
//                 ]),
//               ),
//             ),
//           ]),
//
//           Expanded(
//             child: Stack(children: [
//               Padding(
//                 padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                 child: Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
//                   Text(
//                     item.name ?? '', textAlign: TextAlign.center,
//                     style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall),
//                     maxLines: 2, overflow: TextOverflow.ellipsis,
//                   ),
//                   SizedBox(height: 2),
//
//                   Text(
//                     item.storeName ?? '', textAlign: TextAlign.center,
//                     style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge, color: Theme.of(context).disabledColor),
//                     maxLines: 1, overflow: TextOverflow.ellipsis,
//                   ),
//                   SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),
//
//                   Row(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.end, children: [
//                     getDiscount(item) > 0  ? Flexible(child: Text(
//                       PriceConverter.convertPrice(getStartingPrice(item)),
//                       style: robotoRegular.copyWith(
//                         fontSize: Dimensions.fontSizeLarge, color: Theme.of(context).errorColor,
//                         decoration: TextDecoration.lineThrough,
//                       ),
//                     )) : SizedBox(),
//                     SizedBox(width: item.discount > 0 ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
//                     Text(
//                       PriceConverter.convertPrice(
//                         getStartingPrice(item), discount: getDiscount(item),
//                         discountType: getDiscountType(item),
//                       ),
//                       style: robotoMedium,
//                     ),
//                   ]),
//                 ]),
//               ),
//               Positioned(bottom: 0, right: 0, child: Container(
//                 height: 25, width: 25,
//                 decoration: BoxDecoration(
//                     shape: BoxShape.circle,
//                     color: Theme.of(context).primaryColor
//                 ),
//                 child: Icon(Icons.add, size: 20, color: Colors.white),
//               )),
//             ]),
//           ),
//
//         ]),
//       )
//  */




//InkWell(
//           onTap: () {
//             if(isStore) {
//               if(store != null) {
//                 if(isFeatured && Get.find<SplashController>().moduleList != null) {
//                   for(ModuleModel module in Get.find<SplashController>().moduleList) {
//                     if(module.id == store.moduleId) {
//                       Get.find<SplashController>().setModule(module);
//                       break;
//                     }
//                   }
//                 }
//                 Get.toNamed(
//                   RouteHelper.getStoreRoute(store.id, isFeatured ? 'module' : 'item'),
//                   arguments: StoreScreen(store: store, fromModule: isFeatured),
//                 );
//               }
//             }
//             else {
//               Get.find<CartController>().addToRecentView(item);
//               Get.find<ItemController>().navigateToItemPage(item, context, inStore: inStore, isCampaign: isCampaign);
//             }
//           },
//           child: Container(
//             padding: ResponsiveHelper.isDesktop(context) ? EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL) : null,
//             decoration: BoxDecoration(
//               borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//               color: ResponsiveHelper.isDesktop(context) ? Theme.of(context).cardColor : null,
//               boxShadow: ResponsiveHelper.isDesktop(context) ? [BoxShadow(
//                 color: Colors.grey[Get.isDarkMode ? 700 : 300], spreadRadius: 1, blurRadius: 5,
//               )] : null,
//             ),
//             child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [
//
//               Expanded(child: Padding(
//                 padding: EdgeInsets.symmetric(vertical: _desktop ? 0 : Dimensions.PADDING_SIZE_EXTRA_SMALL),
//                 child: Row(children: [
//
//                   Stack(children: [
//                     ClipRRect(
//                       borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
//                       child: CustomImage(
//                         image: '${isCampaign ? _baseUrls.campaignImageUrl : isStore ? _baseUrls.storeImageUrl
//                             : _baseUrls.commonImageUrl}'
//                             '/${isStore ? store.logo : item.image}',
//                         height: _desktop ? 120 : 65, width: _desktop ? 120 : 80, fit: BoxFit.cover,
//                       ),
//                     ),
//                     DiscountTag(
//                       discount: _discount, discountType: _discountType,
//                       freeDelivery: isStore ? store.freeDelivery : false,
//                     ),
//                     _isAvailable ? SizedBox() : NotAvailableWidget(isStore: isStore),
//                   ]),
//                   SizedBox(width: Dimensions.PADDING_SIZE_SMALL),
//
//                   Expanded(
//                     child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisAlignment: MainAxisAlignment.center, children: [
//
//                       Text(
//                         isStore ? store.name : item.name,
//                         style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall),
//                         maxLines: _desktop ? 2 : 1, overflow: TextOverflow.ellipsis,
//                       ),
//                       SizedBox(height: isStore ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
//
//                       (isStore ? store.address != null : item.storeName != null) ? Text(
//                         isStore ? store.address ?? '' : item.storeName ?? '',
//                         style: robotoRegular.copyWith(
//                           fontSize: Dimensions.fontSizeLarge,
//                           color: Theme.of(context).disabledColor,
//                         ),
//                         maxLines: 1, overflow: TextOverflow.ellipsis,
//                       ) : SizedBox(),
//                       SizedBox(height: ((_desktop || isStore) && (isStore ? store.address != null : item.storeName != null)) ? 5 : 0),
//
//                       !isStore ? RatingBar(
//                         rating: isStore ? store.avgRating : item.avgRating, size: _desktop ? 15 : 12,
//                         ratingCount: isStore ? store.ratingCount : item.ratingCount,
//                       )
//                           : SizedBox(),
//                       SizedBox(height: (!isStore && _desktop) ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
//
//                       isStore ? RatingBar(
//                         rating: isStore ? store.avgRating : item.avgRating, size: _desktop ? 15 : 12,
//                         ratingCount: isStore ? store.ratingCount : item.ratingCount,
//                       ) : Row(children: [
//
//                         Text(
//                           PriceConverter.convertPrice(item.price, discount: _discount, discountType: _discountType),
//                           style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall),
//                         ),
//                         SizedBox(width: _discount > 0 ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
//
//                         _discount > 0 ? Text(
//                           PriceConverter.convertPrice(item.price),
//                           style: robotoMedium.copyWith(
//                             fontSize: Dimensions.fontSizeLarge,
//                             color: Theme.of(context).disabledColor,
//                             decoration: TextDecoration.lineThrough,
//                           ),
//                         ) : SizedBox(),
//
//                       ]),
//
//                     ]),
//                   ),
//
//                   Column(mainAxisAlignment: isStore ? MainAxisAlignment.center : MainAxisAlignment.spaceBetween, children: [
//
//                     !isStore ? Padding(
//                       padding: EdgeInsets.symmetric(vertical: _desktop ? Dimensions.PADDING_SIZE_SMALL : 0),
//                       child: Icon(Icons.add, size: _desktop ? 30 : 25),
//                     ) : SizedBox(),
//
//                     GetBuilder<WishListController>(builder: (wishController) {
//                       bool _isWished = isStore ? wishController.wishStoreIdList.contains(store.id)
//                           : wishController.wishItemIdList.contains(item.id);
//                       return InkWell(
//                         onTap: () {
//                           if(Get.find<AuthController>().isLoggedIn()) {
//                             _isWished ? wishController.removeFromWishList(isStore ? store.id : item.id, isStore)
//                                 : wishController.addToWishList(item, store, isStore);
//                           }else {
//                             showCustomSnackBar('you_are_not_logged_in'.tr);
//                           }
//                         },
//                         child: Padding(
//                           padding: EdgeInsets.symmetric(vertical: _desktop ? Dimensions.PADDING_SIZE_SMALL : 0),
//                           child: Icon(
//                             _isWished ? Icons.favorite : Icons.favorite_border,  size: _desktop ? 30 : 25,
//                             color: _isWished ? Theme.of(context).primaryColor : Theme.of(context).disabledColor,
//                           ),
//                         ),
//                       );
//                     }),
//
//                   ]),
//
//                 ]),
//               )),
//
//               _desktop ? SizedBox() : Padding(
//                 padding: EdgeInsets.only(left: _desktop ? 130 : 90),
//                 child: Divider(color: index == length-1 ? Colors.transparent : Theme.of(context).disabledColor),
//               ),
//
//             ]),
//           ),
//         ),
