import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../controller/splash_controller.dart';
import '../../helper/price_converter.dart';
import '../../util/styles.dart';

class MrpAndSaveView extends StatelessWidget {
  final double mrpFontSize;
  final double startingPrice;
  final double saving;
  final double saveFontSize;
  MrpAndSaveView({@required this.mrpFontSize,@required this.startingPrice,@required this.saving,@required this.saveFontSize});
  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Flexible(child: Text(
          '${'mrp'.tr}:',
          style: robotoMedium.copyWith(fontSize: mrpFontSize,
            color: Colors.grey,),
        )),
        Flexible(child: Text(
          PriceConverter.convertPrice(startingPrice),
          style: robotoRegular.copyWith(
            fontSize: mrpFontSize, color: Theme.of(context).colorScheme.error,
            decoration: TextDecoration.lineThrough,
          ),
        )),
        SizedBox(width: 5,),
        Text(
          '${'save_per_piece'.tr} ${saving == null ? '' : '${Get.find<SplashController>().configModel.currencySymbol} ${(saving).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
              .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'}'
          ,
          style: robotoMedium.copyWith(fontSize: saveFontSize,
            color: Theme.of(context).colorScheme.error,),
        ),

      ],
    );
  }
}
