import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../controller/splash_controller.dart';
import '../../util/dimensions.dart';
import '../../util/styles.dart';

class MrpSellingDiffView extends StatelessWidget {

  final double mrp;
  final double price;
  MrpSellingDiffView({@required this.mrp, this.price});
  
  double differenceBetweenMrpAndPrice (){


    var diff  = mrp-price ; 
    return diff ;

  }

  @override
  Widget build(BuildContext context) {
    return (differenceBetweenMrpAndPrice() > 0 ) ? Row(
      children: [
        Flexible(child: Text(
          '${'mrp'.tr}:',
          style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraSmall,color: Colors.grey,),
        )),
        SizedBox(width: 5,),
        Flexible(child: Text(
          mrp == null ? 0 : '${Get.find<SplashController>().configModel.currencySymbol} ${mrp.toString()}',
          style : robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraSmall,color: Theme.of(context).colorScheme.error,decoration: TextDecoration.lineThrough),
        )),
        SizedBox(width: 5,),

        Text(
          '${'save'.tr} ${mrp == null ? '' : '${Get.find<SplashController>().configModel.currencySymbol} ${(differenceBetweenMrpAndPrice()).toStringAsFixed(Get.find<SplashController>().configModel.digitAfterDecimalPoint)
              .replaceAllMapped(RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))'), (Match m) => '${m[1]},')}'}'
          ,
          style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall,
            color: Theme.of(context).colorScheme.error,),
        ),

      ],
    ) : SizedBox() ;
  }
}
