import 'package:sixam_mart/util/dimensions.dart';
import 'package:flutter/material.dart';

class QuantityButton extends StatelessWidget {
  final bool isIncrement;
  final Function onTap;
  QuantityButton({@required this.isIncrement, @required this.onTap});

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: onTap,
      child: Container(
        height: 22, width: 22,
        margin: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_SMALL),
        decoration: BoxDecoration(
          shape: BoxShape.circle,
          border: Border.all(width: 1, color: isIncrement ? Theme.of(context).primaryColor : Theme.of(context).errorColor),
          color: isIncrement ? Theme.of(context).primaryColor : Theme.of(context).errorColor,
        ),
        alignment: Alignment.center,
        child: Icon(
          //isIncrement ? Icons.add : Icons.remove,
          isIncrement ? Icons.add : Icons.delete,
          size: 15,
          color: isIncrement ? Theme.of(context).cardColor : Theme.of(context).cardColor,
        ),
      ),
    );
  }
}