import 'dart:async';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:sixam_mart/view/base/custom_app_bar.dart';
import 'package:sixam_mart/view/base/custom_snackbar.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../../controller/auth_controller.dart';
import '../../../controller/prime_member_controller.dart';
import '../../../controller/user_controller.dart';
import '../../../data/model/response/PrimeMembersModel2.dart';
import '../../../data/model/response/prime_member_detail_model.dart';
import '../../../data/model/response/state_city_and_relation.dart';
import '../../../data/model/response/userinfo_model.dart';
import '../../../helper/route_helper.dart';
import '../../../util/app_constants.dart';
import '../../../util/styles.dart';
import '../../base/confirmation_dialog.dart';
import '../../base/custom_button.dart';
import '../../base/custom_image.dart';
import '../../base/custom_text_field.dart';
import '../checkout/widget/payment_button.dart';
import '../home/home_screen.dart';
import 'package:universal_html/html.dart' as html;

class BankDetails extends StatefulWidget {

  final String from;

  BankDetails({@required this.from});

  @override
  State<BankDetails> createState() => _BankDetailsState();
}

class _BankDetailsState extends State<BankDetails> {
  final FocusNode _firstNameFocus = FocusNode();
  final FocusNode _emailFocus = FocusNode();
  final FocusNode _phoneFocus = FocusNode();
  final FocusNode _accNumberFocus = FocusNode();
  final FocusNode _confirmAccNumberFocus = FocusNode();
  final FocusNode _ifscFocus = FocusNode();
  final FocusNode _panFocus = FocusNode();
  final FocusNode _aadharCardFocus = FocusNode();
  final FocusNode _nomineeMobileCardFocus = FocusNode();


  final TextEditingController _firstNameController = TextEditingController();
  final TextEditingController _phoneController = TextEditingController();
  final TextEditingController _emailController = TextEditingController();
  final TextEditingController _pinController = TextEditingController();

  final TextEditingController _bothAccountMatched = TextEditingController();
  final TextEditingController _accNumberController = TextEditingController();
  final TextEditingController _confirmAccNumberController = TextEditingController();
  final TextEditingController _ifscController = TextEditingController();
  final TextEditingController _panController = TextEditingController();
  final TextEditingController _aadharCardController = TextEditingController();
  final TextEditingController _nomineeNameController = TextEditingController();
  final TextEditingController _nomineeMobileController = TextEditingController();
  final TextEditingController _searchedPrimeController = TextEditingController();
  final TextEditingController _nomineePanController = TextEditingController();
  final TextEditingController _nomineeAadharController = TextEditingController();

  bool _isDigitalPaymentActive = true;
  bool _isWalletActive = true;
  bool _isLoggedIn;
  double spaceBetweenEdtText=20.0;
  int limit=10;
  bool isTimeEnded=false;
  bool shouldUpdate=false;
  String primeId='';
  bool isServerSideDataRendered=false;

  @override
  void dispose() {

    _bothAccountMatched.dispose();
    _firstNameController.dispose();
    _phoneController.dispose();
    _emailController.dispose();
    _pinController.dispose();
    _accNumberController.dispose();
    _confirmAccNumberController.dispose();
    _ifscController.dispose();
    _panController.dispose();
    _aadharCardController.dispose();
    _nomineeNameController.dispose();
    _nomineeMobileController.dispose();
    _nomineePanController.dispose();
    _nomineeAadharController.dispose();
    super.dispose();
  }
  @override
  void initState() {
    super.initState();

    // _pinController.text =  defaultValue;
    // _accNumberController.text = defaultValue;
    // _confirmAccNumberController.text = defaultValue;
    // _ifscController.text = defaultValue;
    // _aadharCardController.text = defaultValue;
    // _panController.text = defaultValue;
    // _nomineeNameController.text = defaultValue;
    // _nomineeNameController.text = defaultValue;
    // _nomineeMobileController.text = defaultValue;
    // _nomineePanController.text = defaultValue;
    // _nomineeAadharController.text = defaultValue;
    Get.find<PrimeMemberController>().initData();

    Get.find<PrimeMemberController>().getStateCityAndRelationData('');
    Get.find<PrimeMemberController>().getPrimeMembersList(true);
    Get.find<PrimeMemberController>().paymentMethodSelected('');
    Get.find<PrimeMemberController>().getPrimeMemberDetail();
    _isLoggedIn = Get.find<AuthController>().isLoggedIn();
    if(_isLoggedIn && Get.find<UserController>().userInfoModel == null) {
      Get.find<UserController>().getUserInfo();
    }
    //Get.find<UserController>().initData();


  }
  void _checkFormCompleted(PrimeMemberController primeController)  {

    // if(primeController.isFormCompleted!=null && primeController.isFormCompleted==false){
    //
    //   Timer(Duration(seconds: 2), () async {
    //     Get.dialog( ConfirmationDialog(
    //       icon: Images.warning
    //       ,shouldYesButtonHide: primeController.isFormCompleted ? false : true,
    //       rightButtonText: primeController.isFormCompleted ? "Next" : '',
    //       leftButtonText: primeController.isFormCompleted ? "Edit Form" : 'Ok',
    //
    //       title:  primeController.isFormCompleted ? 'Prime Card Inactive' :"Incomplete Form" ,
    //       description: primeController.isFormCompleted ? 'Click on Next to make a payment of ${Get.find<SplashController>().configModel.currencySymbol} ${Get.find<SplashController>().configModel.primeMembershipAmount.toString()} to activate your Prime Card.'
    //
    //           :"Please submit all the details to continue.",
    //       onYesPressed: () async {
    //
    //         Get.back();
    //
    //       },
    //     ));
    //
    //   });
    //
    // }



  }

  Widget afterUpiScreenshotSubmittedUI(){
    return Column(mainAxisAlignment: MainAxisAlignment.center, children: [

      Image.asset( Images.checked, width: 100, height: 100),
      SizedBox(height: Dimensions.PADDING_SIZE_LARGE),

      Text(
        'UPI Payment Screenshot Submitted.',
        style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge),
      ),
      SizedBox(height: Dimensions.PADDING_SIZE_SMALL),

      Padding(
        padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_LARGE, vertical: Dimensions.PADDING_SIZE_SMALL),
        child: Text(
          'We have received your UPI payment screenshot after verification We will activate your Prime Card ',
          style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall, color: Theme.of(context).disabledColor),
          textAlign: TextAlign.center,
        ),
      ),
      SizedBox(height: 30),

      Padding(
        padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
        child: CustomButton(buttonText: 'back_to_home'.tr, onPressed: () => Get.offAllNamed(RouteHelper.getInitialRoute())),
      ),
    ]);
  }

  void _callback(bool isSuccess, String message, String orderID) async {
    if(isSuccess) {

      HomeScreen.loadData(true);

      if(GetPlatform.isWeb) {
          Get.back();
          String hostname = html.window.location.hostname;
          String protocol = html.window.location.protocol;
          String selectedUrl = '${AppConstants.baseUrl}/subscription-payment?order_id=$orderID&&customer_id=${Get.find<UserController>()
              .userInfoModel.id}&&callback=$protocol//$hostname${RouteHelper.primeMembershipPaymentSuccess}?id=$orderID&status=';
          html.window.open(selectedUrl,"_self");
        }
        else{
          Get.offNamed(RouteHelper.getPrimeMembershipPaymentRoute(
            orderID, Get.find<UserController>().userInfoModel.id
          ));
        }


    }else {
      showCustomSnackBar(message);
    }
  }



  int daysBetween() {
    var difference=0;
    // try{
    //   if(Get.find<UserController>().userInfoModel!=null && Get.find<UserController>().userInfoModel.primeRemainingDays!=null){
    //     difference =Get.find<UserController>().userInfoModel.primeRemainingDays;
    //   }
    //   DateTime currentTime = DateTime.now();
    //   // final DateTime primeValidFrom =DateTime.parse(Get.find<UserController>().userInfoModel.primeValidFrom);
    //   // final DateTime primeValidTo =DateTime.parse(Get.find<UserController>().userInfoModel.primeValidTo);
    //   DateTime primeValidFrom = DateTime(currentTime.year, currentTime.month, currentTime.day, currentTime.hour, currentTime.minute, currentTime.second);
    //
    //   final DateTime primeValidTo =DateTime.parse(
    //       "2024-12-01 00:00:00");
    //
    //
    //   DateTime from = DateTime(primeValidFrom.year, primeValidFrom.month, primeValidFrom.day);
    //   DateTime to = DateTime(primeValidTo.year, primeValidTo.month, primeValidTo.day);
    //
    //   print("daysBetween primeValidFrom $from primeValidTo $to");
    //
    //   difference = (to.difference(from).inHours / 24).round();
    //
    // }catch(e){
    //   print("daysBetween error ${e.toString()}");
    //   difference=0;
    // }
    //
    // print("daysBetween  diff = $difference");

    return difference;
  }

  Widget paymentMethodUI(PrimeMemberController primeController,int type){
    //primeController.paymentMethodSelected(AppConstants.payment_method_digital);
    return Get.find<UserController>().userInfoModel.primeMember==0 ? Container(
      padding: const EdgeInsets.all(8.0),
      child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
        SizedBox(height: 15,),

         Column(children: [
          SizedBox(height: 25,),
          // Align(child: ElevatedButton(
          //
          //     child: Padding(
          //       padding: const EdgeInsets.all(8.0),
          //       child: Text(
          //           'Edit Documents',
          //           style: robotoMedium.copyWith(fontSize: 15,color: Colors.white)
          //       ),
          //     ),
          //     style: ElevatedButton.styleFrom(
          //       foregroundColor: Colors.blueGrey, backgroundColor: Colors.grey, // foreground
          //     ),
          //     onPressed: () {
          //       primeController.updateIsFormCompleted(false);
          //     }
          // ),alignment: Alignment.centerRight),
          Row(
            children: [
              Text('Payment  ', style: robotoBlack.copyWith(fontSize: 20)),
              Text('${Get.find<SplashController>().configModel.currencySymbol} ${Get.find<SplashController>().configModel.primeMembershipAmount.toString()}', style: robotoBlack.copyWith(fontSize: 20,color: Colors.purple)),
            ],
          ),
          SizedBox(height: 20,),

          Container(

            width: double.infinity,
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(16),
              color: Theme.of(context).cardColor,
              boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
            ),
            child: Padding(
              padding: const EdgeInsets.all(8.0),
              child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [

                SizedBox(height: 10,),
                Text('choose_payment_method'.tr, style: robotoMedium),
                SizedBox(height: 15,),

                _isDigitalPaymentActive ? PaymentButton(
                  icon: Images.digital_payment,
                  title: 'digital_payment'.tr,
                  subtitle: 'faster_and_safe_way'.tr,
                  isSelected: primeController.isDigitalSelected,
                  onTap: () => primeController.paymentMethodSelected(AppConstants.payment_method_digital),
                )
                    : SizedBox(),
                // PriceConverter.convertPrice(userController.userInfoModel.walletBalance)
                SizedBox(height: 10,),
                (Get.find<SplashController>().configModel.isUpiPayment ) ?
                PaymentButton(
                  icon: Images.upi_payment,
                  title: 'UPI Mobile',
                  subtitle: 'Share screenshot after payment complete',
                  isSelected: primeController.isUpiSelected,
                  subtitle2: (Get.find<SplashController>().configModel.upiCashbackAmount!=null && Get.find<SplashController>().configModel.upiCashbackAmount>0)
                      ?'${Get.find<SplashController>().configModel.currencySymbol} ${Get.find<SplashController>().configModel.upiCashbackAmount} ${'cashback'.tr}'
                      : '',
                  onTap: () => primeController.paymentMethodSelected(AppConstants.payment_method_upi),
                ): SizedBox(),
                SizedBox(height: 10,),
                (Get.find<SplashController>().configModel.isQrPayment ) ?
                PaymentButton(
                  icon: Images.qr_payment,
                  title: 'qr_code'.tr,
                  subtitle: 'Share screenshot after payment complete',
                  isSelected: primeController.isQrSelected,
                  subtitle2: (Get.find<SplashController>().configModel.qrcodeCashbackAmount!=null && Get.find<SplashController>().configModel.qrcodeCashbackAmount>0)
                      ?'${Get.find<SplashController>().configModel.currencySymbol} ${Get.find<SplashController>().configModel.qrcodeCashbackAmount} ${'cashback'.tr}'
                      : '',
                  onTap: () => primeController.paymentMethodSelected(AppConstants.payment_method_qrCode),
                ) : SizedBox(),
                // PaymentButton(
                //   icon: Images.bank,
                //   title: 'Bank Deposit',
                //   subtitle: 'Share screenshot after payment complete',
                //   isSelected: primeController.isBankDepositSelected,
                //   onTap: () => primeController.paymentMethodSelected(AppConstants.payment_method_bank_deposit),
                // ),

                _isWalletActive ? PaymentButton(
                  icon: Images.wallet,
                  title: 'wallet_payment'.tr,
                  subtitle: 'pay_from_your_existing_balance'.tr,
                  isSelected: primeController.isWalletSelected,
                  subtitle2: (Get.find<SplashController>().configModel.walletCashbackAmount!=null && Get.find<SplashController>().configModel.walletCashbackAmount>0)
                      ?'${Get.find<SplashController>().configModel.currencySymbol} ${Get.find<SplashController>().configModel.walletCashbackAmount} ${'cashback'.tr}'
                      : '',
                  onTap: () => primeController.paymentMethodSelected(AppConstants.payment_method_wallet),
                )
                    : SizedBox(),




                // SizedBox(height: 10,),
                // primeController.isUpiSelected? Container(
                //   width: double.infinity,
                //   color: Colors.grey[100],
                //   child: Padding(
                //     padding: const EdgeInsets.fromLTRB(20, 10, 20, 10),
                //     child: Column(
                //       children: [
                //         Text('Bhavya Group Bank Details', style: robotoBold.copyWith(fontSize: 15)),
                //         SizedBox(height: 10,),
                //
                //         Text('Name: Bhavya Sainik Canteen', style: robotoRegular.copyWith(fontSize: 12)),
                //
                //         SizedBox(height: 5,),
                //         Text('Acc No: 12345678909876', style: robotoRegular.copyWith(fontSize: 12)),
                //
                //
                //         SizedBox(height: 5,),
                //         Text('IFSC: ABC000515', style: robotoRegular.copyWith(fontSize: 12)),
                //
                //       ],
                //     ),
                //   ),
                // )
                //     :SizedBox(),
                //
                //
                // SizedBox(height: 10,),
                // primeController.isUpiSelected?   Row(
                //   children: [
                //     Text('Deposit Slip', style:TextStyle(fontSize: 15, color: Colors.black)),
                //     SizedBox(width: 10,),
                //
                //     ClipRRect(
                //       borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                //       child: CustomImage(
                //         image: '',
                //         height: 90, width: 200, fit: BoxFit.fill,
                //       ),
                //     ),
                //
                //     Container(
                //       padding: EdgeInsets.symmetric(vertical: 2, horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
                //       decoration: BoxDecoration(
                //         color: Theme.of(context).cardColor.withOpacity(0.8),
                //         borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                //       ),
                //       child: Icon(Icons.upload),
                //     ),
                //   ],
                // )
                //     : SizedBox(),

                // primeController.isUpiSelected? Column(
                //   crossAxisAlignment: CrossAxisAlignment.start,
                //   children: [
                //     Image.asset(Images.company_qrcode,width: context.width,height: context.width,),
                //     SizedBox(height: 10,),
                //     Text('Screenshot', style:TextStyle(fontSize: 15, color: Colors.black)),
                //     SizedBox(height: 10,),
                //     Stack(children: [
                //       primeController.isUpiScreenshotImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                //         borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                //         child: primeController.rawUpiScreenshotImageFile != null ? Image.memory(
                //           primeController.rawUpiScreenshotImageFile, height: 140, width: double.infinity, fit: BoxFit.cover,
                //         ) : CustomImage(
                //           image: '',
                //           height: 140, width: double.infinity, fit: BoxFit.fill,
                //         ),
                //       ),
                //
                //       Positioned(
                //         bottom: 10,
                //         right: 10,
                //         child: UploadImageWidget(onTap: () => primeController.pickUpiScreenshotImage()),
                //       ),
                //     ]),
                //   ],
                // )
                //     : SizedBox(),
                //
                // SizedBox(height: 10,),
                // (primeMemberController.isCashSelected
                //     || primeMemberController.isBankDepositSelected
                //     || primeMemberController.isUPISelected)?
                // ( primeController.isBankDepositSelected || primeController.isWalletSelected)?Center(
                //   child: primeController.isLoading? CircularProgressIndicator() : ElevatedButton(
                //       child: Padding(
                //         padding: const EdgeInsets.all(8.0),
                //         child: Text(
                //             "Submit Screenshot",
                //             style: TextStyle(fontSize: 14)
                //         ),
                //       ),
                //       style: ButtonStyle(
                //           shape: MaterialStateProperty.all<RoundedRectangleBorder>(RoundedRectangleBorder(borderRadius: BorderRadius.circular(10.0),))
                //       ),
                //       onPressed: () {
                //         if (primeController.rawUpiScreenshotImageFile==null) {
                //           showCustomSnackBar('Select Payment Screenshot');
                //         }
                //
                //         else {
                //           primeController.uploadUpiPaymentScreenshot().then((status) async {
                //             if(status.isSuccess){
                //               primeController.setUpiScreenshotSubmitted(true);
                //             }else{
                //               showCustomSnackBar(status.message,isError: true);
                //             }
                //             // _checkFormCompleted(primeController);
                //
                //           });
                //
                //         }
                //       }
                //   ),
                // )
                //     : SizedBox(),
                // :SizedBox(),
                //SizedBox(height: 10,),
              ]),
            ),
          ),
        ],),

        (primeController.isDigitalSelected || primeController.isWalletSelected|| primeController.isUpiSelected|| primeController.isQrSelected) ?
        primeController.isPrimeMembershipOrderIdLoading? Center(child: CircularProgressIndicator(),)
            : CustomButton(
          buttonText: primeController.isDigitalSelected? 'make_payment'.tr : 'next'.tr,
          onPressed: () {
            UserInfoModel _user =  Get.find<UserController>().userInfoModel;

            if( _user.primeMember==0 && (primeController.referenceDropdownValue==null || primeController.referenceDropdownValue.id.toString()=="-1")){
            showCustomSnackBar('Select Your Reference');
            }else  if(primeController.isUpiSelected || primeController.isQrSelected){

            Get.find<PrimeMemberController>().reset();
            if(primeController.isUpiSelected){
              primeController.getOrderIdForPrimeMembership('upi',Get.find<UserController>().userInfoModel.id.toString(), _callback);
            }else{

              primeController.getOrderIdForPrimeMembership('qrCode',Get.find<UserController>().userInfoModel.id.toString(), _callback);

            }


            }
            else{

              if(primeController.isWalletSelected){
                primeController.getOrderIdForPrimeMembership('wallet',Get.find<UserController>().userInfoModel.id.toString(), _callback);
              }else{
                primeController.getOrderIdForPrimeMembership('gateway',Get.find<UserController>().userInfoModel.id.toString(), _callback);
              }



            }
          },
          radius: Dimensions.RADIUS_SMALL, height: 50,
        )
            :SizedBox(),

        SizedBox(height: 15,),
      ],),
    ): SizedBox();
  }


  @override
  Widget build(BuildContext context) {
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    double userImgWidth = context.width*0.5;
    double userImgHeight = context.width*0.35;
    return Scaffold(
      appBar: CustomAppBar(title:'prime_membership'.tr),

      body:  GetBuilder<UserController>(builder: (userController) {
        if(userController.userInfoModel != null && _phoneController.text.isEmpty ) {
          _firstNameController.text = userController.userInfoModel.fName + " "  + userController.userInfoModel.lName ;
          _phoneController.text = userController.userInfoModel.phone ?? '';
          _emailController.text = userController.userInfoModel.email ?? '';
        }
        return GetBuilder<PrimeMemberController>(builder: (primeController) {
          String _url = '${AppConstants.baseUrl}/uploads/primemebers';
          List<OneStateAllCity> stateCityList = primeController.stateCityList;
          List<City> cityList = primeController.cityList;
          List<String> relationList = primeController.relationList;
          List<Members> primeMembersList = primeController.primeMembersList;
          PrimeMemberDetailData primeMemberDetailData = primeController.primeMemberDetailData;

          if(primeController.referenceDropdownValue!=null){
            if(primeController.referenceDropdownValue.fName==null){
              _searchedPrimeController.text='${primeController.referenceDropdownValue.name}';

            }else{
              _searchedPrimeController.text='${primeController.referenceDropdownValue.fName} ${primeController.referenceDropdownValue.lName}';

            }

            Timer(Duration(seconds: 3), () async {
              _uploadReference(primeController,primeMemberDetailData);
            });
          }else{

            _searchedPrimeController.text='Search your reference';

          }
          if(
          (stateCityList!=null && stateCityList.isNotEmpty) &&
          (primeMembersList!=null && primeMembersList.isNotEmpty) &&
          (relationList!=null && relationList.isNotEmpty) &&
          primeMemberDetailData!=null && !isServerSideDataRendered
          ){

            print("primeMemberDetailData = testing run");
            try{



              primeId =primeMemberDetailData.id.toString();
             // final index = primeMembersList.indexWhere((element) =>
                  // element.id == primeMemberDetailData.parentId);
                  // if (index >= 0) {
                  //   primeController.updateReferenceDropdown(primeMembersList[index]);
                  // }
              //if(_user.primeMember==1){

                //
             // }

              if(stateCityList!=null && stateCityList.isNotEmpty && primeMemberDetailData.state!=null && primeMemberDetailData.state.isNotEmpty){

                final index = stateCityList.indexWhere((element) =>
                element.state == primeMemberDetailData.state);
                if (index >= 0) {
                  primeController.updateStateDropdown(stateCityList[index]);
                  primeController.cityListUpdate(-1,primeController.stateDropdownValue);
                }

                if(cityList!=null && cityList.isNotEmpty && primeMemberDetailData.city!=null && primeMemberDetailData.city.isNotEmpty){

                  var districtFromServer=primeMemberDetailData.city;

                  final index = cityList?.indexWhere((element) =>
                  element.city == districtFromServer);
                  if (index != null) {
                    if (index >= 0) {
                      primeController.updateCityDropdown(cityList[index]);
                    }
                  }
                }

              }


              if(relationList!=null && relationList.isNotEmpty && primeMemberDetailData.nomineeRelation!=null && primeMemberDetailData.nomineeRelation.isNotEmpty){

                final index = relationList.indexWhere((element) =>
                element == primeMemberDetailData.nomineeRelation);
                if (index >= 0) {
                  primeController.updateRelationDropdown(relationList[index]);
                }
              }

              //_searchedPrimeController.text = primeMemberDetailData.pin ?? '';
              _pinController.text = primeMemberDetailData.pin ?? '';
              _accNumberController.text = primeMemberDetailData.bankAccountNo ?? '';
              _confirmAccNumberController.text = primeMemberDetailData.bankAccountNo ?? '';
              _ifscController.text = primeMemberDetailData.bankIfc ?? '';
              _aadharCardController.text = primeMemberDetailData.aadharCard ?? '';
              _panController.text = primeMemberDetailData.panCard ?? '';
              _nomineeNameController.text = primeMemberDetailData.nomineeName ?? '';
              _nomineeNameController.text = primeMemberDetailData.nomineeName ?? '';
              _nomineeMobileController.text = primeMemberDetailData.nomineeMobile ?? '';
              _nomineePanController.text = primeMemberDetailData.nomineePanCard ?? '';
              _nomineeAadharController.text = primeMemberDetailData.nomineeAdharCard ?? '';

              isServerSideDataRendered=true;
              shouldUpdate=true;
              _checkFormCompleted(primeController);
            }
            catch(e){
              print("primeMemberDetailData = testing error = ${e.toString()}");
              _checkFormCompleted(primeController);
            }
          }


          return (

              (stateCityList==null || stateCityList.isEmpty)
                  && (primeMembersList==null || primeMembersList.isEmpty)
                  && (relationList==null || relationList.isEmpty)
                 && primeController.isPrimeMemberDetailLoading
          ) ? Center(child: CircularProgressIndicator(),)
              : Scrollbar(child: SingleChildScrollView(
            physics: BouncingScrollPhysics(),
            child: Container(
              color: Theme.of(context).cardColor,
              child:
              // primeController.upiScreenshotSubmitted ? afterUpiScreenshotSubmittedUI()
              //     : (primeController.isFormCompleted!=null && primeController.isFormCompleted)
              //     ? paymentMethodUI(primeController):
                  Container(
                padding: EdgeInsets.all(8.0),
                child: Column(mainAxisAlignment: MainAxisAlignment.center,crossAxisAlignment: CrossAxisAlignment.start,children: [

                  primeController.upiScreenshotSubmitted ? afterUpiScreenshotSubmittedUI():SizedBox(),

                  (primeController.isFormCompleted!=null && primeController.isFormCompleted==true && daysBetween()<1) ? paymentMethodUI(primeController,0):SizedBox(),

                  Text('Personal Information', style: robotoBlack.copyWith(fontSize: 20)),

                  SizedBox(height: 15,),

                  Container(
                    width: context.width,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(10),
                      color: Theme.of(context).cardColor,
                      boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                    ),
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                        SizedBox(height: primeMembersList==null?0: (_user.primeMember==1) ?0 : 8,),
                       Text('Reference', style:TextStyle(fontSize: 12, color: Colors.black)),

                        SizedBox(height: primeMembersList==null? 0: 8,),

                        // (primeMembersList==null || primeMembersList.isEmpty)? SizedBox()
                        //     : (_user.primeMember==1) ? SizedBox()
                        //     : DropdownButtonFormField<Members>(
                        //   isExpanded: true,
                        //   decoration: AppConstants.dropDownDecoration(),
                        //  // value: primeController.referenceDropdownValue??primeMembersList[0],
                        //   value: primeController.referenceDropdownValue!=null?primeController.referenceDropdownValue:primeMembersList[0],
                        //   onChanged: (Members newValue) {
                        //     primeController.updateReferenceDropdown(newValue);
                        //     if (newValue!=null && newValue.fName!="Select Reference") {
                        //       _uploadReference(primeController,primeMemberDetailData);
                        //     }
                        //   },
                        //   items:primeMembersList.map<DropdownMenuItem<Members>>((Members value) {
                        //     return DropdownMenuItem<Members>(
                        //       value: value,
                        //       enabled: _user.primeMember==1 ? false : true,
                        //       child: value==null?SizedBox() : Text('${ value.primeAccount==null? "" :  value.primeAccount.toString() } ${value.fName.toString()}'
                        //           ' ${value.lName.toString()} '),
                        //     );
                        //   }).toList(),
                        // ),

                         Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          crossAxisAlignment: CrossAxisAlignment.center,
                          children: [
                            Expanded(child: InkWell(child: Container(
                              padding: EdgeInsets.all(5),
                              decoration: BoxDecoration(
                                borderRadius: BorderRadius.circular(5),
                                color: Colors.white,
                                boxShadow: [
                                  BoxShadow(color: Colors.black54, spreadRadius: 0.3),
                                ],
                              ),
                              child: Padding(
                                padding: const EdgeInsets.all(8.0),
                                child: TextField(
                                  decoration: InputDecoration.collapsed(
                                    hintText: "",
                                    border: InputBorder.none,
                                  ),
                                  controller: _searchedPrimeController,
                                  enabled: false,
                                ),
                              ),
                            ),onTap: (){

                              if(_user.primeMember==0){
                                Get.toNamed(RouteHelper.getPrimeSearchRoute());
                              }else{
                                showCustomSnackBar('Reference can not be changed.');
                              }

                            },)),

                            SizedBox(width: 2,),
                            _user.primeMember==1 ? SizedBox() : InkWell(child:
                            Container(
                                color: Theme.of(context).primaryColor,
                                child: Padding(
                                  padding: const EdgeInsets.all(5.0),
                                  child: Text('Change', style:TextStyle(fontSize: 12, color: Colors.white)),

                                )),onTap: (){

                              Get.toNamed(RouteHelper.getPrimeSearchRoute());
                            })
                          ],
                        ),
                        SizedBox(height: stateCityList==null?0:spaceBetweenEdtText,),
                        CustomTextField(
                          hintText: 'name'.tr,
                          controller: _firstNameController,
                          focusNode: _firstNameFocus,
                          nextFocus: _phoneFocus,
                          isEnabled: false,
                          inputType: TextInputType.name,
                          capitalization: TextCapitalization.words,
                          divider: false,
                          showTitle: true
                          ,showBorderStyle: true,
                        ),

                        SizedBox(height: spaceBetweenEdtText,),
                        Row(
                          children: [
                            Expanded(child: CustomTextField(
                              hintText: 'Mobile',
                              controller: _phoneController,
                              focusNode: _phoneFocus,
                              isEnabled: false,
                              inputType: TextInputType.phone,
                              divider: false,showTitle: true
                              ,showBorderStyle: true,
                            )),

                            // OutlinedButton(
                            //   onPressed: () {},
                            //   child: Text('Unverified'),
                            //   style: OutlinedButton.styleFrom(
                            //     shape: BeveledRectangleBorder(
                            //       borderRadius: BorderRadius.circular(12),
                            //     ),
                            //   ),
                            // )
                          ],
                        ),

                        SizedBox(height: spaceBetweenEdtText,),

                        CustomTextField(
                          hintText: 'email'.tr,
                          controller: _emailController,
                          focusNode: _emailFocus,
                          isEnabled: false,
                          inputAction: TextInputAction.done,
                          inputType: TextInputType.emailAddress,
                          divider: false,showTitle: true
                          ,showBorderStyle: true,
                        ),
                        SizedBox(height: (stateCityList==null || stateCityList.isEmpty)?0:spaceBetweenEdtText,),
                        Text('State', style:TextStyle(fontSize: 12, color: Colors.black)),

                        SizedBox(height: (stateCityList==null || stateCityList.isEmpty)?0:10,),

                        (stateCityList==null || stateCityList.isEmpty)? SizedBox() :
                        DropdownButtonFormField<OneStateAllCity>(
                          isExpanded: true,
                            decoration: AppConstants.dropDownDecoration(),
                          value: primeController.stateDropdownValue??stateCityList[0],
                          onChanged: (OneStateAllCity newValue) {
                            primeController.updateStateDropdown(newValue);
                            primeController.cityListUpdate(-1,primeController.stateDropdownValue);
                          },
                          items:stateCityList.map<DropdownMenuItem<OneStateAllCity>>((OneStateAllCity value) {
                            return DropdownMenuItem<OneStateAllCity>(
                              value: value,
                              child: Text(value==null?"" :value.state.toString()),
                            );
                          }).toList(),
                        ),


                        SizedBox(height: ( cityList==null || cityList.isEmpty)?0:20,),

                        Text(( cityList==null || cityList.isEmpty)?'': 'City', style:TextStyle(fontSize: 12, color: Colors.black)),

                        SizedBox(height: ( cityList==null || cityList.isEmpty)?0:10,),

                        ( cityList==null || cityList.isEmpty) ? SizedBox() :  DropdownButtonFormField<City>(
                          isExpanded: true,
                          decoration: AppConstants.dropDownDecoration(),
                          value: cityList[0],
                          onChanged: (City newValue) {
                            primeController.updateCityDropdown(newValue);
                          },
                          items:cityList.map<DropdownMenuItem<City>>((City value) {
                            return DropdownMenuItem<City>(
                              value: value,
                              child: Text(value==null?"" :value.city.toString()),
                            );
                          }).toList(),
                        ),


                        SizedBox(height: stateCityList==null?0:spaceBetweenEdtText,),

                        CustomTextField(
                          hintText: 'Pin',
                          controller: _pinController,
                          // focusNode: _firstNameFocus,
                          // nextFocus: _lastNameFocus,
                          inputType: TextInputType.number,
                          divider: false,showTitle: true
                          ,showBorderStyle: true,
                        ),
                        SizedBox(height: spaceBetweenEdtText,),
                        Text('Photo', style:TextStyle(fontSize: 15, color: Colors.black)),
                        Center(
                          child: Stack(
                              children: [
                                primeController.isUserImageLoading ? Container(color: Colors.grey,height: userImgHeight ,width: userImgWidth,child: Center(child: CircularProgressIndicator()),)
                                    : ClipRRect(
                                  borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                                  child: primeController.rawUserImageFile != null ? Image.memory(
                                    primeController.rawUserImageFile, height: userImgHeight, width: userImgWidth, fit: BoxFit.contain,
                                  ) : CustomImage(
                                    image: (primeMemberDetailData==null || primeMemberDetailData.image==null)? ''
                                        : '${Get.find<SplashController>().configModel.baseUrls.customerImageUrl}/${primeMemberDetailData.image}',

                                    height: userImgHeight, width: userImgWidth, fit: BoxFit.contain,
                                  ),
                                ),

                                Positioned(
                                  bottom: 10,
                                  right: 10,
                                  child: UploadImageWidget(onTap: () => primeController.pickUserImage()),
                                ),
                              ]),
                        ),

                        SizedBox(height: 10,),

                        Center(
                          child: primeController.isLoading? CircularProgressIndicator() : ElevatedButton(
                              child: Padding(
                                padding: const EdgeInsets.all(8.0),
                                child: Text(
                                    shouldUpdate?"Update".toUpperCase():"Upload".toUpperCase(),
                                    style: TextStyle(fontSize: 14)
                                ),
                              ),
                              style: ButtonStyle(
                                  shape: MaterialStateProperty.all<RoundedRectangleBorder>(RoundedRectangleBorder(borderRadius: BorderRadius.circular(10.0),))
                              ),
                              onPressed: () {
                                _uploadPersonalDetails(primeController,primeMemberDetailData);
                              }
                          ),
                        ),
                       // primeController.isPersonalDetailsSubmitted? Row(
                       //    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                       //    children: [
                       //      SizedBox(),
                       //      Image.asset(
                       //        Images.checked,
                       //        height: 25,
                       //        width: 25,
                       //        fit: BoxFit.fill,
                       //      ),
                       //
                       //    ],
                       //  )
                       //     :SizedBox()

                      ]),
                    ),
                  ),


                  SizedBox(height: 25,),

                  Text('Bank Details', style: robotoBlack.copyWith(fontSize: 20)),
                  SizedBox(height: 10,),

                  Container(
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(16),
                      color: Theme.of(context).cardColor,
                      boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                    ),
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            SizedBox(height: 10,),
                            CustomTextField(
                              hintText: 'enter_account_number'.tr,
                              controller: _accNumberController,
                              focusNode: _accNumberFocus,
                              nextFocus: _confirmAccNumberFocus,
                              inputType: TextInputType.text,
                              capitalization: TextCapitalization.words,
                              divider: false
                              ,showTitle: true
                              ,showBorderStyle: true,
                              onChanged: (text) {
                                _bothAccountMatched.text="Bank Account number and Confirm bank account number is not same";
                                primeController.updateBothAccountNumberMatched(false);
                              },
                            ),
                            SizedBox(height: spaceBetweenEdtText,),
                            CustomTextField(
                              hintText: 'confirm_account_number'.tr,
                              controller: _confirmAccNumberController,
                              focusNode: _confirmAccNumberFocus,
                              nextFocus: _ifscFocus,
                              inputType: TextInputType.text,
                              capitalization: TextCapitalization.words,
                              divider: false,showTitle: true
                              ,showBorderStyle: true,
                              onChanged: (text) {

                                if(_accNumberController.text.trim().isNotEmpty
                                    && _confirmAccNumberController.text.trim().isNotEmpty
                                    && _accNumberController.text.trim()==_confirmAccNumberController.text.trim()
                                ){
                                  _bothAccountMatched.text="Bank Account number and Confirm bank account number is same";
                                  primeController.updateBothAccountNumberMatched(true);
                                }else{
                                  _bothAccountMatched.text="Bank Account number and Confirm bank account number is not same";
                                  primeController.updateBothAccountNumberMatched(false);
                                }
                              },
                            ),


                            primeController.isBothAccountNumberMatched==null?SizedBox()
                                :   Padding(
                              padding:  EdgeInsets.only(left: 5,top: 2,right: 5),
                              child:  Container(
                                  padding:  EdgeInsets.all(5),
                                  width: context.width,
                                  color: primeController.isBothAccountNumberMatched? Colors.green.withOpacity(0.2) : Colors.transparent,
                                  child: Text(_bothAccountMatched.text.toString(),

                                      style: robotoMedium.copyWith(fontSize: 14,  color: primeController.isBothAccountNumberMatched? Colors.green : Colors.red))),
                            ),
                            SizedBox(height: spaceBetweenEdtText,),


                            CustomTextField(
                              hintText: 'ifsc_code'.tr,
                              controller: _ifscController,
                              focusNode: _ifscFocus,
                              nextFocus: _aadharCardFocus,
                              inputType: TextInputType.text,
                              capitalization: TextCapitalization.words,
                              divider: false,showTitle: true
                              ,showBorderStyle: true,
                            ),

                            SizedBox(height: spaceBetweenEdtText,),

                            Center(
                              child: primeController.isLoading? CircularProgressIndicator() : ElevatedButton(
                                  child: Padding(
                                    padding: const EdgeInsets.all(8.0),
                                    child: Text(
                                        shouldUpdate?"Update".toUpperCase():"Upload".toUpperCase(),
                                        style: TextStyle(fontSize: 14)
                                    ),
                                  ),
                                  style: ButtonStyle(
                                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(RoundedRectangleBorder(borderRadius: BorderRadius.circular(10.0),))
                                  ),
                                  onPressed: () {
                                    _uploadBankDetails(primeController,primeMemberDetailData);
                                  }
                              ),
                            ),

                          ]),
                    ),
                  ),

                  SizedBox(height: 25,),

                  Text('KYC', style: robotoBlack.copyWith(fontSize: 20)),
                  SizedBox(height: 10,),

                  Container(
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(16),
                      color: Theme.of(context).cardColor,
                      boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                    ),
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Column(children: [

                        SizedBox(height: 10,),
                        CustomTextField(
                          hintText: 'Aadhar Card Number',
                          controller: _aadharCardController,
                          focusNode: _aadharCardFocus,
                          nextFocus: _panFocus,
                          inputType: TextInputType.text,
                          capitalization: TextCapitalization.words,
                          divider: false,showTitle: true
                          ,showBorderStyle: true,
                        ),

                        SizedBox(height: spaceBetweenEdtText,),

                        Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                          Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              Text('Aadhar Card Front', style:TextStyle(fontSize: 14, color: Colors.black)),
                              OutlinedButton(
                                onPressed: () {},
                                child: Text('Unverified'),
                                style: OutlinedButton.styleFrom(
                                  shape: BeveledRectangleBorder(
                                    borderRadius: BorderRadius.circular(12),
                                  ),
                                ),
                              )
                            ],
                          ),
                          SizedBox(height: 10,),
                          Stack(children: [
                            primeController.isAadharImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                              borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                              child: primeController.rawAadharImageFile != null ? Image.memory(
                                primeController.rawAadharImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                              ) : CustomImage(
                                image: (primeMemberDetailData==null || primeMemberDetailData.aadharCardImage==null)? ''
                                    : '$_url/${primeMemberDetailData.aadharCardImage}',
                                height: 140, width: double.infinity, fit: BoxFit.contain,
                              ),
                            ),

                            Positioned(
                              bottom: 10,
                              right: 10,
                              child: UploadImageWidget(onTap: () => primeController.pickAadharImage()),
                            ),
                          ])
                        ],),

                        Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                          Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              Text('Aadhar Card Back', style:TextStyle(fontSize: 14, color: Colors.black)),
                              OutlinedButton(
                                onPressed: () {},
                                child: Text('Unverified'),
                                style: OutlinedButton.styleFrom(
                                  shape: BeveledRectangleBorder(
                                    borderRadius: BorderRadius.circular(12),
                                  ),
                                ),
                              )
                            ],
                          ),
                          SizedBox(height: 10,),
                          Stack(children: [
                            primeController.isAadharBackImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                              borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                              child: primeController.rawAadharBackImageFile != null ? Image.memory(
                                primeController.rawAadharBackImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                              ) : CustomImage(
                                image: (primeMemberDetailData==null || primeMemberDetailData.aadharCardImageBack==null)? ''
                                    : '$_url/${primeMemberDetailData.aadharCardImageBack}',
                                height: 140, width: double.infinity, fit: BoxFit.contain,
                              ),
                            ),

                            Positioned(
                              bottom: 10,
                              right: 10,
                              child: UploadImageWidget(onTap: () => primeController.pickAadharBackImage()),
                            ),
                          ])
                        ],),

                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                            SizedBox(height: spaceBetweenEdtText,),
                            CustomTextField(
                              hintText: 'Pan Card Number',
                              controller: _panController,
                              focusNode: _panFocus,
                              inputType: TextInputType.text,
                              capitalization: TextCapitalization.words,
                              divider: false
                              ,showTitle: true
                              ,showBorderStyle: true,
                            ),
                            SizedBox(height: 10,),


                            Text('pan_front'.tr, style:TextStyle(fontSize: 15, color: Colors.black)),
                            SizedBox(height: 10,),
                            Stack(children: [
                              primeController.isPanImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                                borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                                child: primeController.rawPanImageFile != null ? Image.memory(
                                  primeController.rawPanImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                                ) : CustomImage(
                                  image: (primeMemberDetailData==null || primeMemberDetailData.panCardImage==null)? ''
                                      : '$_url/${primeMemberDetailData.panCardImage}',
                                  height: 140, width: double.infinity, fit: BoxFit.contain,
                                ),
                              ),

                              Positioned(
                                bottom: 10,
                                right: 10,
                                child: UploadImageWidget(onTap: () => primeController.pickPanImage()),
                              ),
                            ])
                          ],),
                        ),

                        // Padding(padding: EdgeInsets.symmetric(horizontal: Dimensions.PADDING_SIZE_LARGE), child: Divider(height: 1)),

                        SizedBox(height: spaceBetweenEdtText,),

                        Center(
                          child: primeController.isLoading? CircularProgressIndicator() : ElevatedButton(
                              child: Padding(
                                padding: const EdgeInsets.all(8.0),
                                child: Text(
                                    shouldUpdate?"Update".toUpperCase():"Upload".toUpperCase(),
                                    style: TextStyle(fontSize: 14)
                                ),
                              ),
                              style: ButtonStyle(
                                  shape: MaterialStateProperty.all<RoundedRectangleBorder>(RoundedRectangleBorder(borderRadius: BorderRadius.circular(10.0),))
                              ),
                              onPressed: () {
                                _uploadKycDetails(primeController,primeMemberDetailData);
                              }
                          ),
                        ),

                      ]),
                    ),
                  ),



                  SizedBox(height: 25,),

                  Text('Nominee', style: robotoBlack.copyWith(fontSize: 20)),
                  SizedBox(height: 10,),

                  Container(
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(16),
                      color: Theme.of(context).cardColor,
                      boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                    ),
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                        SizedBox(height: spaceBetweenEdtText,),
                        CustomTextField(
                          hintText: 'Nominee Name',
                          controller: _nomineeNameController,

                          nextFocus: _nomineeMobileCardFocus,
                          inputType: TextInputType.name,
                          capitalization: TextCapitalization.words,
                          divider: false,showTitle: true
                          ,showBorderStyle: true,
                        ),
                        SizedBox(height: spaceBetweenEdtText,),
                        Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          crossAxisAlignment: CrossAxisAlignment.center,
                          children: [
                            Expanded(child: CustomTextField(
                              hintText: 'Nominee Mobile',
                              controller: _nomineeMobileController,
                              focusNode: _nomineeMobileCardFocus,
                              // nextFocus: _lastNameFocus,
                              inputType: TextInputType.phone,
                              divider: false,showTitle: true
                              ,showBorderStyle: true,
                            )),

                            SizedBox(width: 2,),
                            Container(
                                color: Colors.red,
                                child: Padding(
                              padding: const EdgeInsets.all(5.0),
                              child: Text('Unverified', style:TextStyle(fontSize: 12, color: Colors.white)),

                            ))
                          ],
                        ),

                        SizedBox(height: spaceBetweenEdtText,),
                       Text('Relation', style:TextStyle(fontSize: 12, color: Colors.black)),

                        SizedBox(height: relationList==null?0:10,),

                        relationList==null?SizedBox() : DropdownMenu<String>(
                          width: context.width*0.8,
                          enabled: true,
                          enableSearch: false,
                          initialSelection: primeController.relationDropdownValue??relationList[0],
                          onSelected: (String value) {
                            primeController.updateRelationDropdown(value);

                          },
                          dropdownMenuEntries: relationList.map<DropdownMenuEntry<String>>((String value) {
                            return DropdownMenuEntry<String>(value: value, label: value);
                          }).toList(),
                        ),

                        SizedBox(height: spaceBetweenEdtText,),

                        CustomTextField(
                          hintText: 'Nominee Aadhar Card Number',
                          controller: _nomineeAadharController,
                          inputType: TextInputType.text,
                          capitalization: TextCapitalization.words,
                          divider: false
                          ,showTitle: true
                          ,showBorderStyle: true,
                        ),
                        SizedBox(height: 10,),

                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                            Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                Text('Nominee Aadhar Card Front', style:TextStyle(fontSize: 15, color: Colors.black)),
                                SizedBox(width: 2,),
                                Container(
                                    color: Colors.red,
                                    child: Padding(
                                      padding: const EdgeInsets.all(5.0),
                                      child: Text('Unverified', style:TextStyle(fontSize: 12, color: Colors.white)),

                                    ))
                              ],
                            ),
                            SizedBox(height: 10,),
                            Stack(children: [
                              primeController.isNomineeAadharImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                                borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                                child: primeController.rawNomineeAadharImageFile != null ? Image.memory(
                                  primeController.rawNomineeAadharImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                                ) : CustomImage(
                                  image: (primeMemberDetailData==null || primeMemberDetailData.nomineeAdharCardImage==null)? ''
                                      : '$_url/${primeMemberDetailData.nomineeAdharCardImage}',
                                  height: 140, width: double.infinity, fit: BoxFit.contain,
                                ),
                              ),

                              Positioned(
                                bottom: 10,
                                right: 10,
                                child: UploadImageWidget(onTap: () => primeController.pickNomineeAadharImage()),
                              ),
                            ])
                          ],),
                        ),

                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                            Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                Text('Nominee Aadhar Card Back', style:TextStyle(fontSize: 15, color: Colors.black)),
                                SizedBox(width: 2,),
                                Container(
                                    color: Colors.red,
                                    child: Padding(
                                      padding: const EdgeInsets.all(5.0),
                                      child: Text('Unverified', style:TextStyle(fontSize: 12, color: Colors.white)),

                                    ))
                              ],
                            ),
                            SizedBox(height: 10,),
                            Stack(children: [
                              primeController.isNomineeAadharBackImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                                borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                                child: primeController.rawNomineeAadharBackImageFile != null ? Image.memory(
                                  primeController.rawNomineeAadharBackImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                                ) : CustomImage(
                                  image: (primeMemberDetailData==null || primeMemberDetailData.nomineeAdharCardImageBack==null)? ''
                                      : '$_url/${primeMemberDetailData.nomineeAdharCardImageBack}',
                                  height: 140, width: double.infinity, fit: BoxFit.contain,
                                ),
                              ),

                              Positioned(
                                bottom: 10,
                                right: 10,
                                child: UploadImageWidget(onTap: () => primeController.pickNomineeAadharBackImage()),
                              ),
                            ])
                          ],),
                        ),

                        Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [
                            CustomTextField(
                              hintText: 'Nominee Pan Card Number',
                              controller: _nomineePanController,
                              inputType: TextInputType.text,
                              capitalization: TextCapitalization.words,
                              divider: false
                              ,showTitle: true
                              ,showBorderStyle: true,
                            ),
                            SizedBox(height: 10,),
                            Text('Nominee Pan card Front', style:TextStyle(fontSize: 15, color: Colors.black)),
                            SizedBox(height: 10,),
                            Stack(children: [
                              primeController.isNomineePanImageLoading ? Container(color: Colors.grey,height: 140,width: double.infinity,child: Center(child: CircularProgressIndicator()),) : ClipRRect(
                                borderRadius: BorderRadius.vertical(top: Radius.circular(Dimensions.RADIUS_SMALL)),
                                child: primeController.rawNomineePanImageFile != null ? Image.memory(
                                  primeController.rawNomineePanImageFile, height: 140, width: double.infinity, fit: BoxFit.contain,
                                ) : CustomImage(
                                  image: (primeMemberDetailData==null || primeMemberDetailData.nomineePanCardImage==null)? ''
                                      : '$_url/${primeMemberDetailData.nomineePanCardImage}',
                                  height: 140, width: double.infinity, fit: BoxFit.contain,
                                ),
                              ),

                              Positioned(
                                bottom: 10,
                                right: 10,
                                child: UploadImageWidget(onTap: () => primeController.pickNomineePanImage()),
                              ),
                            ])
                          ],),
                        ),

                        SizedBox(height: 10,),
                      ]),
                    ),
                  ),
                  SizedBox(height: 10,),

                  Center(
                    child: primeController.isLoading? CircularProgressIndicator() : ElevatedButton(
                        child: Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Text(
                              shouldUpdate?"Update".toUpperCase():"Submit".toUpperCase(),
                              style: TextStyle(fontSize: 14)
                          ),
                        ),
                        style: ButtonStyle(
                            shape: MaterialStateProperty.all<RoundedRectangleBorder>(RoundedRectangleBorder(borderRadius: BorderRadius.circular(10.0),))
                        ),
                        onPressed: () {
                          _uploadNomineeDetails(primeController,primeMemberDetailData);
                        }
                    ),
                  ),

                  daysBetween()<1? paymentMethodUI(primeController,0) : SizedBox(),



                ]),
              ),
            ),
          ));
        });
      }),
    );
  }

  String returnDefaultValue(String inputValue){
    if(inputValue==null){
      return "NA";
    }
   else if(inputValue.isEmpty||  inputValue=="NA"){
      inputValue="NA";
      return inputValue;
    }
    return inputValue;
  }
  void _uploadReference(PrimeMemberController primeController, PrimeMemberDetailData primeMemberDetailData) async {

    print("_uploadReference search ${primeController.goingToSearchClicked}");
    if(primeController.goingToSearchClicked){
      primeController.setGoingToSearch(false);

      String _state;
      String _city;
      String _referenceId;

      if(primeController.referenceDropdownValue!=null){
        _referenceId = primeController.referenceDropdownValue.id.toString();
      }
      if(primeController.stateDropdownValue!=null){
        _state = primeController.stateDropdownValue.state;
      }
      if(primeController.cityDropdownValue!=null){
        _city = primeController.cityDropdownValue.city;
      }

      String nomineeRelation;
      if(primeController.relationDropdownValue!=null){
        nomineeRelation = primeController.relationDropdownValue;
      }


      String _pin = _pinController.text.trim();
      String _accNumber = _accNumberController.text.trim();
      String _ifsc = _ifscController.text.trim();

      String _aadharCard = _aadharCardController.text.trim();
      String _panCard = _panController.text.trim();
      String _nomineeName = _nomineeNameController.text.trim();
      String _nomineeMobile = _nomineeMobileController.text.trim();

      String _nomineeAadhar = _nomineeAadharController.text.trim();
      String _nomineePan = _nomineePanController.text.trim();
      UserInfoModel _user =  Get.find<UserController>().userInfoModel;
      if ( _user.primeMember==0 && (_referenceId==null ||_referenceId=="-1")) {
        showCustomSnackBar('Select Your Reference');
      }
      else {

        primeController.uploadDocument(
            shouldUpdate,
            returnDefaultValue(_state),
            returnDefaultValue(_city),
            returnDefaultValue(_pin) ,
            returnDefaultValue(_accNumber) ,
            returnDefaultValue(_ifsc) ,
            returnDefaultValue(_aadharCard) ,
            returnDefaultValue(_panCard) ,
            returnDefaultValue(_nomineeName),
            returnDefaultValue(_nomineeMobile) ,
            returnDefaultValue(nomineeRelation),
            returnDefaultValue(_nomineeAadhar) ,
            returnDefaultValue(_nomineePan) ,
            _referenceId
        ).then((status) async {

          if(status.isSuccess){
            setState(() {
              shouldUpdate=true;
            });
            primeController.setGoingToSearch(false);
            showCustomSnackBar("Reference Selected",isError: false);
          }else{
            primeController.setGoingToSearch(false);
            showCustomSnackBar(status.message,isError: true);
          }

        });


        // if(_responseModel.isSuccess) {
        //   primeController.updatePersonalDetailsSubmitted();
        // }else {
        //   showCustomSnackBar(_responseModel.message);
        // }
      }
    }

  }

  void _uploadPersonalDetails (PrimeMemberController primeController, PrimeMemberDetailData primeMemberDetailData) async {
    String _state;
    String _city;
    String _referenceId;

    if(primeController.referenceDropdownValue!=null){
      _referenceId = primeController.referenceDropdownValue.id.toString();
    }
    if(primeController.stateDropdownValue!=null){
      _state = primeController.stateDropdownValue.state;
    }
    if(primeController.cityDropdownValue!=null){
      _city = primeController.cityDropdownValue.city;
    }

    String nomineeRelation;
    if(primeController.relationDropdownValue!=null){
      nomineeRelation = primeController.relationDropdownValue;
    }


    String _pin = _pinController.text.trim();
    String _accNumber = _accNumberController.text.trim();
    String _ifsc = _ifscController.text.trim();

    String _aadharCard = _aadharCardController.text.trim();
    String _panCard = _panController.text.trim();
    String _nomineeName = _nomineeNameController.text.trim();
    String _nomineeMobile = _nomineeMobileController.text.trim();

    String _nomineeAadhar = _nomineeAadharController.text.trim();
    String _nomineePan = _nomineePanController.text.trim();
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    if ( _user.primeMember==0 && (_referenceId==null ||_referenceId=="-1")) {
      showCustomSnackBar('Select Your Reference');
    }
    else if (_state==null ||_state=="Select State") {
      showCustomSnackBar('Select State');
    }
    else if (_city==null) {
      showCustomSnackBar('Select City');
    }else if (_pin.isEmpty) {
      showCustomSnackBar('Enter Pin Code');
    }else if (_pin.length<6) {
      showCustomSnackBar('Enter Valid Pin Code');
    }
    else if (primeController.rawUserImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.image==null
            || primeMemberDetailData.image.isEmpty
        )) {
      showCustomSnackBar('Select User Image');
    }

    else {
      primeController.uploadDocument(
          shouldUpdate,
          _state,
          _city,
          _pin,
          returnDefaultValue(_accNumber) ,
          returnDefaultValue(_ifsc) ,
          returnDefaultValue(_aadharCard) ,
          returnDefaultValue(_panCard) ,
          returnDefaultValue(_nomineeName) ,
          returnDefaultValue(_nomineeMobile) ,
          returnDefaultValue(nomineeRelation) ,
          returnDefaultValue(_nomineeAadhar) ,
          returnDefaultValue(_nomineePan) ,
          _referenceId
      ).then((status) async {

        if(status.isSuccess){
          setState(() {
            shouldUpdate=true;
          });
          showCustomSnackBar("Personal Information Uploaded",isError: false);
        }else{
          showCustomSnackBar(status.message,isError: true);
        }

      });


      // if(_responseModel.isSuccess) {
      //   primeController.updatePersonalDetailsSubmitted();
      // }else {
      //   showCustomSnackBar(_responseModel.message);
      // }
    }
  }

  void _uploadBankDetails(PrimeMemberController primeController, PrimeMemberDetailData primeMemberDetailData) async {
    String _state;
    String _city;
    String _referenceId;

    if(primeController.referenceDropdownValue!=null){
      _referenceId = primeController.referenceDropdownValue.id.toString();
    }
    if(primeController.stateDropdownValue!=null){
      _state = primeController.stateDropdownValue.state;
    }
    if(primeController.cityDropdownValue!=null){
      _city = primeController.cityDropdownValue.city;
    }

    String nomineeRelation;
    if(primeController.relationDropdownValue!=null){
      nomineeRelation = primeController.relationDropdownValue;
    }


    String _pin = _pinController.text.trim();
    String _accNumber = _accNumberController.text.trim();
    String _confirmAccNumber = _confirmAccNumberController.text.trim();
    String _ifsc = _ifscController.text.trim();

    String _aadharCard = _aadharCardController.text.trim();
    String _panCard = _panController.text.trim();
    String _nomineeName = _nomineeNameController.text.trim();
    String _nomineeMobile = _nomineeMobileController.text.trim();

    String _nomineeAadhar = _nomineeAadharController.text.trim();
    String _nomineePan = _nomineePanController.text.trim();
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    if (_user.primeMember==0 && (_referenceId==null ||_referenceId=="-1")) {
      showCustomSnackBar('Select Your Reference');
    }
    else if (_state==null ||_state=="Select State") {
    showCustomSnackBar('Select State');
    }
    else if (_city==null) {
      showCustomSnackBar('Select City');
    }else if (_pin.isEmpty) {
      showCustomSnackBar('Enter Pin Code');
    }else if (_pin.length<6) {
       showCustomSnackBar('Enter Valid Pin Code');
    }
    else if (primeController.rawUserImageFile==null
        && (primeMemberDetailData==null
        || primeMemberDetailData.image==null
        || primeMemberDetailData.image.isEmpty
    )) {
      showCustomSnackBar('Select User Image');
    }

    else if (_accNumber.isEmpty || _accNumber=="NA") {
       showCustomSnackBar('Enter Bank Account Number');
     }
     else if (_confirmAccNumber.isEmpty || _confirmAccNumber!=_accNumber || _confirmAccNumber=="NA") {
       showCustomSnackBar('Account number and Confirm account number do not match');
     }
     else if (_ifsc.isEmpty|| _ifsc=="NA") {
       showCustomSnackBar('Enter IFSC Code');
    }
     else {
      primeController.uploadDocument(shouldUpdate,
          _state,
          _city,
          _pin,
          _accNumber,
          _ifsc,
          returnDefaultValue(_aadharCard) ,
          returnDefaultValue(_panCard) ,
          returnDefaultValue(_nomineeName) ,
          returnDefaultValue(_nomineeMobile) ,
          returnDefaultValue(nomineeRelation) ,
          returnDefaultValue(_nomineeAadhar) ,
          returnDefaultValue(_nomineePan) ,
          _referenceId).then((status) async {
        if(status.isSuccess){
          setState(() {
            shouldUpdate=true;
          });
          showCustomSnackBar("Bank Details Uploaded",isError: false);
        }else{
          showCustomSnackBar(status.message,isError: true);
        }
      });




    }
  }


  void _uploadKycDetails(PrimeMemberController primeController, PrimeMemberDetailData primeMemberDetailData) async {
    String _state;
    String _city;
    String _referenceId;

    if(primeController.referenceDropdownValue!=null){
      _referenceId = primeController.referenceDropdownValue.id.toString();
    }
    if(primeController.stateDropdownValue!=null){
      _state = primeController.stateDropdownValue.state;
    }
    if(primeController.cityDropdownValue!=null){
      _city = primeController.cityDropdownValue.city;
    }

    String nomineeRelation;
    if(primeController.relationDropdownValue!=null){
      nomineeRelation = primeController.relationDropdownValue;
    }


    String _pin = _pinController.text.trim();
    String _accNumber = _accNumberController.text.trim();
    String _confirmAccNumber = _confirmAccNumberController.text.trim();
    String _ifsc = _ifscController.text.trim();

    String _aadharCard = _aadharCardController.text.trim();
    String _panCard = _panController.text.trim();
    String _nomineeName = _nomineeNameController.text.trim();
    String _nomineeMobile = _nomineeMobileController.text.trim();

    String _nomineeAadhar = _nomineeAadharController.text.trim();
    String _nomineePan = _nomineePanController.text.trim();
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    if (_user.primeMember==0 && (_referenceId==null ||_referenceId=="-1")) {
      showCustomSnackBar('Select Your Reference');
    }
    else if (_state==null ||_state=="Select State") {
    showCustomSnackBar('Select State');
    }
    else if (_city==null) {
      showCustomSnackBar('Select City');
    }else if (_pin.isEmpty || _pin=="NA") {
      showCustomSnackBar('Enter Pin Code');
    }else if (_pin.length<6) {
       showCustomSnackBar('Enter Valid Pin Code');
    }
    else if (primeController.rawUserImageFile==null
        && (primeMemberDetailData==null
        || primeMemberDetailData.image==null
        || primeMemberDetailData.image.isEmpty
    )) {
      showCustomSnackBar('Select User Image');
    }

    else if (_accNumber.isEmpty || _accNumber=="NA") {
       showCustomSnackBar('Enter Bank Account Number');
     }
     else if (_confirmAccNumber.isEmpty || _confirmAccNumber!=_accNumber || _confirmAccNumber=="NA") {
       showCustomSnackBar('The account number do not match');
     }
     else if (_ifsc.isEmpty || _ifsc=="NA") {
       showCustomSnackBar('Enter IFSC Code');
    }else if (_aadharCard.isEmpty || _aadharCard=="NA") {
       showCustomSnackBar('Enter Aadhar Card Number');
    }else if (primeController.rawAadharImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.aadharCardImage==null
            || primeMemberDetailData.aadharCardImage.isEmpty
        )
    ) {
       showCustomSnackBar('Select Aadhar Card Front Image');
    }
     else if (primeController.rawAadharBackImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.aadharCardImageBack==null
            || primeMemberDetailData.aadharCardImageBack.isEmpty
        )
    ) {
       showCustomSnackBar('Select Aadhar Card Front Image');
    }
     else if (_panCard.isEmpty || _panCard=="NA") {
       showCustomSnackBar('Enter Pan Card Number');
     }else if (primeController.rawPanImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.panCardImage==null
            || primeMemberDetailData.panCardImage.isEmpty
        )
    ) {
       showCustomSnackBar('Select Pan Card Image');
     }
     else {
      primeController.uploadDocument(shouldUpdate,
          _state,
          _city,
          _pin,
          _accNumber,
          _ifsc,
          _aadharCard,
          _panCard,
          returnDefaultValue(_nomineeName) ,
          returnDefaultValue(_nomineeMobile) ,
          returnDefaultValue(nomineeRelation) ,
          returnDefaultValue(_nomineeAadhar) ,
          returnDefaultValue(_nomineePan) ,
          _referenceId).then((status) async {
        if(status.isSuccess){
          setState(() {
            shouldUpdate=true;
          });
          showCustomSnackBar("KYC Details Uploaded",isError: false);
        }else{
          showCustomSnackBar(status.message,isError: true);
        }
      });


    }
  }


  void _uploadNomineeDetails(PrimeMemberController primeController, PrimeMemberDetailData primeMemberDetailData) async {
    String _state;
    String _city;
    String _referenceId;

    if(primeController.referenceDropdownValue!=null){
      _referenceId = primeController.referenceDropdownValue.id.toString();
    }
    if(primeController.stateDropdownValue!=null){
      _state = primeController.stateDropdownValue.state;
    }
    if(primeController.cityDropdownValue!=null){
      _city = primeController.cityDropdownValue.city;
    }

    String nomineeRelation;
    if(primeController.relationDropdownValue!=null){
      nomineeRelation = primeController.relationDropdownValue;
    }


    String _pin = _pinController.text.trim();
    String _accNumber = _accNumberController.text.trim();
    String _confirmAccNumber = _confirmAccNumberController.text.trim();
    String _ifsc = _ifscController.text.trim();

    String _aadharCard = _aadharCardController.text.trim();
    String _panCard = _panController.text.trim();
    String _nomineeName = _nomineeNameController.text.trim();
    String _nomineeMobile = _nomineeMobileController.text.trim();

    String _nomineeAadhar = _nomineeAadharController.text.trim();
    String _nomineePan = _nomineePanController.text.trim();
    UserInfoModel _user =  Get.find<UserController>().userInfoModel;
    if (_user.primeMember==0 && ( _referenceId==null ||_referenceId=="-1")) {
      showCustomSnackBar('Select Your Reference');
    }
    else if (_state==null ||_state=="Select State") {
    showCustomSnackBar('Select State');
    }
    else if (_city==null) {
      showCustomSnackBar('Select City');
    }else if (_pin.isEmpty) {
      showCustomSnackBar('Enter Pin Code');
    }else if (_pin.length<6) {
       showCustomSnackBar('Enter Valid Pin Code');
    }
    else if (primeController.rawUserImageFile==null
        && (primeMemberDetailData==null
        || primeMemberDetailData.image==null
        || primeMemberDetailData.image.isEmpty
    )) {
      showCustomSnackBar('Select User Image');
    }

    else if (_accNumber.isEmpty) {
       showCustomSnackBar('Enter Bank Account Number');
     }
     else if (_confirmAccNumber.isEmpty || _confirmAccNumber!=_accNumber) {
       showCustomSnackBar('The account number do not match');
     }
     else if (_ifsc.isEmpty) {
       showCustomSnackBar('Enter IFSC Code');
    }else if (_aadharCard.isEmpty) {
       showCustomSnackBar('Enter Aadhar Card Number');
    }else if (primeController.rawAadharImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.aadharCardImage==null
            || primeMemberDetailData.aadharCardImage.isEmpty
        )
    ) {
       showCustomSnackBar('Select Aadhar Card Image');
    }
     else if (_panCard.isEmpty) {
       showCustomSnackBar('Enter Pan Card Number');
     }else if (primeController.rawPanImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.panCardImage==null
            || primeMemberDetailData.panCardImage.isEmpty
        )
    ) {
       showCustomSnackBar('Select Pan Card Image');
     }else if (_nomineeName.isEmpty) {
       showCustomSnackBar('Enter Nominee Name');
     }else if (_nomineeMobile.isEmpty) {
       showCustomSnackBar('Enter Nominee Mobile');
     }


     else if (_nomineeMobile.length<10) {
       showCustomSnackBar('Invalid Nominee Mobile');
     }
     else if (nomineeRelation==null ||nomineeRelation=='Select Relationship') {
       showCustomSnackBar('Select Nominee Relation');
     } else if (_nomineeAadhar.isEmpty) {
       showCustomSnackBar('Enter Nominee Aadhar Card Number');
     }
     else if (primeController.rawNomineeAadharImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.nomineeAdharCardImage==null
            || primeMemberDetailData.nomineeAdharCardImage.isEmpty
        )
    ) {
       showCustomSnackBar('Select Nominee Aadhar Card Front Image');
     }

    else if (primeController.rawNomineeAadharBackImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.nomineeAdharCardImageBack==null
            || primeMemberDetailData.nomineeAdharCardImageBack.isEmpty
        )
    ) {
      showCustomSnackBar('Select Nominee Aadhar Card Back Image');
    }
     else if (_nomineePan.isEmpty) {
       showCustomSnackBar('Enter Nominee Pan Card Number');
     }
     else if (primeController.rawNomineePanImageFile==null
        && (primeMemberDetailData==null
            || primeMemberDetailData.nomineePanCard==null
            || primeMemberDetailData.nomineePanCard.isEmpty
        )
    ) {
       showCustomSnackBar('Select Nominee Pan Card Image');
     }

     else {
      primeController.uploadDocument(shouldUpdate,
          _state,
          _city,
          _pin,
          _accNumber,
          _ifsc,
          _aadharCard,
          _panCard,
          _nomineeName,
          _nomineeMobile,
          nomineeRelation,
          _nomineeAadhar,
          _nomineePan,
          _referenceId).then((status) async {
        if(status.isSuccess){
          setState(() {
            shouldUpdate=true;
          });
          showCustomSnackBar("Documents Uploaded",isError: false);
        }else{
          showCustomSnackBar("Documents uploading process completed. Please make a payment to activate your Prime Card!!!",isError: true);
        }
      });

    }
  }


}





class UploadImageWidget extends StatelessWidget {
  final Function onTap;
  UploadImageWidget({ @required this.onTap});


  @override
  Widget build(BuildContext context) {
    return InkWell(onTap: onTap,child: Container(
      padding: EdgeInsets.symmetric(vertical: 2, horizontal: Dimensions.PADDING_SIZE_EXTRA_SMALL),
      decoration: BoxDecoration(
        color: Theme.of(context).cardColor.withOpacity(0.8),
        borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
      ),
      child: Icon(Icons.upload),
    ),);
  }
}


