import 'package:sixam_mart/controller/order_controller.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class PaymentButton extends StatelessWidget {
  final String icon;
  final String title;
  final String subtitle;
  String subtitle2='';
  final bool isSelected;
  final Function onTap;
  PaymentButton({@required this.isSelected, @required this.icon, @required this.title, @required this.subtitle, this.subtitle2="", @required this.onTap});

  @override
  Widget build(BuildContext context) {
    return GetBuilder<OrderController>(builder: (orderController) {
      return Padding(
        padding: EdgeInsets.only(bottom: Dimensions.PADDING_SIZE_SMALL),
        child: InkWell(
          onTap: onTap,
          child: Container(
            padding: EdgeInsets.all(10.0),
            decoration : BoxDecoration(
              border: Border.all(color: isSelected ? Theme.of(context).primaryColor : Colors.transparent),
              color:   Theme.of(context).cardColor,
              borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
              boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], blurRadius: 5, spreadRadius: 2)],
            ),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.start,
              crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                Image.asset(
                    icon, width: 40, height: 40,
                    color: isSelected ? Theme.of(context).primaryColor : Theme.of(context).disabledColor,
                  ),

            SizedBox(width: 10,),

            Expanded(child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
               Row(
                 children: [
                   Text(
                      title,
                      style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeExtraLarge),
                    ),

                 ],
               ),
                SizedBox(height: 5,),
                Text(
                  subtitle,
                  style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeLarge, color: isSelected ? Colors.orange : Theme.of(context).disabledColor),
                ),
                subtitle2=='' ? SizedBox() : Text(
                  subtitle2,
                  style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeDefault, color: Theme.of(context).primaryColor),
                ),
              ],
            )),
            ]),
            // child: ListTile(
            //   leading: Image.asset(
            //     icon, width: 40, height: 40,
            //     color: ( isSelected && title!='qr_code'.tr)? Theme.of(context).primaryColor : title!='qr_code'.tr? Theme.of(context).disabledColor:null,
            //   ),
            //   title: Text(
            //     title,
            //     style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge),
            //   ),
            //   subtitle: Column(
            //     crossAxisAlignment: CrossAxisAlignment.start,
            //     children: [
            //       Text(
            //         subtitle,
            //         style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeLarge, color: Theme.of(context).disabledColor),
            //         maxLines: 1, overflow: TextOverflow.ellipsis,
            //       ),
            //       subtitle2=='' ?SizedBox() : Text(
            //         subtitle2,
            //         style: robotoRegular.copyWith(fontSize: Dimensions.fontSizeLarge, color: Theme.of(context).primaryColor),
            //         maxLines: 1, overflow: TextOverflow.ellipsis,
            //       ),
            //     ],
            //   ),
            //   trailing: isSelected ? Icon(Icons.check_circle, color: Theme.of(context).primaryColor) : null,
            // ),
          ),
        ),
      );
    });
  }
}
