import 'package:flutter/material.dart';

class BottomNavItem extends StatelessWidget {
  final IconData iconData;
  final Function onTap;
  final bool isSelected;
  final String iconName;
  final Color disableColor;
  final double width;
  BottomNavItem({@required this.iconData, this.onTap, this.isSelected = false,@required this.iconName,@required this.disableColor,@required this.width});

  @override
  Widget build(BuildContext context) {
    return MaterialButton(
      onPressed: onTap,
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          Icon(
            iconData,
            color: isSelected ? Theme.of(context).primaryColor : disableColor,
          ),
          Text(
            iconName,
            style: TextStyle(
              color: isSelected ? Theme.of(context).primaryColor : disableColor,
              fontSize: 10,
            ),
          ),
        ],
      ),
      minWidth: width ,
    );
  }
}
