import 'dart:async';
import 'dart:collection';
import 'dart:ui';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:sixam_mart/view/base/custom_app_bar.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:get/get.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:url_launcher/url_launcher_string.dart';

import '../../../controller/prime_member_controller.dart';
import '../../../helper/date_converter.dart';



class FamilyMapScreen extends StatefulWidget {
  @override
  _FamilyMapScreenState createState() => _FamilyMapScreenState();
}

class _FamilyMapScreenState extends State<FamilyMapScreen> {
  GoogleMapController mapController;
  Completer<GoogleMapController> _controller = Completer();
  LatLng _lastMapPosition = _center;



  Iterable markers =
  Iterable.generate(Get.find<PrimeMemberController>().familyMembersListForMap.length, (index) {
    return Get.find<PrimeMemberController>().familyMembersListForMap[index].trackLastLocation==null? Marker(markerId: null):
    Marker(
        markerId: MarkerId(Get.find<PrimeMemberController>().familyMembersListForMap[index].name),
        position: LatLng(

          double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[index].trackLastLocation.latitude),

          double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[index].trackLastLocation.longitude),
        ),
        infoWindow: InfoWindow(title: Get.find<PrimeMemberController>().familyMembersListForMap[index].name,

            onTap: (){
              //Get.find<PrimeMemberController>().setSelectedIndexOnMap(index);
            },snippet: DateConverter.dateTimeStringToDateTime(
            DateConverter.isoStringToLocalString(
                Get.find<PrimeMemberController>().familyMembersListForMap[index].trackLastLocation.createdAt)))
    );
  });

  static const LatLng _center = const LatLng(28.771646, 77.507561);
 //var f= double.parse(Get.find<LocationController>().getUserAddress().longitude),
  //final Set<Marker> markers = {};
  bool _isLoading = true;
  // Set<Marker> markers = {
  //   Marker(
  //
  //     markerId: MarkerId('marker1'),
  //     position: LatLng(28.771646, 77.507561), // Example coordinates
  //     infoWindow: InfoWindow(title: 'Marker 1',snippet: "19 Jan 2024 10:10 AM",),
  //     //icon: GetPlatform.isWeb ? BitmapDescriptor.defaultMarker : BitmapDescriptor.fromBytes(destinationImageData),
  //
  //   ),
  //   Marker(
  //     markerId: MarkerId('marker2'),
  //     position: LatLng(28.667856, 77.449791), // Example coordinates
  //     infoWindow: InfoWindow(title: 'Marker 2',snippet: "19 Jan 2024 10:10 AM"),
  //   ),
  //   Marker(
  //     markerId: MarkerId('marker3'),
  //     position: LatLng(28.8015538	, 77.2419444), // Example coordinates
  //     infoWindow: InfoWindow(title: 'Marker 3',snippet: "19 Jan 2024 10:10 AM"),
  //   ),
  //   // Add more markers as needed
  // };


  @override
  void dispose() {
    mapController?.dispose();
    super.dispose();
  }


  void setMarker() async {
    try {
      Uint8List restaurantImageData = await convertAssetToUnit8List(Images.restaurant_marker, width: 100);
      Uint8List deliveryBoyImageData = await convertAssetToUnit8List(Images.delivery_man_marker, width: 100);
      Uint8List destinationImageData = await convertAssetToUnit8List(Images.user_marker, width:  100,);

      // Animate to coordinate
      // LatLngBounds bounds;
      // double _rotation = 0;
      // if(mapController != null) {
      //   // if (double.parse(addressModel.latitude) < double.parse(store.latitude)) {
      //   //   bounds = LatLngBounds(
      //   //     southwest: LatLng(double.parse(addressModel.latitude), double.parse(addressModel.longitude)),
      //   //     northeast: LatLng(double.parse(store.latitude), double.parse(store.longitude)),
      //   //   );
      //   //   _rotation = 0;
      //   // }else {
      //     bounds = LatLngBounds(
      //       southwest: LatLng(double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[0].trackLastLocation.latitude), double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[0].trackLastLocation.longitude)),
      //       northeast: LatLng(28.984644, 77.705956),
      //     );
      //     _rotation = 180;
      //  // }
      // }
      // LatLng centerBounds = LatLng(
      //   (bounds.northeast.latitude + bounds.southwest.latitude)/2,
      //   (bounds.northeast.longitude + bounds.southwest.longitude)/2,
      // );

      // mapController.moveCamera(CameraUpdate.newCameraPosition(CameraPosition(target: centerBounds, zoom: GetPlatform.isWeb ? 10 : 17)));
      // if(!ResponsiveHelper.isWeb()) {
      //   zoomToFit(mapController, bounds, centerBounds, padding: 1.5);
      // }

    }catch(e) {}
    setState(() {});
  }

  Future<void> zoomToFit(GoogleMapController controller, LatLngBounds bounds, LatLng centerBounds, {double padding = 0.5}) async {
    bool keepZoomingOut = true;

    while(keepZoomingOut) {
      final LatLngBounds screenBounds = await controller.getVisibleRegion();
      if(fits(bounds, screenBounds)){
        keepZoomingOut = false;
        final double zoomLevel = await controller.getZoomLevel() - padding;
        controller.moveCamera(CameraUpdate.newCameraPosition(CameraPosition(
          target: centerBounds,
          zoom: zoomLevel,
        )));
        break;
      }
      else {
        // Zooming out by 0.1 zoom level per iteration
        final double zoomLevel = await controller.getZoomLevel() - 0.1;
        controller.moveCamera(CameraUpdate.newCameraPosition(CameraPosition(
          target: centerBounds,
          zoom: zoomLevel,
        )));
      }
    }
  }

  bool fits(LatLngBounds fitBounds, LatLngBounds screenBounds) {
    final bool northEastLatitudeCheck = screenBounds.northeast.latitude >= fitBounds.northeast.latitude;
    final bool northEastLongitudeCheck = screenBounds.northeast.longitude >= fitBounds.northeast.longitude;

    final bool southWestLatitudeCheck = screenBounds.southwest.latitude <= fitBounds.southwest.latitude;
    final bool southWestLongitudeCheck = screenBounds.southwest.longitude <= fitBounds.southwest.longitude;

    return northEastLatitudeCheck && northEastLongitudeCheck && southWestLatitudeCheck && southWestLongitudeCheck;
  }

  Future<Uint8List> convertAssetToUnit8List(String imagePath, {int width = 50}) async {
    ByteData data = await rootBundle.load(imagePath);
    Codec codec = await instantiateImageCodec(data.buffer.asUint8List(), targetWidth: width);
    FrameInfo fi = await codec.getNextFrame();
    return (await fi.image.toByteData(format: ImageByteFormat.png)).buffer.asUint8List();
  }


  void check(CameraUpdate u, GoogleMapController c) async {
    c.animateCamera(u);
    mapController.animateCamera(u);
    LatLngBounds l1=await c.getVisibleRegion();
    LatLngBounds l2=await c.getVisibleRegion();
    print(l1.toString());
    print(l2.toString());
    if(l1.southwest.latitude==-90 ||l2.southwest.latitude==-90)
      check(u, c);
  }

  void _onMapCreated(GoogleMapController controller) {
    mapController = controller;
    _controller.complete(controller);
//
    LatLng latLng_1 = LatLng(28.771646, 77.507561);
    LatLng latLng_2 = LatLng(28.667856, 77.449791);
    LatLng latLng_3 = LatLng(28.8015538	, 77.2419444);
   LatLngBounds bound = LatLngBounds(southwest: latLng_1, northeast: latLng_2);


    // setState(() {
    //   markers.clear();
    //   addMarker(latLng_1, "Madrid", "5 Star Rating");
    //   addMarker(latLng_2, "Barcelona", "7 Star Rating");
    //   addMarker(latLng_3, "Barcelona", "9 Star Rating");
    //   //_isLoading=false;
    // });

   CameraUpdate u2 = CameraUpdate.newLatLngBounds(bound, 50);
    this.mapController.animateCamera(u2).then((void v){
      check(u2,this.mapController);
    });

  }
  void addMarker(LatLng mLatLng, String mTitle, String mDescription){
    // markers.add(Marker(
    //   // This marker id can be anything that uniquely identifies each marker.
    //   markerId: MarkerId((mTitle + "_" + markers.length.toString()).toString()),
    //   position: mLatLng,
    //   infoWindow: InfoWindow(
    //     title: mTitle,
    //     snippet: mDescription,
    //   ),
    //   icon: BitmapDescriptor.defaultMarker,
    // ));
  }

  void _onCameraMove(CameraPosition position) {
    _lastMapPosition = position.target;
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Map View'),
      ),
      body: Center(child: SizedBox(width: Dimensions.WEB_MAX_WIDTH,
          child: Stack(children: [

            GoogleMap(
              mapType: MapType.normal,
              initialCameraPosition: CameraPosition(target: LatLng(
                double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[0].trackLastLocation.latitude),
                double.parse(Get.find<PrimeMemberController>().familyMembersListForMap[0].trackLastLocation.longitude),
              ), zoom: 5.5),
              minMaxZoomPreference: MinMaxZoomPreference(0, 16),
              zoomControlsEnabled: true,
              markers: Set.from(markers),

              onMapCreated: (GoogleMapController controller) {
                mapController = controller;
                _isLoading = false;
                setMarker();
              },
              //zoomGesturesEnabled: true,

            ),
          // Positioned(top: 5,right: 10,child: Get.find<PrimeMemberController>().selectedIndexOnMap==-1? SizedBox() :
          // Container(
          //   padding: EdgeInsets.fromLTRB(5, 5, 7, 7),
          //   decoration: BoxDecoration(
          //       border: Border.all(color: Colors.green),
          //       borderRadius: BorderRadius.circular(5)),
          //
          //   child: Column(
          //     children: [
          //       Text(Get.find<PrimeMemberController>().familyMembersListForMap[Get.find<PrimeMemberController>().selectedIndexOnMap].name, style: robotoRegular.copyWith(fontSize:
          //       10,color: Colors.black12)),
          //       SizedBox(height: 5,),
          //       Expanded(child: Text(Get.find<PrimeMemberController>().familyMembersListForMap[Get.find<PrimeMemberController>().selectedIndexOnMap].trackLastLocation.location, style: robotoRegular.copyWith(fontSize:
          //       10,color: Colors.red))),
          //     ],
          //   ),
          // )),
          //   GoogleMap(
          //   markers: markers,
          //   onMapCreated: _onMapCreated,
          //   initialCameraPosition: CameraPosition(
          //     target: _center,
          //     zoom: 11.0,
          //   ),
          //   onCameraMove: _onCameraMove,
          // ),

            _isLoading ? Center(child: CircularProgressIndicator()) : SizedBox(),

          ]))),
    );
  }
}
