
import 'package:sixam_mart/controller/auth_controller.dart';
import 'package:sixam_mart/controller/banner_controller.dart';
import 'package:sixam_mart/controller/category_controller.dart';
import 'package:sixam_mart/controller/location_controller.dart';
import 'package:sixam_mart/controller/notification_controller.dart';
import 'package:sixam_mart/controller/item_controller.dart';
import 'package:sixam_mart/controller/parcel_controller.dart';
import 'package:sixam_mart/controller/store_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/controller/user_controller.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_drawer.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_bar.dart';
import 'package:sixam_mart/view/screens/home/theme1/theme1_home_screen.dart';
import 'package:sixam_mart/view/screens/home/web_home_screen.dart';
import 'package:sixam_mart/view/screens/home/widget/home_search_view.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/screens/home/widget/module_view.dart';
import 'package:sixam_mart/view/screens/parcel/parcel_category_screen.dart';
import 'package:upgrader/upgrader.dart';

import '../../../controller/brand_controller_sonu.dart';
import '../../../controller/prime_member_controller.dart';
import '../../../controller/wallet_controller.dart';
import '../../../helper/route_helper.dart';
import '../../../util/images.dart';
import '../../../util/styles.dart';
import '../../base/custom_button.dart';
import '../../base/custom_image.dart';
import '../admin_screen/Bhavya_points.dart';
import '../location/widget/module_dialog.dart';


class HomeScreen extends StatefulWidget {

  static Future<void> loadData(bool reload) async {
    if(Get.find<SplashController>().module != null && !Get.find<SplashController>().configModel.moduleConfig.module.isParcel) {
      Get.find<LocationController>().syncZoneData();
     // Get.find<BannerController>().getBannerList(reload);
      // Get.find<CategoryController>().getCategoryList(reload,0);
      Get.find<StoreController>().getPopularStoreList(reload, 'all', false);
      //Get.find<CampaignController>().getItemCampaignList(reload);
      Get.find<ItemController>().getPopularItemList(reload, 'all', false);
      Get.find<StoreController>().getLatestStoreList(reload, 'all', false);
      Get.find<ItemController>().getReviewedItemList(reload, 'all', false);
      Get.find<StoreController>().getStoreList(1, reload);
    }
    if(Get.find<AuthController>().isLoggedIn()) {
      Get.find<UserController>().getUserInfo(shouldFeaturedApiCall: true);
      Get.find<NotificationController>().getNotificationList(reload);
    }
    Get.find<SplashController>().getModules();

    Get.find<BrandController>().getFeaturedBrandItemList(0,reload);
    Get.find<BannerController>().getTodaysBannerList(reload);
    Get.find<BannerController>().getOtherBannerList(reload);
    Get.find<BannerController>().getEventsBanner(reload);
    Get.find<CategoryController>().getFeaturedCategoryList(reload);
    Get.find<CategoryController>().getCategoryList(reload);
  //  Get.find<StoreController>().getStoreItemList(0, 0, 'all', reload);
    Get.find<ItemController>().getFeaturedLatestItemList(notify: reload);
    Get.find<CategoryController>().getCategoryDairyItemList_Sonu();

    if(Get.find<SplashController>().module == null && Get.find<SplashController>().configModel.module == null) {
      Get.find<BannerController>().getFeaturedBanner();
      Get.find<StoreController>().getFeaturedStoreList();
      if(Get.find<AuthController>().isLoggedIn()) {
        Get.find<LocationController>().getAddressList();
      }
    }
    if(Get.find<SplashController>().module != null && Get.find<SplashController>().configModel.moduleConfig.module.isParcel) {
      Get.find<ParcelController>().getParcelCategoryList();
    }


  }

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> {
  final ScrollController _scrollController = ScrollController();

  @override
  void initState() {
    super.initState();


    HomeScreen.loadData(false);

    print("launchPage  HomeScreen");

    if(!ResponsiveHelper.isWeb() && Get.find<LocationController>()!=null) {
      Get.find<LocationController>().getZone(
          Get.find<LocationController>().getUserAddress()?.latitude??'',
          Get.find<LocationController>().getUserAddress()?.longitude??'', false, updateInAddress: true
      );
    }

  }

  @override
  void dispose() {
    super.dispose();
    _scrollController?.dispose();
  }

  @override
  Widget build(BuildContext context) {
    double screenWidth = MediaQuery.of(context).size.width;
    return GetBuilder<SplashController>(builder: (splashController) {
      bool _showMobileModule = !ResponsiveHelper.isDesktop(context) && splashController.module == null && splashController.configModel.module == null;
      bool _isParcel = splashController.module != null && splashController.configModel.moduleConfig.module.isParcel;
      bool _isInAppPopupEventActive = splashController.configModel.inAppPopupEvent != null && splashController.configModel.inAppPopupEvent.isActive;

      if(_isInAppPopupEventActive){

        Future.delayed(const Duration(milliseconds: 4000), () {
          if(!splashController.isInAppPopupAlreadyShowing){
            splashController.setInAppPopupAlreadyShowing();
            Get.dialog(EventWidget());
          }
        });
      }

      return Scaffold(
        appBar: ResponsiveHelper.isDesktop(context) ? WebMenuBar() : null,
        endDrawer: WebMenuDrawer(),
        backgroundColor: ResponsiveHelper.isDesktop(context) ? Theme.of(context).bottomAppBarTheme.color : splashController.module == null
            ? Theme.of(context).bottomAppBarTheme.color : null,
        body: _isParcel ? ParcelCategoryScreen()
            : SafeArea(child:
        RefreshIndicator(
            onRefresh: () async {

              if(Get.find<AuthController>().isLoggedIn()) {
                await Get.find<UserController>().getUserInfo();
                await Get.find<NotificationController>().getNotificationList(true);
              }
              if(Get.find<SplashController>().module != null) {
                await Get.find<LocationController>().syncZoneData();

                // await Get.find<CategoryController>().getCategoryList(true,0);
                await Get.find<StoreController>().getPopularStoreList(true, 'all', false);
                //await Get.find<CampaignController>().getItemCampaignList(true);
                await Get.find<ItemController>().getPopularItemList(true, 'all', false);
                await Get.find<StoreController>().getLatestStoreList(true, 'all', false);
                await Get.find<ItemController>().getReviewedItemList(true, 'all', false);
                await Get.find<StoreController>().getStoreList(1, true);

               // Get.find<StoreController>().getStoreItemList(0, 0, 'all', true);


              }

              else {
                await Get.find<BannerController>().getFeaturedBanner();
                await Get.find<SplashController>().getModules();

                if(Get.find<AuthController>().isLoggedIn()) {
                  await Get.find<LocationController>().getAddressList();
                }
                await Get.find<StoreController>().getFeaturedStoreList();
              }
              //await Get.find<BannerController>().getBannerList(true);
              await Get.find<BannerController>().getTodaysBannerList(true);
              await Get.find<BrandController>().getFeaturedBrandItemList(0,true);
              await Get.find<BannerController>().getOtherBannerList(true);
              await Get.find<CategoryController>().getCategoryList(true);
              await  Get.find<ItemController>().getFeaturedLatestItemList(notify: true);
              await Get.find<CategoryController>().getFeaturedCategoryList(true);
              await Get.find<CategoryController>().getCategoryDairyItemList_Sonu();
            },
            child: ResponsiveHelper.isDesktop(context) ? WebHomeScreen(scrollController: _scrollController,) :
            (Get.find<SplashController>().module != null && Get.find<SplashController>().module.themeId == 2
                && Get.find<SplashController>().isHomeSearch==false) ?

            Theme1HomeScreen(scrollController: _scrollController, splashController: splashController, showMobileModule: _showMobileModule,) : //category page

            CustomScrollView(controller: _scrollController, // home main page
              physics: AlwaysScrollableScrollPhysics(),
              scrollDirection: Axis.vertical,
              shrinkWrap: true,
              slivers: [
                // SliverAppBar(
                //   floating: true, elevation: 0, automaticallyImplyLeading: false,
                //   backgroundColor: ResponsiveHelper.isDesktop(context) ? Colors.transparent : Colors.white,
                //   title: Center(child: Container(
                //
                //     width: context.width, height: 50,
                //     child: Row(children: [
                //       (splashController.module != null && splashController.configModel.module == null) ? InkWell(
                //         onTap: () => splashController.removeModule(),
                //         child: Image.asset(Images.module_icon, height: 22, width: 22, color: Theme.of(context).textTheme.bodyLarge.color),
                //       )
                //           : SizedBox(),
                //       SizedBox(width: (splashController.module != null && splashController.configModel.module
                //           == null) ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0),
                //       Expanded(child: InkWell(
                //         onTap: () => Get.toNamed(RouteHelper.getAccessLocationRoute('home')),
                //         child: Padding(
                //           padding: EdgeInsets.symmetric(
                //             vertical: Dimensions.PADDING_SIZE_SMALL,
                //             horizontal: ResponsiveHelper.isDesktop(context) ? Dimensions.PADDING_SIZE_SMALL : 0,
                //           ),
                //           child: GetBuilder<LocationController>(builder: (locationController) {
                //             return Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.start,
                //               children: [
                //                 Icon(
                //                   locationController.getUserAddress().addressType == 'home' ? Icons.home_filled
                //                       : locationController.getUserAddress().addressType == 'office' ? Icons.work : Icons.location_on,
                //                   size: 20, color: Theme.of(context).textTheme.bodyLarge.color,
                //                 ),
                //                 SizedBox(width: 10),
                //                 Flexible(
                //                   child: Text(
                //                     locationController.getUserAddress().address,
                //                     style: robotoRegular.copyWith(
                //                       color: Theme.of(context).textTheme.bodyLarge.color, fontSize: Dimensions.fontSizeSmall,
                //                     ),
                //                     maxLines: 1, overflow: TextOverflow.ellipsis,
                //                   ),
                //                 ),
                //                 Icon(Icons.arrow_drop_down, color: Theme.of(context).textTheme.bodyLarge.color),
                //               ],
                //             );
                //           }),
                //         ),
                //       )),
                //       InkWell(
                //         child: GetBuilder<NotificationController>(builder: (notificationController) {
                //           return Stack(children: [
                //             Icon(Icons.notifications, size: 25, color: Theme.of(context).textTheme.bodyText1.color),
                //             notificationController.hasNotification ? Positioned(top: 0, right: 0, child: Container(
                //               height: 10, width: 10, decoration: BoxDecoration(
                //               color: Theme.of(context).primaryColor, shape: BoxShape.circle,
                //               border: Border.all(width: 1, color: Theme.of(context).cardColor),
                //             ),
                //             )) : SizedBox(),
                //           ]);
                //         }),
                //         onTap: () => Get.toNamed(RouteHelper.getNotificationRoute()),
                //       ),
                //     ]),
                //   )),
                //   actions: [SizedBox()],
                // ),
                // Search Button

                HomeSearchView(screenWidth,splashController),

                SliverToBoxAdapter(
                  child: Center(child: SizedBox(
                    width: Dimensions.WEB_MAX_WIDTH,
                    child: returnModuleView(splashController),
                    //child: ModuleView(splashController: splashController),
                    // child: (!_showMobileModule && !splashController.isHomeSearch)?
                    // Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
                    //   //if we get module in config api then this portion is the launch at the home screen when user open the app
                    //   BannerView(isFeatured: false),
                    //   CategoryView(),
                    //   PopularStoreView(isPopular: true, isFeatured: false),
                    //   ItemCampaignView(),
                    //   PopularItemView(isPopular: true),
                    //   PopularStoreView(isPopular: false, isFeatured: false),
                    //   PopularItemView(isPopular: false),
                    //
                    //   Padding(
                    //     padding: EdgeInsets.fromLTRB(10, 15, 0, 5),
                    //     child: Row(children: [
                    //       Expanded(child: Text(
                    //         Get.find<SplashController>().configModel.moduleConfig.module.showRestaurantText
                    //             ? 'all_restaurants'.tr : 'all_stores'.tr,
                    //         style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge),
                    //       )),
                    //       FilterView(),
                    //     ]),
                    //   ),
                    //
                    //   GetBuilder<StoreController>(builder: (storeController) {
                    //     return PaginatedListView(
                    //       scrollController: _scrollController,
                    //       totalSize: storeController.storeModel != null ? storeController.storeModel.totalSize : null,
                    //       offset: storeController.storeModel != null ? storeController.storeModel.offset : null,
                    //       onPaginate: (int offset) async => await storeController.getStoreList(offset, false),
                    //       itemView: ItemsView(
                    //         isStore: true, items: null,
                    //         stores: storeController.storeModel != null ? storeController.storeModel.stores : null,
                    //         padding: EdgeInsets.symmetric(
                    //           horizontal: ResponsiveHelper.isDesktop(context) ? Dimensions.PADDING_SIZE_EXTRA_SMALL : Dimensions.PADDING_SIZE_SMALL,
                    //           vertical: ResponsiveHelper.isDesktop(context) ? Dimensions.PADDING_SIZE_EXTRA_SMALL : 0,
                    //         ),
                    //       ),
                    //     );
                    //   }),
                    //
                    // ]) :
                    // ModuleView(splashController: splashController),// home main page
                  )),
                ),
              ],
            ),
          ),
        ),
      );
    });
  }

  Widget returnModuleView(SplashController splashController){
    if(GetPlatform.isWeb)
      return ModuleView(splashController: splashController);
          else
            return UpgradeAlert(
                upgrader: Upgrader(
                    debugLogging: true,
                    showIgnore: false,
                    showLater: false,
                    shouldPopScope: ()=>true,
                    durationUntilAlertAgain: Duration(minutes: 1),
                    canDismissDialog: true,
                    dialogStyle: ResponsiveHelper.isIos(context) ? UpgradeDialogStyle.cupertino : UpgradeDialogStyle.material),
                child: ModuleView(splashController: splashController));

  }
}

class SliverDelegate extends SliverPersistentHeaderDelegate {
  Widget child;

  SliverDelegate({@required this.child});

  @override
  Widget build(BuildContext context, double shrinkOffset, bool overlapsContent) {
    return child;
  }

  @override
  double get maxExtent => 50;

  @override
  double get minExtent => 50;

  @override
  bool shouldRebuild(SliverDelegate oldDelegate) {
    return oldDelegate.maxExtent != 50 || oldDelegate.minExtent != 50 || child != oldDelegate.child;
  }
}

class EventWidget extends StatelessWidget {

  @override
  Widget build(BuildContext context) {
    return Dialog(
      shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL)),
      insetPadding: EdgeInsets.all(30),
      clipBehavior: Clip.antiAliasWithSaveLayer,
      child: Container(
        color: Theme.of(context).primaryColor,
        width: 600,
        child: GetBuilder<WalletController>(builder: (walletController) {
          return SingleChildScrollView(
            child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [

              Row(mainAxisAlignment: MainAxisAlignment.spaceBetween, children: [

                SizedBox(),
               Text((Get.find<SplashController>().configModel.inAppPopupEvent.title==null
               || Get.find<SplashController>().configModel.inAppPopupEvent.title.isEmpty)?'':Get.find<SplashController>().configModel.inAppPopupEvent.title, style: robotoMedium.copyWith(color: Colors.white,fontSize: Dimensions.fontSizeLarge)),
                // CustomButton(
                //   onPressed: () {
                //     Navigator.of(context).pop();
                //   },
                //   buttonText: 'close'.tr, transparent: true, width: 65,
                // ),
                InkWell(
                  onTap: () => Navigator.of(context).pop(),
                  child: Padding(
                    padding: EdgeInsets.all(Dimensions.PADDING_SIZE_EXTRA_SMALL),
                    child: Icon(Icons.close, color: Theme.of(context).cardColor),
                  ),
                ),
              ]),
              CustomImage(
                height: 500,
                image: Get.find<SplashController>().configModel.inAppPopupEvent.image,
                fit: BoxFit.fill,
              ),
              // Image.asset(Images.event_01, width: context.width,height: 500,fit: BoxFit.fill,)
            ]),
          );
        }),
      ),
    );
  }
}