
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../../../controller/brand_controller_sonu.dart';
import '../../../../data/model/response/brand_model.dart';
import '../../../../util/app_constants.dart';
import '../../../base/custom_image.dart';
import '../../../base/title_widget.dart';
import '../../../base/circular_image_shimmer_list.dart';

class BrandViewSonu extends StatelessWidget {
  final bool isFeatured;
  final BrandController brandController;
  BrandViewSonu({@required this.isFeatured , @required this.brandController});

  @override
  Widget build(BuildContext context) {
    List<Brands> brandList = brandController.featuredBrandsList;
    String _baseUrl = Get.find<SplashController>().configModel.baseUrls.commonImageUrl;

    return brandList != null ? brandList.length>0? Container(
      width: MediaQuery.of(context).size.width,
      height: GetPlatform.isDesktop ? 200 : MediaQuery.of(context).size.width * 0.46,
      padding: EdgeInsets.only(top: Dimensions.PADDING_SIZE_DEFAULT),
      child:  Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: EdgeInsets.only(left: 10,right: 10),
            child: TitleWidget(
              title: 'brands'.tr,
              onTap: () => Get.toNamed(RouteHelper.getAllBrandsRoute('all_brands'.tr)),
            ),
          ),
          SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
          SizedBox(
            height: 105,
            child:ListView.builder(
              controller: ScrollController(),
              physics: BouncingScrollPhysics(),
              scrollDirection: Axis.horizontal,
              padding: EdgeInsets.only(left: Dimensions.PADDING_SIZE_SMALL),
              itemCount: brandList.length,
              itemBuilder: (context, index){
                return Padding(
                  padding: EdgeInsets.symmetric(horizontal: 5),
                  child: InkWell(
                    onTap: () =>Get.toNamed(RouteHelper.getBrandItemRoute(
                      brandList[index].id, brandList[index].name,
                    )),
                    child: Container(width: 100,
                      height: 100,
                      child: Center(
                        child: Padding(
                          padding: const EdgeInsets.all(0.0),
                          child: ClipRRect(
                            borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                            child: CustomImage(
                              height: context.height, width: context.width, fit: BoxFit.fill,
                              //image: 'https://www.rd.com/wp-content/uploads/2022/06/15-best-air-fresheners-for-your-car-ft-via-merchant.png',
                              image:'$_baseUrl/${brandList[index].image}',
                            ),
                          ),
                        ),
                      ),
                    ),
                    // child: SizedBox(
                    //   width: 100,
                    //   child: Container(
                    //     height: 70,
                    //     width: 70,
                    //
                    //     margin: EdgeInsets.only(
                    //       left: index == 0 ? 0 : Dimensions.PADDING_SIZE_EXTRA_SMALL,
                    //       right: Dimensions.PADDING_SIZE_EXTRA_SMALL,
                    //     ),
                    //     child: Stack(children: [
                    //       Container(
                    //         width: 70.0,
                    //         height: 70.0,
                    //         decoration: BoxDecoration(
                    //           image: DecorationImage(
                    //             image: NetworkImage('$_baseUrl/${brandList[index].image}'),
                    //             fit: BoxFit.cover,
                    //           ),
                    //           borderRadius: BorderRadius.all( Radius.circular(50.0)),
                    //           border: Border.all(
                    //             color: Theme.of(context).dividerColor,
                    //             width: 1.0,
                    //           ),
                    //         ),
                    //       ),
                    //
                    //     ]),
                    //   ),
                    // ),
                  ),
                );
              },
            ),
          ),
        ],
      ),
    )
        : SizedBox() : CircularImageListForShimmer(isEnabled: brandList==null,title: 'brands'.tr);
  }

}
