import 'dart:async';

import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/base/categories_shimmer.dart';
import '../../../../controller/category_controller.dart';
import '../../../../helper/responsive_helper.dart';
import '../../../base/categories_widget.dart';

class CategoriesViewSonu extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    bool _desktop = ResponsiveHelper.isDesktop(context);
    bool _isTab = ResponsiveHelper.isTab(context);
    bool _isWeb = ResponsiveHelper.isWeb();
    bool _isMobile = ResponsiveHelper.isMobile(context);
    double _width = MediaQuery.of(context).size.width;




    //print("testResponsiveHelper CategoriesViewSonu width ${MediaQuery.of(context).size.width} _desktop  $_desktop _isTab $_isTab isWeb $_isWeb _isMobile $_isMobile");


    return GetBuilder<CategoryController>(builder: (catController) {


      return catController.categoryList != null ? catController.categoryList.length > 0 ? Container(



        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Padding(
              padding: EdgeInsets.only(left: 10,right: 10),
              child: Text('categories'.tr, style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge)),
            ),
            SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

            GridView.builder(
              physics: NeverScrollableScrollPhysics(),
              shrinkWrap: true,
              gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                // crossAxisCount: ResponsiveHelper.isDesktop(context) ? 6
                //     : ResponsiveHelper.isTab(context) ? 4 : 2,
                // childAspectRatio: (1/1.3),
                // mainAxisSpacing: Dimensions.PADDING_SIZE_LARGE,
                // crossAxisSpacing:Dimensions.PADDING_SIZE_DEFAULT,

                crossAxisCount: _desktop ? 6 : _isTab ? 4 : 2
                , mainAxisSpacing: ( _desktop || _isTab )? Dimensions.PADDING_SIZE_LARGE:  Dimensions.PADDING_SIZE_DEFAULT,
                crossAxisSpacing:( _desktop || _isTab ) ? Dimensions.PADDING_SIZE_LARGE : Dimensions.PADDING_SIZE_DEFAULT
                , childAspectRatio: _desktop ? (1/1.4) :_isTab? (1/1.2) : (1/1.3),
              ),
              padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
              itemCount: catController.categoryList.length,
              itemBuilder: (context, index) {
                return InkWell(
                  onTap: (){

                   Get.toNamed(RouteHelper.getCategoryItemRoute(catController.categoryList[index].id, catController.categoryList[index].parentId,catController.categoryList[index].name));
                  },
                  child: CategoriesWidget(
                    isBrand: false,
                    brandItem: null,
                    catItem: catController.categoryList[index],
                    index: index,
                    length: catController.categoryList.length,
                  ),
                );
              },
            ),
          ],
        ),
      )
          :SizedBox():CategoriesShimmer(isEnabled: catController.categoryList==null,);
    });
  }
}







