import 'package:sixam_mart/controller/item_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/controller/theme_controller.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/helper/price_converter.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_image.dart';
import 'package:sixam_mart/view/base/discount_tag.dart';
import 'package:sixam_mart/view/base/not_available_widget.dart';
import 'package:sixam_mart/view/base/title_widget.dart';
import 'package:flutter/material.dart';
import 'package:shimmer_animation/shimmer_animation.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/base/product_grid_shimmer.dart';

import '../../../../controller/auth_controller.dart';
import '../../../../controller/cart_controller.dart';
import '../../../../controller/category_controller.dart';
import '../../../../controller/store_controller.dart';
import '../../../../controller/wishlist_controller.dart';
import '../../../../helper/responsive_helper.dart';
import '../../../../util/images.dart';
import '../../../base/custom_snackbar.dart';
import '../../../base/item_widget.dart';

class DairyBakeryViewSonu extends StatelessWidget {

@override
Widget build(BuildContext context) {
  bool _desktop = ResponsiveHelper.isDesktop(context);
  bool _isTab = ResponsiveHelper.isTab(context);
  bool _isWeb = ResponsiveHelper.isWeb();
  bool _isMobile = ResponsiveHelper.isMobile(context);
  double _width = MediaQuery.of(context).size.width;
  print("testResponsiveHelper DairyBakeryViewSonu _desktop $_desktop _isTab $_isTab isWeb $_isWeb _isMobile $_isMobile");


  String _baseUrl = Get.find<SplashController>().configModel.baseUrls.commonImageUrl;
  return GetBuilder<CategoryController>(builder: (categoryController) {

    List<Item> _itemList = categoryController.categoryDairyItemList;

    return _itemList != null ? _itemList.length > 0 ?
    Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
    Padding(
    padding: EdgeInsets.only(left: 10,right: 10,top: 10),
    child: Text('dairy_products'.tr, style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge)),
    ),

        SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
        GridView.builder(gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
          crossAxisCount: _desktop ? Dimensions.crossAxisCount_Desktop : (_isTab && _width > 950 )? Dimensions.crossAxisCount_Tab_widthMoreThan950 : (_isTab && _width < 950 )? Dimensions.crossAxisCount_Tab_widthLessThan950  : Dimensions.crossAxisCount_Mobile
          , mainAxisSpacing: ( _desktop || _isTab )? Dimensions.PADDING_SIZE_DEFAULT:  Dimensions.PADDING_SIZE_SMALL,
          crossAxisSpacing:( _desktop || _isTab ) ? Dimensions.PADDING_SIZE_DEFAULT : Dimensions.PADDING_SIZE_SMALL
          , childAspectRatio: _desktop ? Dimensions.childAspectRatio_Desktop : (_isTab && _width > 950 ) ? Dimensions.childAspectRatio_Tab_widthMoreThan950 : (_isTab && _width < 950 ) ? Dimensions.childAspectRatio_Tab_widthLessThan950 : Dimensions.childAspectRatio_Mobile,

        ),
          padding: EdgeInsets.all(Dimensions.gridPadding),
          itemCount: _itemList.length,
          shrinkWrap: true, physics: NeverScrollableScrollPhysics(),
          itemBuilder: (context, index) {
            return ItemWidget(
              isStore: false,
              item: _itemList[index],
              isFeatured: false,
              store:  null,
              index: index,
              length: _itemList.length,
              isCampaign: false,
              inStore: false,
            );
          },
        ),
      ],
    )
        :SizedBox():ProductGridShimmer(isEnabled: _itemList==null,);
  });
}
}
