import 'package:carousel_slider/carousel_slider.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:shimmer_animation/shimmer_animation.dart';
import 'package:sixam_mart/controller/banner_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/util/app_constants.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/screens/home/widget/banner_view.dart';
import 'package:sixam_mart/view/screens/home/widget/products_view_sonu.dart';
import 'package:sixam_mart/view/screens/home/widget/recent_view.dart';
import 'package:sixam_mart/view/screens/home/widget/todays_banner_view_sonu.dart';
import 'package:sixam_mart/view/screens/home/widget/upgrade_to_prime_sonu.dart';
import '../../../../controller/brand_controller_sonu.dart';
import '../../../../controller/user_controller.dart';
import '../../../../data/model/response/basic_campaign_model.dart';
import '../../../../data/model/response/userinfo_model.dart';
import '../../../../helper/price_converter.dart';
import '../../../../helper/route_helper.dart';
import '../../../../util/images.dart';
import '../../../../util/styles.dart';
import '../../../base/banner_shimmer.dart';
import '../../../base/confirmation_dialog.dart';
import '../../../base/custom_image.dart';
import 'Bhavya_porducts_view.dart';
import 'brand_view_sonu.dart';
import 'categories_view_sonu.dart';
import 'dairy_bakery_view.dart';

class ModuleView extends StatelessWidget {
  final SplashController splashController;
  ModuleView({@required this.splashController});



  @override
  Widget build(BuildContext context) {


    return Container(

      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [

          SizedBox(height: 10,),

          // UpgradeToPrimeCard(splashController),

          BhavyaProductsView(splashController),

          // GetBuilder<BannerController>(builder: (bannerController) {
          //   return BannerView(isFeatured: true);
          // }),

          GetBuilder<BrandController>(builder: (brandController) {
            return BrandViewSonu(isFeatured: true,brandController:brandController);}
          ),

          // Container(
          //   padding: EdgeInsets.only(top: 10,bottom: 10),
          //     decoration: BoxDecoration(
          //       gradient: LinearGradient(
          //         begin: Alignment.topCenter,
          //         end: Alignment.bottomCenter,
          //         stops: [0.1, 0.4],
          //         colors: [
          //           Colors.indigo.withOpacity(0.5),
          //           Colors.indigo.withOpacity(0.3),
          //         ],
          //       ),
          //     ),
          //     child:  GetBuilder<BannerController>(builder: (bannerController) {
          //       return TodaysBannerViewSonu(bannerType: 'todays_offers'.tr,);
          //     })),


          CategoriesViewSonu(),

          ProductsViewSonu(),

          // GetBuilder<BannerController>(builder: (bannerController) {
          //   return TodaysBannerViewSonu(bannerType: 'Offers',);
          // }),

         // RecentViewSonu(),

          // StaticWidgetView(),
          DairyBakeryViewSonu(),

          // Container(
          //   decoration: BoxDecoration(
          //     borderRadius: BorderRadius.circular(Dimensions.PADDING_SIZE_DEFAULT),
          //     border: Border.all(width: Dimensions.BORDER_WIDTH_FOR_CONTAINER, color: Theme.of(context).backgroundColor),
          //   ),
          //   child: GridView.builder(gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
          //       crossAxisCount: 3, mainAxisSpacing: Dimensions.PADDING_SIZE_SMALL,
          //       crossAxisSpacing: Dimensions.PADDING_SIZE_SMALL, childAspectRatio: (1/1),
          //     ),
          //     padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
          //     itemCount: splashController.moduleList.length,
          //     shrinkWrap: true, physics: NeverScrollableScrollPhysics(),
          //     itemBuilder: (context, index) {
          //       return InkWell(
          //         onTap: () {
          //
          //           splashController.setHomeSearchTrue(false);
          //           splashController.switchModule(index, true);},
          //         child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [
          //
          //           Container(
          //               decoration: BoxDecoration(
          //                 borderRadius: BorderRadius.circular(Dimensions.WEB_MAX_WIDTH),
          //                 border: Border.all(width: 1, color: Theme.of(context).colorScheme.background),
          //               ),
          //               child: Padding(
          //                 padding: const EdgeInsets.all(10.0),
          //                 child: ClipRRect(
          //                   borderRadius: BorderRadius.circular(12),
          //                   child: CustomImage(
          //                     image: '${splashController.configModel.baseUrls.moduleImageUrl}/${splashController.moduleList[index].icon}',
          //                     height: 50, width: 50,
          //                   ),
          //                 ),
          //               )
          //           ),
          //
          //           SizedBox(height: Dimensions.PADDING_SIZE_SMALL),
          //
          //           Center(child: Text(
          //             splashController.moduleList[index].moduleName,
          //             textAlign: TextAlign.center, maxLines: 2, overflow: TextOverflow.ellipsis,
          //             style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeSmall),
          //           )),
          //
          //         ]),
          //       );
          //     },
          //   ),
          // ),
        ],),
    );
  }

}

class ModuleShimmer extends StatelessWidget {
  final bool isEnabled;
  final BuildContext context;
  ModuleShimmer({@required this.isEnabled , @required this.context});

  @override
  Widget build(BuildContext context) {
    return GridView.builder(
      gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
        crossAxisCount: 3, mainAxisSpacing: Dimensions.PADDING_SIZE_SMALL,
        crossAxisSpacing: Dimensions.PADDING_SIZE_SMALL, childAspectRatio: (1/1),
      ),
      padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
      itemCount: 6,
      shrinkWrap: true, physics: NeverScrollableScrollPhysics(),
      itemBuilder: (context, index) {
        return Container(
          decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(Dimensions.RADIUS_DEFAULT),
            color: Theme.of(context).backgroundColor,
            boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 700 : 200], spreadRadius: 1, blurRadius: 5)],
          ),
          child: Shimmer(
            duration: Duration(seconds: 2),
            enabled: isEnabled,
            child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [

              Container(
                height: 50, width: 50,
                decoration: BoxDecoration(borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL), color: Colors.grey[300]),
              ),
              SizedBox(height: Dimensions.PADDING_SIZE_SMALL),

              Center(child: Container(height: 15, width: 50, color: Colors.grey[300])),

            ]),
          ),
        );
      },
    );
  }

}

//        height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
class BannerView extends StatelessWidget {
  final bool isFeatured;
  BannerView({@required this.isFeatured});

  @override
  Widget build(BuildContext context) {

    return GetBuilder<BannerController>(builder: (bannerController) {
      List<String> bannerList = isFeatured ? bannerController.featuredBannerList : bannerController.bannerImageList;
      List<dynamic> bannerDataList = isFeatured ? bannerController.featuredBannerDataList : bannerController.bannerDataList;

      return bannerList != null? bannerList.length > 0 ? Container(
        width: MediaQuery.of(context).size.width,
        height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.44,
        padding: EdgeInsets.only(top: Dimensions.PADDING_SIZE_DEFAULT),
        child: bannerList != null ? Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: [
            Expanded(
              child: CarouselSlider.builder(
                options: CarouselOptions(
                  autoPlay: true,
                  enlargeCenterPage: true,
                  disableCenter: true,
                  viewportFraction: 0.8,
                  autoPlayInterval: Duration(seconds: 7),
                  onPageChanged: (index, reason) {
                    bannerController.setCurrentIndex(index, true);
                  },
                ),
                itemCount: bannerList.length == 0 ? 1 : bannerList.length,
                itemBuilder: (context, index, _) {
                  String _baseUrl = bannerDataList[index] is BasicCampaignModel ? Get.find<SplashController>().configModel.baseUrls.campaignImageUrl  : Get.find<SplashController>().configModel.baseUrls.bannerImageUrl;
                  return InkWell(
                    onTap: ()  {
                      Get.toNamed(RouteHelper.getAllProductsRoute('Offers'));

                      // if(bannerDataList[index] is Item) {
                      //   Item _item = bannerDataList[index];
                      //   Get.find<ItemController>().navigateToItemPage(_item, context);
                      // }else if(bannerDataList[index] is Store) {
                      //   Store _store = bannerDataList[index];
                      //   if(isFeatured && (Get.find<LocationController>().getUserAddress().zoneData != null
                      //       && Get.find<LocationController>().getUserAddress().zoneData.length > 0)) {
                      //     for(ModuleModel module in Get.find<SplashController>().moduleList) {
                      //       if(module.id == _store.moduleId) {
                      //         Get.find<SplashController>().setModule(module);
                      //         break;
                      //       }
                      //     }
                      //     ZoneData _zoneData = Get.find<LocationController>().getUserAddress().zoneData.firstWhere((data) => data.id == _store.zoneId);
                      //
                      //     Modules _module = _zoneData.modules.firstWhere((module) => module.id == _store.moduleId);
                      //     Get.find<SplashController>().setModule(ModuleModel(id: _module.id, moduleName: _module.moduleName, moduleType: _module.moduleType, themeId: _module.themeId, storesCount: _module.storesCount));
                      //   }
                      //   Get.toNamed(
                      //     RouteHelper.getStoreRoute(_store.id, isFeatured ? 'module' : 'banner'),
                      //     arguments: StoreScreen(store: _store, fromModule: isFeatured),
                      //   );
                      // }else if(bannerDataList[index] is BasicCampaignModel) {
                      //   BasicCampaignModel _campaign = bannerDataList[index];
                      //   Get.toNamed(RouteHelper.getBasicCampaignRoute(_campaign));
                      // }else {
                      //   String url = bannerDataList[index];
                      //   print('--------------url is: $url');
                      //   if (await canLaunchUrlString(url)) {
                      //     await launchUrlString(url, mode: LaunchMode.externalApplication);
                      //   }else {
                      //     showCustomSnackBar('unable_to_found_url'.tr);
                      //   }
                      // }
                    },
                    child: Container(
                      decoration: BoxDecoration(
                        color: Theme.of(context).cardColor,
                        borderRadius: BorderRadius.circular(Dimensions.RADIUS_LARGE),
                        boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                      ),
                      child: ClipRRect(
                        borderRadius: BorderRadius.circular(Dimensions.RADIUS_EXTRA_LARGE),
                        child: GetBuilder<SplashController>(builder: (splashController) {
                          return CustomImage(
                            image: '$_baseUrl/${bannerList[index]}',
                            fit: BoxFit.fill,
                          );
                        }),
                      ),
                    ),
                  );
                },
              ),
            ),

            SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL),
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: bannerList.map((bnr) {
                int index = bannerList.indexOf(bnr);
                return TabPageSelectorIndicator(
                  backgroundColor: index == bannerController.currentIndex ? Theme.of(context).primaryColor
                      : Theme.of(context).primaryColor.withOpacity(0.5),
                  borderColor: Theme.of(context).backgroundColor,
                  size: index == bannerController.currentIndex ? 10 : 7,
                );
              }).toList(),
            ),

          ],
        ) : Shimmer(
          duration: Duration(seconds: 2),
          enabled: bannerList == null,
          child: Container(margin: EdgeInsets.symmetric(horizontal: 10), decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
            color: Colors.grey[300],
          )),
        ),
      )
          :SizedBox()
          :BannerShimmer(isEnabled: bannerList==null,context: context,);
    });
  }

}

class PrimeBenefitsBannerView extends StatelessWidget {
  final UserInfoModel user;
  PrimeBenefitsBannerView(this.user);


  @override
  Widget build(BuildContext context) {
     double _primeDiscountAmount = Get.find<SplashController>().configModel.primeMemberAditionalDiscount;


    return GetBuilder<BannerController>(builder: (splashController) {


      return splashController.primeEventsResponse != null
          ? splashController.primeEventsResponse.data.length>0?
      Container(
        width: MediaQuery.of(context).size.width,
        height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
        // padding: EdgeInsets.only(top: 0),
        child:Column(
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: [
            SizedBox(height: 10,),

            Expanded(
              child: CarouselSlider.builder(
                options: CarouselOptions(
                  autoPlay: true,
                  enlargeCenterPage: false,
                  disableCenter: true,
                  viewportFraction: 0.9,
                  enableInfiniteScroll: true,
                  autoPlayInterval: Duration(seconds: 3),
                  onPageChanged: (index, reason) {
                    // bannerController.setCurrentIndex(index, true);
                  },
                ),
                itemCount: splashController.primeEventsResponse.data.length,
                itemBuilder: (context, index, _) {
                  return Padding(
                    padding: const EdgeInsets.only(left: 10,right: 10),
                    child: InkWell(
                      onTap: ()  {
                        Get.toNamed(RouteHelper.getUpiScreenshotImageScreenRoute(splashController.primeEventsResponse.data[index].image));
                      },

                      child: Container(
                        decoration: BoxDecoration(
                          color: Theme.of(context).cardColor,
                          borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                          boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                        ),
                        child: ClipRRect(
                          borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                          child: Stack(children: [
                            Container(
                              width: double.infinity,
                              child: CustomImage(
                                image: splashController.primeEventsResponse.data[index].image,
                                fit: BoxFit.fill,
                              ),
                            ),

                            Positioned(bottom: 16,child: splashController.primeEventsResponse.data[index].additionalText=="true"?
                            Container(
                              width: context.width,
                              child: Center(
                                child: Text('${PriceConverter.primeDiscountToViewOnly(discount: _primeDiscountAmount,
                                    discountType: Get.find<SplashController>().configModel.primeMemberAditionalDiscountType)}'
                                    , style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge
                                        ,color: Colors.yellowAccent)),
                              ),
                            )
                                :SizedBox())
                          ],),
                        ),
                      ),
                    ),
                  );
                },
              ),
            ),

          ],
        ),
      )
          :SizedBox()

          :BannerShimmer(isEnabled: splashController.primeEventsResponse==null,context: context,) ;
    });
  }

}

// class PrimeBenefitsBannerView extends StatelessWidget {
//   final UserInfoModel user;
//   PrimeBenefitsBannerView(this.user);
//
//   Widget primeDiscountUI(BuildContext context) {
//     double _primeDiscountAmount = Get.find<SplashController>().configModel.primeMemberAditionalDiscount;
//
//     return Padding(
//       padding: const EdgeInsets.all(5),
//       child: Container(
//         height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
//         width: double.infinity,
//         padding: const EdgeInsets.all(8),
//         decoration: BoxDecoration(
//             gradient: const LinearGradient(
//               begin: Alignment.topLeft,
//               end: Alignment.bottomRight,
//              // colors: [ Color(0xFF846AFF), Color(0xFF755EE8), Colors.purpleAccent,Colors.amber,],
//               colors: [ Colors.amber,Colors.purpleAccent,Color(0xFF846AFF)],
//             ),
//             borderRadius: BorderRadius.circular(10)),
//         child: Row(
//           children: [
//             Image.asset(Images.logo_2,
//               width: 80, height: 30,),
//             Column(
//               children: [
//                 Text('additional_membership_discount'.tr, style:
//                 robotoMedium.copyWith(fontSize:
//                 Dimensions.fontSizeExtraExtraLarge,color:
//                 Theme.of(context).cardColor)),
//
//                 SizedBox(height: 10,),
//
//                 Text('${PriceConverter.primeDiscountToViewOnly(discount: _primeDiscountAmount,
//                 discountType: Get.find<SplashController>().
//                 configModel.primeMemberAditionalDiscountType)}', style:
//                 robotoMedium.copyWith(fontSize:
//                 Dimensions.fontSizeExtraExtraLarge,color:
//                 Theme.of(context).cardColor)),
//
//
//
//
//
//               ],
//             ),
//
//           ],
//         ),
//       ),
//     );
//   }
//
//   Widget prelaunchingUI(BuildContext context) {
//     return Padding(
//       padding: const EdgeInsets.all(5),
//       child: Container(
//         height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
//         width: double.infinity,
//         padding: const EdgeInsets.all(8),
//         decoration: BoxDecoration(
//             gradient: const LinearGradient(
//               begin: Alignment.topLeft,
//               end: Alignment.bottomRight,
//              // colors: [ Color(0xFF846AFF), Color(0xFF755EE8), Colors.purpleAccent,Colors.amber,],
//               colors: [ Colors.amber,Colors.purpleAccent,Color(0xFF846AFF)],
//             ),
//             borderRadius: BorderRadius.circular(10)), // Adds a gradient background and rounded corners to the container
//         child: Row(
//           children: [
//             Image.asset(Images.logo_2,
//               width: 80, height: 30,),
//             Column(
//               children: [
//                 Text('prime_membership'.tr, style:
//                 robotoMedium.copyWith(fontSize:
//                 Dimensions.fontSizeExtraExtraLarge,color:
//                 Theme.of(context).cardColor)),
//
//                 SizedBox(height: 5,),
//                 Column(
//                   crossAxisAlignment: CrossAxisAlignment.center,
//                   mainAxisAlignment: MainAxisAlignment.center,
//                   children: [
//                     Text('PRELAUNCHING', style:
//                     robotoBold.copyWith(fontSize:
//                     Dimensions.fontSizeExtraLarge,color:
//                     AppConstants.googleButtonColor)),
//                     SizedBox(height: 2,),
//                     Text('from 13-12-2023', style: robotoRegular.copyWith(fontSize:
//                     Dimensions.fontSizeLarge,color:
//                     Theme.of(context).cardColor))
//                   ],
//                 ),
//               ],
//             ),
//
//             Padding(
//               padding: const EdgeInsets.only(left: 10),
//               child: Align(child:   Image.asset(Images.india,
//                 width: 40, height: 40,), alignment: Alignment.center),
//             ),
//           ],
//         ),
//       ),
//     );
//   }
//
//   Widget launchingUI(BuildContext context) {
//     return Padding(
//       padding: const EdgeInsets.all(5),
//       child: Container(
//         height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
//         width: double.infinity,
//         padding: const EdgeInsets.all(8),
//         decoration: BoxDecoration(
//             gradient: const LinearGradient(
//               begin: Alignment.topLeft,
//               end: Alignment.bottomRight,
//               // colors: [ Color(0xFF846AFF), Color(0xFF755EE8), Colors.purpleAccent,Colors.amber,],
//               colors: [ Colors.amber,Colors.purpleAccent,Color(0xFF846AFF)],
//             ),
//             borderRadius: BorderRadius.circular(10)), // Adds a gradient background and rounded corners to the container
//         child: Row(
//           children: [
//             Image.asset(Images.logo_2,
//               width: 80, height: 30,),
//             Column(
//               children: [
//                 Text('prime_membership'.tr, style:
//                 robotoMedium.copyWith(fontSize:
//                 Dimensions.fontSizeExtraExtraLarge,color:
//                 Theme.of(context).cardColor)),
//
//                 SizedBox(height: 5,),
//                 Column(
//                   crossAxisAlignment: CrossAxisAlignment.center,
//                   mainAxisAlignment: MainAxisAlignment.center,
//                   children: [
//                     Text('LAUNCHING', style:
//                     robotoBold.copyWith(fontSize:
//                     Dimensions.fontSizeExtraLarge,color:
//                     AppConstants.googleButtonColor)),
//                     SizedBox(height: 2,),
//                     Text('from 26-01-2026', style: robotoRegular.copyWith(fontSize:
//                     Dimensions.fontSizeLarge,color:
//                     Theme.of(context).cardColor))
//                   ],
//                 ),
//               ],
//             ),
//
//             Padding(
//               padding: const EdgeInsets.only(left: 10),
//               child: Align(child:   Image.asset(Images.india,
//                 width: 40, height: 40,), alignment: Alignment.center),
//             ),
//           ],
//         ),
//       ),
//     );
//   }
//   @override
//   Widget build(BuildContext context) {
//
//     return GetBuilder<BannerController>(builder: (bannerController) {
//
//
//       //_user.primeMember==1
//       var count=0;
//       var list=[
//         Images.free_delivery,
//         Images.free_delivery,
//         Images.free_delivery,
//
//         Images.free_delivery,
//         Images.share_img,
//         Images.family_tracking,
//         Images.wallet_img,
//         Images.credit_limit
//
//       ];
//
//       return Container(
//         width: MediaQuery.of(context).size.width,
//         height: GetPlatform.isDesktop ? 500 : MediaQuery.of(context).size.width * 0.30,
//         // padding: EdgeInsets.only(top: 0),
//         child:Column(
//           crossAxisAlignment: CrossAxisAlignment.stretch,
//           children: [
//
//             Expanded(
//               child: CarouselSlider.builder(
//                 options: CarouselOptions(
//                   autoPlay: true,
//                   enlargeCenterPage: true,
//                   disableCenter: true,
//                   viewportFraction: 1,
//                   enableInfiniteScroll: true,
//                   autoPlayInterval: Duration(seconds: 3),
//                   onPageChanged: (index, reason) {
//                     bannerController.setCurrentIndex(index, true);
//                   },
//                 ),
//                 itemCount: list.length,
//                 itemBuilder: (context, index, _) {
//                   return index > 2 ?  InkWell(
//                     onTap: () async {
//                       if(list[index]==Images.family_tracking && user.primeMember==1){
//                         Get.toNamed(RouteHelper.getTrackFamilyMemberRoute());
//                       }
//                     },
//
//                     child: Card(
//                       shape: RoundedRectangleBorder(
//                         borderRadius: BorderRadius.circular(10),
//                       ),
//                       clipBehavior: Clip.antiAliasWithSaveLayer,
//                       child: Container(child:  Image.asset(
//                         list[index],
//                         width: context.width,
//                         fit: BoxFit.fill,
//                       )),
//                     ),
//                   )
//                       : index==0? prelaunchingUI(context)
//                       : index==1? launchingUI(context):
//                   primeDiscountUI(context);
//                 },
//               ),
//             ),
//
//           ],
//         ),
//       );
//     });
//   }
//
// }


