import 'package:sixam_mart/controller/item_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/view/base/title_widget.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/base/product_grid_shimmer.dart';
import '../../../../helper/responsive_helper.dart';
import '../../../base/item_widget.dart';
import '../web/web_popular_item_view.dart';


class ProductsViewSonu extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    bool _desktop = ResponsiveHelper.isDesktop(context);
    bool _isTab = ResponsiveHelper.isTab(context);
    bool _isWeb = ResponsiveHelper.isWeb();
    bool _isMobile = ResponsiveHelper.isMobile(context);

    double _width = MediaQuery.of(context).size.width;
    print("testResponsiveHelper ProductsViewSonu _desktop $_desktop _isTab $_isTab isWeb $_isWeb _isMobile $_isMobile");

    return GetBuilder<ItemController>(builder: (itemController) {

      List<Item> _itemList = itemController.featuredLatestItemList;

      return _itemList != null ? _itemList.length > 0 ?
       Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: EdgeInsets.only(left: 10,right: 10),
            child: TitleWidget(
              title: 'products'.tr,
              onTap: () => Get.toNamed(RouteHelper.getAllProductsRoute('all_products'.tr)),
            ),
          ),

          SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),
          GridView.builder(gridDelegate:
          SliverGridDelegateWithFixedCrossAxisCount(
            crossAxisCount: _desktop ? Dimensions.crossAxisCount_Desktop : (_isTab && _width > 950 )? Dimensions.crossAxisCount_Tab_widthMoreThan950 : (_isTab && _width < 950 )? Dimensions.crossAxisCount_Tab_widthLessThan950  : Dimensions.crossAxisCount_Mobile
            , mainAxisSpacing: ( _desktop || _isTab )? Dimensions.mainAxisSpacing_Desktop_Tab:  Dimensions.mainAxisSpacing_mobile,
            crossAxisSpacing:( _desktop || _isTab ) ? Dimensions.PADDING_SIZE_DEFAULT : Dimensions.PADDING_SIZE_SMALL
            , childAspectRatio: _desktop ? Dimensions.childAspectRatio_Desktop : (_isTab && _width > 950 ) ? Dimensions.childAspectRatio_Tab_widthMoreThan950 : (_isTab && _width < 950 ) ? Dimensions.childAspectRatio_Tab_widthLessThan950 : Dimensions.childAspectRatio_Mobile,

          ),
            padding: EdgeInsets.all(Dimensions.gridPadding),
            itemCount: _itemList.length,
            shrinkWrap: true, physics: NeverScrollableScrollPhysics(),
            itemBuilder: (context, index) {
              return ItemWidget(
                isStore: false,
                item: _itemList[index],
                isFeatured: false,
                store:  null,
                index: index,
                length: _itemList.length,
                isCampaign: false,
                inStore: false,
              );
            },
          ),
        ],
      )
          :SizedBox(): GetPlatform.isWeb ? WebCampaignShimmer(enabled: _itemList == null) : ProductGridShimmer(isEnabled: _itemList==null,);
    });
  }
}

//TitleWidget(
//               title: 'products'.tr,
//               onTap: () => Get.toNamed(RouteHelper.getAllProductsRoute('products'.tr)),
//             )





