import 'package:sixam_mart/controller/cart_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_image.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sixam_mart/view/base/product_grid_shimmer.dart';
import '../../../../controller/auth_controller.dart';
import '../../../../controller/item_controller.dart';
import '../../../../controller/wishlist_controller.dart';
import '../../../../helper/price_converter.dart';
import '../../../../helper/responsive_helper.dart';
import '../../../base/custom_snackbar.dart';
import '../../../base/discount_tag.dart';
import '../../../base/item_widget.dart';
import '../../../base/not_available_widget.dart';
import '../../../base/add_item_button_widget.dart';

class RecentViewSonu extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    bool _desktop = ResponsiveHelper.isDesktop(context);
    String _baseUrl = Get.find<SplashController>().configModel.baseUrls.commonImageUrl;
    return GetBuilder<CartController>(builder: (cartController) {


      return cartController.recentViewList != null ? cartController.recentViewList.length > 0 ? Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Padding(
            padding: EdgeInsets.only(left: 10,right: 10),
            child: Text('recent_view'.tr, style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge)),
          ),
          SizedBox(height: Dimensions.PADDING_SIZE_EXTRA_SMALL,),

          GridView.builder(
            physics: NeverScrollableScrollPhysics(),
            shrinkWrap: true,
            gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
              crossAxisCount: ResponsiveHelper.isDesktop(context) ? 6 : ResponsiveHelper.isTab(context) ? 4 : 1,
              childAspectRatio: (1/0.7),
              mainAxisSpacing: Dimensions.PADDING_SIZE_SMALL,
              crossAxisSpacing: Dimensions.PADDING_SIZE_SMALL,
            ),
            padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
            itemCount: cartController.recentViewList.length,
            reverse: false,
            itemBuilder: (context, index) {
              return ItemWidget(
                isStore: false,
                item: cartController.recentViewList[index],
                isFeatured: false,
                store:  null,
                index: index,
                length: cartController.recentViewList.length,
                isCampaign: false,
                inStore: false,
                isRecentViewItem: true,
              );
            },
          ),
        ],
      )
          :SizedBox():ProductGridShimmer(isEnabled: cartController.recentViewList==null,);
    });
  }
}
