import 'package:dotted_border/dotted_border.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:sixam_mart/view/base/custom_app_bar.dart';
import 'package:sixam_mart/view/base/custom_snackbar.dart';
import 'package:sixam_mart/view/base/footer_view.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_drawer.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../../controller/auth_controller.dart';


class MyEarnings extends StatelessWidget {
  const MyEarnings({Key key}) : super(key: key);




  Widget card(String title , String value){
    return Container(

      padding: const EdgeInsets.all(10.0),
      decoration: BoxDecoration(
        border: Border.all(width: 1, color: Colors.grey),
        borderRadius: BorderRadius.all(Radius.circular(10)),
      ),
      child: Row(
        children: [
          Text(title, style:TextStyle(fontSize: 15, color: Colors.black)),
          SizedBox(width: 5,),
          Text(':', style:TextStyle(fontSize: 15, color: Colors.black)),
          SizedBox(width: 10,),
          Text(
            value,
            style: TextStyle(fontSize: 15.0),
          ),
        ],
      ),
    );
  }


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: CustomAppBar(title: 'my_earnings'.tr),
      endDrawer: WebMenuDrawer(),
      body: Scrollbar(child: SingleChildScrollView(
        physics: BouncingScrollPhysics(),
        child: Container(
          width: context.width,
          height: context.height,
          color: Theme.of(context).backgroundColor,
          child: GetBuilder<AuthController>(builder: (authController) {

            return Padding(
              padding: const EdgeInsets.all(10.0),
              child: Column(crossAxisAlignment: CrossAxisAlignment.start,children: [

                SizedBox(height: 20.0),
                card('date'.tr,"24-03-2023"),
                SizedBox(height: 20.0),
                card('particular'.tr,"particular"),
                SizedBox(height: 20.0),
                card('amount'.tr,"Rs 12,90/-"),
                SizedBox(height: 20.0),

              ]),
            );
          }),
        ),
      )),
    );
  }
}
