import 'dart:io';

import 'package:carousel_slider/carousel_slider.dart';
import 'package:flip_card/flip_card.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:flutter_widget_from_html/flutter_widget_from_html.dart';
import 'package:share_plus/share_plus.dart';
import 'package:sixam_mart/view/base/custom_app_bar.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_drawer.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:url_launcher/url_launcher_string.dart';
import 'package:universal_html/html.dart' as html;
import '../../../../controller/auth_controller.dart';
import '../../../controller/banner_controller.dart';
import '../../../controller/splash_controller.dart';
import '../../../controller/user_controller.dart';
import '../../../helper/price_converter.dart';
import '../../../helper/responsive_helper.dart';
import '../../../helper/route_helper.dart';
import '../../../util/app_constants.dart';
import '../../../util/dimensions.dart';
import '../../../util/html_type.dart';
import '../../../util/images.dart';
import '../../../util/styles.dart';
import '../../base/custom_button.dart';
import '../../base/custom_image.dart';
import '../../base/footer_view.dart';
import '../../base/web_constrained_box.dart';


class BenefitsPointsScreen extends StatefulWidget {
  final HtmlType htmlType;
  final String visiblePayment;
  BenefitsPointsScreen({@required this.htmlType , @required this.visiblePayment});



  @override
  State<BenefitsPointsScreen> createState() => _BenefitsPointsScreenState();
}

class _BenefitsPointsScreenState extends State<BenefitsPointsScreen> {


  @override
  void initState() {
    super.initState();

    // Get.find<SplashController>().getHtmlText(widget.htmlType);
  }
  @override
  Widget build(BuildContext context) {
    double _primeDiscountAmount = Get.find<SplashController>().configModel.primeMemberAditionalDiscount;

    return Scaffold(
      appBar: CustomAppBar(title: 'prime_benefits'.tr),
      endDrawer: WebMenuDrawer(),
      body: Column(
        children: [

          Expanded(
            child: Container(
              height: context.height,
              width: context.width,
              child: Get.find<BannerController>().primeEventsResponse != null? SingleChildScrollView(physics: BouncingScrollPhysics(),
                  child:Column(
                    children: [

                      ListView.builder(
                        controller: ScrollController(),
                        physics: ClampingScrollPhysics(),
                        scrollDirection: Axis.vertical,
                        shrinkWrap: true,
                        padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
                        itemCount: Get.find<BannerController>().primeEventsResponse.data.length,
                        itemBuilder: (context, index){
                          return Padding(
                            padding: EdgeInsets.only(bottom: 10),
                            child: InkWell(
                              onTap: (){
                              },
                              child:  Card(
                                shape: RoundedRectangleBorder(
                                  borderRadius: BorderRadius.circular(10),
                                ),
                                clipBehavior: Clip.antiAliasWithSaveLayer,
                                child: Container(
                                  decoration: BoxDecoration(
                                    color: Theme.of(context).cardColor,
                                    borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                                    boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
                                  ),
                                  child: ClipRRect(
                                    borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
                                    child: Stack(children: [
                                      Container(
                                        width: double.infinity,
                                        child: CustomImage(
                                          image: Get.find<BannerController>().primeEventsResponse.data[index].image,
                                          fit: BoxFit.fill,
                                        ),
                                      ),

                                      Positioned(bottom: 35,child: Get.find<BannerController>().primeEventsResponse.data[index].additionalText=="true"?
                                      Container(
                                        width: context.width,
                                        child: Center(
                                          child: Text('${PriceConverter.primeDiscountToViewOnly(discount: _primeDiscountAmount,
                                              discountType: Get.find<SplashController>().
                                              configModel.primeMemberAditionalDiscountType)}', style:
                                          robotoMedium.copyWith(fontSize:
                                          Dimensions.fontSizeExtraExtraLarge2,color:
                                          Theme.of(context).primaryColor)),
                                        ),
                                      )
                                          :SizedBox())
                                    ],),
                                  ),
                                ),
                              ),

                            ),
                          );
                        },
                      ),
                    ],
                  )) :SizedBox(),
            ),
          ),

          Container(
            width: Dimensions.WEB_MAX_WIDTH,
            padding: EdgeInsets.all(5),
            child: CustomButton(buttonText: 'upgrade_to_prime'.tr, onPressed: () {
              Get.toNamed(RouteHelper.getPrimeMemberBankDetailsRoute(''));

              // Get.find<UserController>().setPrime(1);
              // Get.offNamed(RouteHelper.getInitialRoute());
            }),
          ),

        ],
      ),
    );
  }
}





