import 'dart:async';
import 'dart:collection';
import 'dart:ui';

import 'package:share_plus/share_plus.dart';
import 'package:sixam_mart/controller/location_controller.dart';
import 'package:sixam_mart/controller/order_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/address_model.dart';
import 'package:sixam_mart/data/model/response/order_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:sixam_mart/view/base/custom_app_bar.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:get/get.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:url_launcher/url_launcher_string.dart';

import '../../../controller/prime_member_controller.dart';
import '../../../controller/user_controller.dart';
import '../../../data/model/response/FamilyMemberListResponseData.dart';
import '../../../helper/date_converter.dart';
import '../../../helper/route_helper.dart';
import '../../../util/app_constants.dart';
import '../../../util/styles.dart';
import '../../base/confirmation_dialog.dart';
import '../../base/custom_image.dart';
import '../../base/custom_snackbar.dart';
import '../../base/custom_text_field.dart';


class PrimeInvoiceScreen extends StatefulWidget {

  @override
  State<PrimeInvoiceScreen> createState() => _PrimeInvoiceScreenState();
}

class _PrimeInvoiceScreenState extends State<PrimeInvoiceScreen> {

  @override
  void initState() {
    super.initState();
    Get.find<PrimeMemberController>().getFamilyMembersListData();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: CustomAppBar(title: 'Invoice'),
      body: GetBuilder<PrimeMemberController>(builder: (primeMemberController) {
        List<FamilyMemberData> familyMembersList = primeMemberController.familyMembersList;
        return Container(
          height: context.height,
          width: context.width,
          padding: EdgeInsets.only(left: 10,right: 10),
          child: SingleChildScrollView(physics: BouncingScrollPhysics(),
              child:Column(
                children: [
                  SizedBox(height: 20,),

                  Center(child: Text("Invoice",style:
                  robotoRegular.copyWith(fontSize: Dimensions.fontSizeExtraLarge,)),),
                ],
              )),
        );
      }),
    );

  }
}

