import 'dart:async';

import 'package:sixam_mart/controller/category_controller.dart';
import 'package:sixam_mart/controller/localization_controller.dart';
import 'package:sixam_mart/controller/prime_member_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/data/model/response/item_model.dart';
import 'package:sixam_mart/data/model/response/store_model.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:url_launcher/url_launcher_string.dart';

import '../../../../util/app_constants.dart';
import '../../../controller/auth_controller.dart';
import '../../../controller/change_client_controller.dart';
import '../../../data/model/response/PrimeMembersModel2.dart';
import '../../../data/model/response/users_prime_members_response.dart';
import '../../../util/images.dart';
import '../../base/custom_app_bar.dart';
import '../../base/custom_image.dart';
import '../../base/custom_snackbar.dart';
import '../../base/no_data_screen.dart';
import '../menu/web_menu_bar.dart';

class PrimeMembersListScreen extends StatefulWidget {

  @override
  _PrimeMembersListScreenState createState() => _PrimeMembersListScreenState();
}

class _PrimeMembersListScreenState extends State<PrimeMembersListScreen> with TickerProviderStateMixin {
  final bool _ltr = Get.find<LocalizationController>().isLtr;
  var addOnOffset = 10;
  var limit = 10;
  final TextEditingController _searchController = TextEditingController();
  Timer timeHandle;
  final ScrollController scrollController = ScrollController();
  String parentChild=AppConstants.CHILD;

  @override
  void initState() {
    super.initState();

    Get.find<PrimeMemberController>().getUsersPrimeMembersList();

   //_searchController.addListener(textListener);

    // scrollController?.addListener(() {
    //   if (scrollController.position.pixels == scrollController.position.maxScrollExtent
    //       && Get.find<PrimeMemberController>().primeMembersList != null
    //       && !Get.find<PrimeMemberController>().isLoading) {
    //     int pageSize = (Get.find<PrimeMemberController>().pageSize / 10).ceil();
    //     if (Get.find<PrimeMemberController>().offset < pageSize) {
    //       print('end of the page');
    //       Get.find<PrimeMemberController>().showBottomLoader();
    //       Get.find<PrimeMemberController>().getPrimeMembersList(Get.find<ChangeClientController>().offset+addOnOffset
    //           ,true);
    //     }
    //   }
    // });
  }

  textListener()  {
    var searchedData = _searchController.text.trim();
    if(searchedData!=null && searchedData.isNotEmpty && searchedData.length>1){

      if (timeHandle != null) {
        timeHandle.cancel();
      }
      timeHandle = Timer(Duration(milliseconds: 1200), () {
        _actionSearch(true, searchedData, false);
      });

    }

  }

  @override
  void dispose() {
    _searchController.dispose();
    timeHandle?.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return GetBuilder<PrimeMemberController>(builder: (primeMemberController) {
      List<UsersPrimeMember> _items = primeMemberController.usersPrimeMembersList;

      return Scaffold(

        appBar: ResponsiveHelper.isDesktop(context) ? WebMenuBar() :
        CustomAppBar(title: 'prime_members'.tr),

        body: Center(child: SizedBox(
          width: Dimensions.WEB_MAX_WIDTH,
          child: Column(children: [

            _items!=null ?
           _items.length>0 ? SingleChildScrollView(
              controller: scrollController,
              child: ListView.builder(
                shrinkWrap: true,
                scrollDirection: Axis.vertical,
                itemCount: _items.length,
                physics: BouncingScrollPhysics(),
                itemBuilder: (context, index) {
                  return Padding(
                    padding: const EdgeInsets.only(top: 8,left: 8,right: 8),
                    child:  InkWell(
                      onTap: () {

                      },
                      child: Container(
                        decoration: AppConstants.customBoxDecoration(context),
                        child: Row(
                          children: [
                            Padding(
                              padding: const EdgeInsets.only(right: 5,left: 5),
                              child: Container(
                                decoration: BoxDecoration(
                                  border: Border.all(width: 2, color: Theme.of(context).cardColor),
                                  shape: BoxShape.circle,
                                ),
                                alignment: Alignment.topLeft,
                                child: ClipOval(child: CustomImage(
                                  image: '${Get.find<SplashController>().configModel.baseUrls.customerImageUrl}'
                                      '/${_items[index].image != null  ? _items[index].image : ''}',
                                  height: 40, width: 40, fit: BoxFit.cover,isProfile: true,
                                )),
                              ),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                SizedBox(height: 5,),
                                Text(
                                  '${ _items[index].fullName}',
                                  style: TextStyle(fontSize: 15.0),
                                ),
                                SizedBox(height: 5,),

                                Text(
                                  'Prime Acc: ${ _items[index].primeAccountNo}',
                                  style: TextStyle(fontSize: 15.0),
                                ),
                                SizedBox(height: 5,),

                                Row(
                                  mainAxisAlignment: MainAxisAlignment.start,
                                  children: [
                                    Text(
                                      _items[index].phone,
                                      style: TextStyle(fontSize: 15.0),
                                    ),
                                    SizedBox(width: 5,),

                                    InkWell(child: Container(
                                      height: 30, width: 30,
                                      decoration: BoxDecoration(
                                        shape: BoxShape.circle,
                                        color: Colors.blue.withOpacity(0.2),
                                      ),
                                      child: Icon(Icons.call, color: Colors.blue, size: 20),
                                    ), onTap: () async {
                                      if(await canLaunchUrlString('tel:${_items[index].phone}')) {
                                        launchUrlString('tel:${_items[index].phone}');
                                      }else {
                                        showCustomSnackBar('${'can_not_launch'.tr} ${Get.find<SplashController>().configModel.phone}');
                                      }
                                    }),SizedBox(width: 5,),

                                    InkWell(child: Container(
                                      height: 30, width: 30,
                                      decoration: BoxDecoration(
                                        shape: BoxShape.circle,
                                        color: Colors.red.withOpacity(0.2),
                                      ),
                                      child: Image.asset(Images.whatsapp, width: 30,
                                        height: 30,fit: BoxFit.fill,),
                                    ), onTap: ()
                                    async {
                                      var whatsappUrl =
                                          "whatsapp://send?phone=${_items[index].phone}" ;
                                            //  + "&text=${Uri.encodeComponent("hi")}";

                                      if(await canLaunchUrlString(whatsappUrl)) {
                                        launchUrlString(whatsappUrl);
                                      }else {
                                        showCustomSnackBar('${'can_not_launch'.tr} ${Get.find<SplashController>().configModel.phone}');
                                      }
                                    }),

                                  ],
                                ),

                                Row(
                                  children: [
                                    Text(
                                      _items[index].email,
                                      style: TextStyle(fontSize: 15.0),
                                    ),

                                    SizedBox(width: 5,),
                                    InkWell(child: Container(
                                      height: 30, width: 30,
                                      decoration: BoxDecoration(
                                        shape: BoxShape.circle,
                                        color: Colors.red.withOpacity(0.2),
                                      ),
                                      child: Icon(Icons.mail_outline, color: Colors.red, size: 20),
                                    ), onTap: () async {
                                      final Uri emailLaunchUri = Uri(
                                        scheme: 'mailto',
                                        path: _items[index].email,
                                      );
                                      launchUrlString(emailLaunchUri.toString());
                                    }),
                                  ],
                                ),
                                // SizedBox(height: 10,),
                                // Row(
                                //   children: [
                                //     Text('prime_member_since'.tr, style:TextStyle(fontSize: 15, color: Colors.black)),
                                //     SizedBox(width: 5,),
                                //     Text(':', style:TextStyle(fontSize: 15, color: Colors.black)),
                                //     SizedBox(width: 10,),
                                //     Text(
                                //       _items[index] == null ? "NA" : _items[index].primeSince,
                                //       style: TextStyle(fontSize: 15.0),
                                //     ),
                                //   ],
                                // ),
                                // SizedBox(height: 10,),
                                //
                                // Row(
                                //   children: [
                                //     Text('ref_code'.tr, style:TextStyle(fontSize: 15, color: Colors.black)),
                                //     SizedBox(width: 5,),
                                //     Text(':', style:TextStyle(fontSize: 15, color: Colors.black)),
                                //     // SizedBox(width: 10,),
                                //     // Text(
                                //     //   _items[index].refCode == null ? "NA" : _items[index].refCode,
                                //     //   style: TextStyle(fontSize: 15.0,color:
                                //     //   Get.find<AuthController>().getClientReferral()==_items[index].refCode
                                //     //       ? Colors.white
                                //     //       :Theme.of(context).primaryColor ),
                                //     // ),
                                //   ],
                                // ),
                                SizedBox(height: 5,),

                              ]
                              ,)
                          ],
                        ),
                      ),
                    ),
                  );
                },
              ),
            )
           : NoDataScreen(text: 'no_data_found'.tr)
                :SizedBox(),

            primeMemberController.isLoading ? Center(child: Padding(
              padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
              child: CircularProgressIndicator(valueColor: AlwaysStoppedAnimation<Color>(Theme.of(context).primaryColor)),
            )) : SizedBox(),

          ]),
        )),
      );
    });
  }

  void _actionSearch(bool isSubmit, String queryText, bool fromHome) {
    if(Get.find<ChangeClientController>().isSearchMode || isSubmit) {
      if(queryText.isNotEmpty) {

        Get.find<ChangeClientController>().searchData(queryText);
      }

    }
  }
}