import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../../../helper/route_helper.dart';

class ProfileButton extends StatelessWidget {
  final IconData icon;
  final String title;
  final String icon2;
  final bool isButtonActive;
  final Function onTap;
  ProfileButton({ this.icon, @required this.title, @required this.onTap, this.isButtonActive, this.icon2});

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: title=='notification'.tr ? (){
        Get.toNamed(RouteHelper.getNotificationRoute(fromNotification: false));
      } :  onTap,
      child: Container(
        padding: EdgeInsets.symmetric(
          horizontal: Dimensions.PADDING_SIZE_SMALL,
          vertical: isButtonActive != null ? Dimensions.PADDING_SIZE_EXTRA_SMALL : Dimensions.PADDING_SIZE_DEFAULT,
        ),
        decoration: BoxDecoration(
          color: Theme.of(context).cardColor,
          borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
          boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], spreadRadius: 1, blurRadius: 5)],
        ),
        child: Row(children: [
          icon2==null?Icon(icon, size: 25):Image.asset(icon2,width: 25,height: 25,),

          SizedBox(width: Dimensions.PADDING_SIZE_SMALL),
          Expanded(child: Text(title, style: robotoRegular)),
          isButtonActive != null ? Switch(
            value: isButtonActive,
            onChanged: (bool isActive) => onTap(),
            activeColor: Theme.of(context).primaryColor,
            activeTrackColor: Theme.of(context).primaryColor.withOpacity(0.5),
          ) : SizedBox(),
        ]),
      ),
    );
  }
}
