import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../../../../helper/route_helper.dart';

class ProfileCard extends StatelessWidget {
  final String title;
  final String data;
  ProfileCard({@required this.data, @required this.title});

  @override
  Widget build(BuildContext context) {
    return Expanded(child: Padding(
      padding: const EdgeInsets.only(left: 5,right: 5),
      child: InkWell(child: Container(
        height: 100,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(Dimensions.RADIUS_SMALL),
          color: data=='recharge'.tr? Colors.green :Theme.of(context).cardColor,
          boxShadow: [BoxShadow(color: Colors.grey[Get.isDarkMode ? 800 : 200], blurRadius: 5, spreadRadius: 1)],
        ),
        child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [
          Text(data, style: robotoMedium.copyWith(
            fontSize: Dimensions.fontSizeExtraLarge, color: data=='recharge'.tr? Colors.white : Theme.of(context).primaryColor,
          )),
          SizedBox(height: Dimensions.PADDING_SIZE_SMALL),
          Text(title, style: robotoRegular.copyWith(
            fontSize: Dimensions.fontSizeSmall, color: Theme.of(context).disabledColor,
          )),
        ]),
      ),onTap: (){
        if(data=='recharge'.tr){
          Get.toNamed(RouteHelper.getWalletRechargeRoute(true));
        }else if(title=='wallet_amount'.tr){
          Get.toNamed(RouteHelper.getWalletRoute(true,"NA"));
        }
      },),
    ));
  }
}
