import 'dart:async';

import 'package:sixam_mart/controller/order_controller.dart';
import 'package:sixam_mart/controller/splash_controller.dart';
import 'package:sixam_mart/controller/theme_controller.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/helper/route_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/images.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:sixam_mart/view/base/custom_button.dart';
import 'package:sixam_mart/view/base/footer_view.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_drawer.dart';
import 'package:sixam_mart/view/screens/menu/web_menu_bar.dart';
import 'package:sixam_mart/view/screens/checkout/widget/payment_failed_dialog.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../../../controller/prime_member_controller.dart';

class WalletAmtTransferSuccessfulScreen extends StatefulWidget {
  @override
  State<WalletAmtTransferSuccessfulScreen> createState() => _WalletAmtTransferSuccessfulScreenState();
}

class _WalletAmtTransferSuccessfulScreenState extends State<WalletAmtTransferSuccessfulScreen> {


  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: () async{
        await Get.offAllNamed(RouteHelper.getInitialRoute());
        return false;
      },
      child: Scaffold(
        backgroundColor: Theme.of(context).cardColor,
        appBar: ResponsiveHelper.isDesktop(context) ? WebMenuBar() : null,
        endDrawer: WebMenuDrawer(),
        body: Center(
          child: SingleChildScrollView(
            child: FooterView(child: SizedBox(width: Dimensions.WEB_MAX_WIDTH,
                child: Column(mainAxisAlignment: MainAxisAlignment.center, children: [

                  Image.asset(Images.checked , width: 100, height: 100),
                  SizedBox(height: Dimensions.PADDING_SIZE_LARGE),

                  Text('wallet_transfer_successful'.tr,
                    style: robotoMedium.copyWith(fontSize: Dimensions.fontSizeLarge),
                  ),

                  SizedBox(height: 30),

                  Padding(
                    padding: EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
                    child: CustomButton(buttonText: 'back'.tr, onPressed: () => Get.offAllNamed(RouteHelper.getInitialRoute())),
                   // child: CustomButton(buttonText: 'back'.tr, onPressed: () => Get.back()),
                  ),
                ]))),
          ),
        ),
      ),
    );
  }
}
