import 'dart:async';
import 'package:sixam_mart/controller/localization_controller.dart';
import 'package:sixam_mart/controller/wallet_controller.dart';
import 'package:sixam_mart/helper/responsive_helper.dart';
import 'package:sixam_mart/util/dimensions.dart';
import 'package:sixam_mart/util/styles.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import '../../../../util/app_constants.dart';
import '../../../controller/change_client_controller.dart';
import '../../../data/model/response/WallerTransferHistoryResponseModel.dart';
import '../../../util/images.dart';
import '../../base/custom_app_bar.dart';
import '../../base/footer_view.dart';
import '../../base/web_constrained_box.dart';
import '../menu/web_menu_drawer.dart';

class WalletTransferHistoryScreen extends StatefulWidget {

  @override
  _WalletTransferHistoryScreenState createState() => _WalletTransferHistoryScreenState();
}

class _WalletTransferHistoryScreenState extends State<WalletTransferHistoryScreen> with TickerProviderStateMixin {
  final bool _ltr = Get.find<LocalizationController>().isLtr;
  var addOnOffset = 10;
  final TextEditingController _searchController = TextEditingController();
  Timer timeHandle;
  final ScrollController scrollController = ScrollController();
  String parentChild=AppConstants.CHILD;

  @override
  void initState() {
    super.initState();

    Get.find<WalletController>().walletAmtTransferHistory();

  // _searchController.addListener(textListener);

    // scrollController?.addListener(() {
    //   if (scrollController.position.pixels == scrollController.position.maxScrollExtent
    //       && Get.find<CategoryController>().categoryItemList != null
    //       && !Get.find<CategoryController>().isLoading) {
    //     int pageSize = (Get.find<CategoryController>().pageSize / 10).ceil();
    //     if (Get.find<CategoryController>().offset < pageSize) {
    //       print('end of the page');
    //       Get.find<CategoryController>().showBottomLoader();
    //       Get.find<ChangeClientController>().getPrimeMembersList(Get.find<ChangeClientController>().offset+addOnOffset
    //           ,true);
    //     }
    //   }
    // });
  }


  // @override
  // void dispose() {
  //   _searchController.dispose();
  //   timeHandle?.cancel();
  //   super.dispose();
  // }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: CustomAppBar(title: 'transfer_history'.tr),
      endDrawer: WebMenuDrawer(),
      body: GetBuilder<WalletController>(
        builder: (walletController) {
          List<WallerTransferHistoryResponseData> _items=walletController.wallerTransferHistoryResponseModel?.data;

          print("WallerTransferHistoryResponseData ${_items?.length}");
          return  ( _items!=null && _items.length > 0) ? SingleChildScrollView(
            child: Scrollbar(
              child: SingleChildScrollView(
                padding: ResponsiveHelper.isDesktop(context) ? EdgeInsets.only(
                  top: Dimensions.PADDING_SIZE_SMALL,
                ) : EdgeInsets.all(Dimensions.PADDING_SIZE_SMALL),
                physics: BouncingScrollPhysics(),
                child: FooterView(
                  child: SizedBox(
                    width: Dimensions.WEB_MAX_WIDTH,
                    child: ListView.builder(
                      physics: NeverScrollableScrollPhysics(),
                      shrinkWrap: true,
                      itemCount: _items.length,
                      itemBuilder: (context, index) {

                        return  Padding(
                          padding: const EdgeInsets.all(8.0),
                          child: Container(
                            padding: const EdgeInsets.only(left: 10,right: 10,top: 5,bottom: 5),
                            decoration: BoxDecoration(
                              border: Border.all(color: Colors.blueGrey),
                            ),
                            child: Column(
                              children: [
                                Row(children: [
                                // Text(
                                //   'Income Type:  ${_items[index].incomeType}',
                                //   style: robotoMedium.copyWith(fontSize: 12),
                                //   textAlign: TextAlign.center,
                                // ),
                                //   SizedBox(width: 10,),

                                  (_items[index].debit==null && _items[index].credit!=null)?
                                  Row(
                                    children: [
                                      Text(
                                        'Credit:',
                                        style: robotoMedium.copyWith(fontSize: 12,),
                                        textAlign: TextAlign.center,
                                      ),
                                      SizedBox(width: 5,),
                                      Text(
                                        '${_items[index].credit}',
                                        style: robotoMedium.copyWith(fontSize: 12, color: Theme.of(context).disabledColor),
                                        textAlign: TextAlign.center,
                                      ),
                                    ],
                                  ) :
                                  (_items[index].credit==null && _items[index].debit!=null) ?
                                  Row(
                                    children: [
                                      Text(
                                        'Debit:',
                                        style: robotoMedium.copyWith(fontSize: 12,),
                                        textAlign: TextAlign.center,
                                      ),
                                      SizedBox(width: 5,),
                                      Text(
                                        '${_items[index].debit}',
                                        style: robotoMedium.copyWith(fontSize: 12, color: Theme.of(context).disabledColor),
                                        textAlign: TextAlign.center,
                                      ),
                                    ],
                                  ) : SizedBox(),

                                  SizedBox(width: 10,),
                                  Text(
                                    '${_items[index].createdAt}',
                                    style: robotoMedium.copyWith(fontSize: 12,color: Theme.of(context).disabledColor),
                                    textAlign: TextAlign.center,
                                  ),
                                SizedBox(width: 10,),

                          ],),

                                SizedBox(height: 10,),

                                Row(mainAxisAlignment: MainAxisAlignment.spaceBetween,children: [


                                  (_items[index].debit==null && _items[index].credit!=null)?
                                  Row(
                                    children: [
                                      Text(
                                        'Received from:',
                                        style: robotoMedium.copyWith(fontSize: 12,),
                                        textAlign: TextAlign.center,
                                      ),
                                      SizedBox(width: 5,),
                                      Text(
                                        '${_items[index].party}',
                                        style: robotoMedium.copyWith(fontSize: 12, color: Theme.of(context).disabledColor),
                                        textAlign: TextAlign.center,
                                      ),
                                    ],
                                  ) : (_items[index].credit==null && _items[index].debit!=null) ?
                                  Row(
                                    children: [
                                      Text(
                                        'Transfer to:',
                                        style: robotoMedium.copyWith(fontSize: 12,),
                                        textAlign: TextAlign.center,
                                      ),
                                      SizedBox(width: 5,),
                                      Text(
                                        '${_items[index].party}',
                                        style: robotoMedium.copyWith(fontSize: 12, color: Theme.of(context).disabledColor),
                                        textAlign: TextAlign.center,
                                      ),
                                    ],
                                  )
                                      : SizedBox(),

                                  Row(
                                    children: [
                                      Text(
                                        'Balance:',
                                        style: robotoMedium.copyWith(fontSize: 12),
                                        textAlign: TextAlign.center,
                                      ),
                                      SizedBox(width: 5,),

                                      Text(
                                        '${_items[index].balance}',
                                        style: robotoMedium.copyWith(fontSize: 12),
                                        textAlign: TextAlign.center,
                                      ),
                                    ],
                                  ),




                                ],),
                              ],
                            ),),
                        );
                        // return CartItemWidget(cart: cartController.cartList[index], cartIndex: index, addOns: cartController.addOnsList[index], isAvailable: cartController.availableList[index]);

                      },
                    ),
                  ),
                ),
              ),
            ),
          ) :
          walletController.isHistoryLoading? Center(child: CircularProgressIndicator(),) :
          SingleChildScrollView(
            child: FooterView(
              visibility: true,
              child: Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.stretch, children: [

                Image.asset(
                  Images.no_data_found,
                  width: MediaQuery.of(context).size.height*0.15, height: MediaQuery.of(context).size.height*0.15,
                ),
                SizedBox(height: MediaQuery.of(context).size.height*0.03),

                Text(
                  'transfer_history_not_available'.tr ,
                  style: robotoMedium.copyWith(fontSize: MediaQuery.of(context).size.height*0.0175, color: Theme.of(context).disabledColor),
                  textAlign: TextAlign.center,
                ),

              ]),
            ),
          );
        },
      ),
    );
  }

}

