import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';
import 'package:url_launcher/url_launcher_string.dart';

import '../../util/dimensions.dart';
import '../base/custom_app_bar.dart';
import '../base/custom_snackbar.dart';
import '../base/custom_text_field.dart';

class WebViewTestScreen extends StatefulWidget {

  @override
  State<WebViewTestScreen> createState() => _WebViewTestScreenState();
}



class _WebViewTestScreenState extends State<WebViewTestScreen> {
  final GlobalKey webViewKey = GlobalKey();
  InAppWebViewController webViewController;
  final TextEditingController _passwordController = TextEditingController();
  String cookiesString = '';
  List<List<String>> listOfLists = []; //Outter List which contains the data List
  List<String> header = [];


  @override
  void initState() {
    super.initState();
    // IsolateNameServer.registerPortWithName(_port.sendPort, 'downloader_send_port');
    // _port.listen((dynamic data) {
    //   String id = data[0];
    //   int progress = data[2];
    //   setState((){ });
    // });
    // FlutterDownloader.registerCallback(downloadCallback);

  }

  // @pragma('vm:entry-point')
  // static void downloadCallback(String id, int status, int progress) {
  //   final SendPort? send = IsolateNameServer.lookupPortByName('downloader_send_port');
  //   send?.send([id, status, progress]);
  // }

  // @override
  // void dispose() {
  //   IsolateNameServer.removePortNameMapping('downloader_send_port');
  //   super.dispose();
  // }
  // Future<void> updateCookies(Uri url) async {
  //   List<Cookie> cookies = await CookieManager().getCookies(url: url);
  //   cookiesString = '';
  //   for (Cookie cookie in cookies) {
  //     cookiesString += '${cookie.name}=${cookie.value};';
  //   }
  //   print(cookiesString);
  // }

  launchURL(String url) async {
    if (await canLaunchUrlString(url)) {
      await launchUrlString(url, mode: LaunchMode.externalApplication);
    } else {
      throw 'Could not launch $url';
    }
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: CustomAppBar(title: ""),

        body: Center(
          child: Container(
            width: Dimensions.WEB_MAX_WIDTH,
            child: Stack(
              children: [
                InAppWebView(
                  key: webViewKey,
                  //initialUrlRequest: URLRequest(url: Uri.parse("https://proof.ovh.net")),
                  initialUrlRequest: URLRequest(url: Uri.parse("https://webxr.run/m6YYnYwR1NeMX")),
                 // initialUrlRequest: URLRequest(url: Uri.parse("https://files.unity3d.com/jonas/AngryBots/")),
                 //  initialUrlRequest: URLRequest(url: Uri.parse("https://get.webgl.org/")),
                  //initialUrlRequest: URLRequest(url: Uri.parse('http://122.176.28.104/primersion/local/userdetails/testdownload.php')),

                  initialOptions: InAppWebViewGroupOptions(
                    crossPlatform: InAppWebViewOptions(
                        useOnDownloadStart: true,
                        mediaPlaybackRequiresUserGesture: true,
                        allowFileAccessFromFileURLs: true,
                        allowUniversalAccessFromFileURLs: true,
                        cacheEnabled: true,
                        clearCache: true,
                        javaScriptCanOpenWindowsAutomatically: true,
                        javaScriptEnabled: true,
                        supportZoom: true,
                        useShouldOverrideUrlLoading: true,
                        useOnLoadResource: true
                    ),
                    ios: IOSInAppWebViewOptions(
                      enableViewportScale: true,
                      allowsLinkPreview: true,
                      allowsAirPlayForMediaPlayback: true,
                      automaticallyAdjustsScrollIndicatorInsets: true,
                      sharedCookiesEnabled: true,

                    ),
                    android: AndroidInAppWebViewOptions(
                      databaseEnabled: true,

                      blockNetworkImage: false,

                      networkAvailable: true,
                      thirdPartyCookiesEnabled: true,
                      allowContentAccess: true,
                      allowFileAccess: true,
                      domStorageEnabled: true,
                      saveFormData: true,
                      hardwareAcceleration: true,
                      clearSessionCache: true,
                      blockNetworkLoads: false,
                      loadsImagesAutomatically: true,
                      //useHybridComposition: true,
                    ),
                  ),

                  onWebViewCreated: (controller) {webViewController = controller;},
                  onLoadStart: (controller, url) => {},
                  onLoadStop: (controller, url)  {
                    // if (url != null) {
                    //   await updateCookies(url);
                    // }
                    //
                    // setState(() {
                    //   this.url = url.toString();
                    //   urlController.text = this.url;
                    // });
                  },


                  androidOnPermissionRequest: (InAppWebViewController controller, String origin, List<String> resources) async {
                    return PermissionRequestResponse(resources: resources, action: PermissionRequestResponseAction.GRANT);
                  },

                  onDownloadStartRequest:(controller, url) async {
                    showCustomSnackBar(url.url.toString(),isError: false);


                    print("onDownloadStart result =  $url ");
                    print("onDownloadStart url =  ${url.url.toString()} ");


                  }
                  ,
                ),
              ],
            ),
          ),
        ));
  }
}
